/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
void build_structures()
{
 unsigned int max_changes=1;
 max_changes+=num_0D_states + num_1D_states;

 fprintf(struct_def,"real *KKK;\n");
 fprintf(struct_def,"real *_0D_globals;\n");

 fprintf(struct_def,"real **CCC;\n");
 fprintf(struct_def,"real **_1D_globals;\n");
 fprintf(struct_def,"real ***DDD;\n");
 fprintf(struct_def,"real ***_2D_globals;\n");

 fprintf(struct_def,"real ***_2D_state_ptr;\n");
 fprintf(struct_def,"real ***_2D_globals_ptr;\n");
 fprintf(struct_def,"real ***_2D_float_derivs_ptr;\n");
 fprintf(struct_def,"real ***_2D_glob_derivs_ptr;\n");

 fflush(struct_def);
/* 2D_Real-derives */
if (num_2D_float_derivs>0)
 for (j=0;j<num_2D_float_derivs;j++)
   {
   cp=strpos(_2D_float_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_2D_float_derivs[j],0,cp));
   if ( strpos(_2D_float_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"real ***%sDDD;\n",helpstr);
    fprintf(struct_h,"extern real ***%sDDD;\n",helpstr);
    for (i=0;i<num_2D_states;i++)
      {
      fprintf(struct_def,"real **%s%s;\n",helpstr,_2D_state_names[i]);
      fprintf(struct_h,"extern real **%s%s;\n",helpstr,_2D_state_names[i]);
      }
     }
   if ( strpos(_2D_float_derivs[j],"base") > 0)
    {
    max_changes+=num_2D_states;
    fprintf(struct_def,"real *%sDDD;\n",helpstr);
    fprintf(struct_h,"extern real *%sDDD;\n",helpstr);
    for (i=0;i<num_2D_states;i++)
      {
      fprintf(struct_def,"real *%s%s;\n",helpstr,_2D_state_names[i]);
      fprintf(struct_h,"extern real *%s%s;\n",helpstr,_2D_state_names[i]);
      }
     }
   }
 fflush(struct_def);

/* 1D_Real-derives */
if (num_1D_float_derivs>0)
 for (j=0;j<num_1D_float_derivs;j++)
   {
   cp=strpos(_1D_float_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_1D_float_derivs[j],0,cp));
   if ( strpos(_1D_float_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"real **%sCCC;\n",helpstr);
    fprintf(struct_h,"extern real **%sCCC;\n",helpstr);
    for (i=0;i<num_1D_states;i++)
      {
      fprintf(struct_def,"real *%s%s;\n",helpstr,_1D_state_names[i]);
      fprintf(struct_h,"extern real *%s%s;\n",helpstr,_1D_state_names[i]);
      }
     }

   if ( strpos(_1D_float_derivs[j],"base") > 0)
    {
    max_changes+=num_1D_states;
    fprintf(struct_def,"real *%sCCC;\n",helpstr);
    fprintf(struct_h,"extern real *%sCCC;\n",helpstr);
    for (i=0;i<num_1D_states;i++)
      {
      fprintf(struct_def,"real *%s%s;\n",helpstr,_1D_state_names[i]);
      fprintf(struct_h,"extern real *%s%s;\n",helpstr,_1D_state_names[i]);
      }
     }
   }
 fflush(struct_def);

/* 0D_Real-derives */
if (num_0D_float_derivs>0)
for (j=0;j<num_0D_float_derivs;j++)
   {
   cp=strpos(_0D_float_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_0D_float_derivs[j],0,cp));
   if ( strpos(_0D_float_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"real *%sKKK;\n",helpstr);
    fprintf(struct_h,"extern real *%sKKK;\n",helpstr);
    for (i=0;i<num_0D_states;i++)
      {
      fprintf(struct_def,"real %s%s;\n",helpstr,_0D_state_names[i]);
      fprintf(struct_h,"extern real %s%s;\n",helpstr,_0D_state_names[i]);
      }
     }

/*   if ( strpos(_0D_float_derivs[j],"base") > 0)
    {
    max_changes+=num_0D_states;
    fprintf(struct_def,"real %sKKK;\n",helpstr);
    fprintf(struct_h,"extern real %sKKK;\n",helpstr);
    for (i=0;i<num_0D_states;i++)
      {
      fprintf(struct_def,"real %s%s;\n",helpstr,_0D_state_names[i]);
      fprintf(struct_h,"extern real %s%s;\n",helpstr,_0D_state_names[i]);
      }
     }*/
   }
 fflush(struct_def);

/* 2D-Int-Derives */
  for (j=0;j<num_2D_int_derivs;j++)
   {
    fprintf(struct_def,"/*j=%d, name=%s;*/\n",j,_2D_int_derivs[j]);

   cp=strpos(_2D_int_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_2D_int_derivs[j],0,cp));
   if ( strpos(_2D_int_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"int ***%sDDD;\n",helpstr);
    fprintf(struct_h,"extern int ***%sDDD;\n",helpstr);
    for (i=0;i<num_2D_states;i++)
      {
      fprintf(struct_def,"int **%s%s;\n",helpstr,_2D_state_names[i]);
      fprintf(struct_h,"extern int **%s%s;\n",helpstr,_2D_state_names[i]);
      }
     }

   if ( strpos(_2D_int_derivs[j],"base") > 0)
    {
    max_changes+=num_2D_states;
    fprintf(struct_def,"int *%sDDD;\n",helpstr);
    fprintf(struct_h,"extern int *%sDDD;\n",helpstr);
    for (i=0;i<num_2D_states;i++)
      {
      fprintf(struct_def,"int *%s%s;\n",helpstr,_2D_state_names[i]);
      fprintf(struct_h,"extern int *%s%s;\n",helpstr,_2D_state_names[i]);
      }
     }
   }
 fflush(struct_def);

/* 1D Int-Derives */
  for (j=0;j<num_1D_int_derivs;j++)
   {
   cp=strpos(_1D_int_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_1D_int_derivs[j],0,cp));
   if ( strpos(_1D_int_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"int **%sCCC;\n",helpstr);
    fprintf(struct_h,"extern int **%sCCC;\n",helpstr);
    for (i=0;i<num_1D_states;i++)
      {
      fprintf(struct_def,"int *%s%s;\n",helpstr,_1D_state_names[i]);
      fprintf(struct_h,"extern int *%s%s;\n",helpstr,_1D_state_names[i]);
      }
     }

   if ( strpos(_1D_int_derivs[j],"base") > 0)
    {
    max_changes+=num_1D_states;
    fprintf(struct_def,"int *%sCCC;\n",helpstr);
    fprintf(struct_h,"extern int *%sCCC;\n",helpstr);
    for (i=0;i<num_1D_states;i++)
      {
      fprintf(struct_def,"int *%s%s;\n",helpstr,_1D_state_names[i]);
      fprintf(struct_h,"extern int *%s%s;\n",helpstr,_1D_state_names[i]);
      }
     }
   }
 fflush(struct_def);

/* 0D Int-Derives */
/*  for (j=0;j<num_0D_int_derivs;j++)
   {
   cp=strpos(_0D_int_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_0D_int_derivs[j],0,cp));
   if ( strpos(_0D_int_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"int %sKKK;\n",helpstr);
    fprintf(struct_h,"extern int %sKKK;\n",helpstr);
    for (i=0;i<num_0D_states;i++)
      {
      fprintf(struct_def,"int %s%s;\n",helpstr,_0D_state_names[i]);
      fprintf(struct_h,"extern int %s%s;\n",helpstr,_0D_state_names[i]);
      }
     }

   if ( strpos(_0D_int_derivs[j],"base") > 0)
    {
    max_changes+=num_0D_states;
    fprintf(struct_def,"int %sKKK;\n",helpstr);
    fprintf(struct_h,"extern int %sKKK;\n",helpstr);
    for (i=0;i<num_0D_states;i++)
      {
      fprintf(struct_def,"int %s%s;\n",helpstr,_0D_state_names[i]);
      fprintf(struct_h,"extern int %s%s;\n",helpstr,_0D_state_names[i]);
      }
     }
   }*/
 fflush(struct_def);

/* 2D-Glob-Derives */
 for (j=0;j<num_2D_glob_derivs;j++)
   {
   cp=strpos(_2D_glob_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_2D_glob_derivs[j],0,cp));
   if ( strpos(_2D_glob_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"real ***%sDDD;\n",helpstr);
    fprintf(struct_h,"extern real ***%sDDD;\n",helpstr);
    for (i=0;i<num_2D_states;i++)
      {
      fprintf(struct_def,"real **%s%s;\n",helpstr,_2D_state_names[i]);
      fprintf(struct_h,"extern real **%s%s;\n",helpstr,_2D_state_names[i]);
      }
     }
   }
 fflush(struct_def);

/* 1D_Glob-Derives */
 for (j=0;j<num_1D_glob_derivs;j++)
   {
   cp=strpos(_1D_glob_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_1D_glob_derivs[j],0,cp));
   if ( strpos(_1D_glob_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"real **%sCCC;\n",helpstr);
    fprintf(struct_h,"extern real **%sCCC;\n",helpstr);
    for (i=0;i<num_1D_states;i++)
      {
      fprintf(struct_def,"real *%s%s;\n",helpstr,_1D_state_names[i]);
      fprintf(struct_h,"extern real *%s%s;\n",helpstr,_1D_state_names[i]);
      }
     }
   }
 fflush(struct_def);

/* 0D_Glob-Derives */
/* for (j=0;j<num_0D_glob_derivs;j++)
   {
   cp=strpos(_0D_glob_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_0D_glob_derivs[j],0,cp));
   if ( strpos(_0D_glob_derivs[j],"variable") > 0)
    {
    fprintf(struct_def,"real *%sCCC;\n",helpstr);
    fprintf(struct_h,"extern real *%sCCC;\n",helpstr);
    for (i=0;i<num_0D_states;i++)
      {
      fprintf(struct_def,"real %s%s;\n",helpstr,_0D_state_names[i]);
      fprintf(struct_h,"extern real %s%s;\n",helpstr,_0D_state_names[i]);
      }
     }
   }*/
 fflush(struct_def);

 max_changes+=num_vars -num_0D_int_derivs -num_0D_float_derivs -num_0D_globals;
 max_changes+=-num_1D_int_derivs -num_1D_float_derivs -num_1D_globals;
 max_changes+= -num_2D_int_derivs -num_2D_float_derivs -num_2D_globals;

 fprintf(struct_def,"/* 0D-Types */\n");
 fprintf(struct_def,"long_name *_0D_state_names;\n");
 fprintf(struct_def,"long_name *_0D_global_names;\n");
 fprintf(struct_def,"long_name *_0D_float_derivs;\n");
 fprintf(struct_def,"long_name *_0D_glob_derivs;\n");
 fprintf(struct_def,"long_name *_0D_int_derivs;\n");

 fprintf(struct_def,"const int num_0D_states=%d; \n",num_0D_states);
 fprintf(struct_def,"const int num_0D_float_derivs=%d; \n",num_0D_float_derivs*num_0D_states);
 fprintf(struct_def,"const int num_0D_glob_derivs=%d; \n",num_0D_glob_derivs*num_0D_states);
 fprintf(struct_def,"const int num_0D_globals=%d; \n",num_0D_globals);
 fprintf(struct_def,"const int num_0D_int_derivs=%d; \n",num_0D_int_derivs*num_0D_states);
 
 fprintf(struct_def,"/* 1D-Types */\n");
 fprintf(struct_def,"long_name *_1D_state_names;\n");
 fprintf(struct_def,"long_name *_1D_float_derivs;\n");
 fprintf(struct_def,"long_name *_1D_glob_derivs;\n");
 fprintf(struct_def,"long_name *_1D_global_names;\n");
 fprintf(struct_def,"long_name *_1D_int_derivs;\n");
 fprintf(struct_def,"int *i_com;\n");
/* for backward compatibilty */
 fprintf(struct_def,"long_name *state_names;\n");
 fprintf(struct_def,"long_name *float_derivs;\n");
 fprintf(struct_def,"long_name *glob_derivs;\n");
 fprintf(struct_def,"long_name *global_names;\n");
 fprintf(struct_def,"long_name *int_derivs;\n");

 fprintf(struct_def,"const int num_1D_states=%d; \n",num_1D_states);
 fprintf(struct_def,"const int num_1D_float_derivs=%d; \n",num_1D_float_derivs*num_1D_states);
 fprintf(struct_def,"const int num_1D_glob_derivs=%d; \n",num_1D_glob_derivs*num_1D_states);
 fprintf(struct_def,"const int num_1D_globals=%d; \n",num_1D_globals);
 fprintf(struct_def,"const int num_1D_int_derivs=%d; \n",num_1D_int_derivs*num_1D_states);
/* for backward compatibilty */
 fprintf(struct_def,"const int num_states=%d; \n",num_1D_states);
 fprintf(struct_def,"const int num_float_derivs=%d; \n",num_1D_float_derivs*num_1D_states);
 fprintf(struct_def,"const int num_glob_derivs=%d; \n",num_1D_glob_derivs*num_1D_states);
 fprintf(struct_def,"const int num_globals=%d; \n",num_1D_globals);
 fprintf(struct_def,"const int num_int_derivs=%d; \n",num_1D_int_derivs*num_1D_states);

 fprintf(struct_def,"/* 2D-Types */\n");
 fprintf(struct_def,"long_name *_2D_state_names;\n");
 fprintf(struct_def,"long_name *_2D_float_derivs;\n");
 fprintf(struct_def,"long_name *_2D_glob_derivs;\n");
 fprintf(struct_def,"long_name *_2D_global_names;\n");
 fprintf(struct_def,"long_name *_2D_int_derivs;\n");

 fprintf(struct_def,"const int num_2D_states=%d; \n",num_2D_states);
 fprintf(struct_def,"const int num_2D_float_derivs=%d; \n",num_2D_float_derivs*num_2D_states);
 fprintf(struct_def,"const int num_2D_glob_derivs=%d; \n",num_2D_glob_derivs*num_2D_states);
 fprintf(struct_def,"const int num_2D_globals=%d; \n",num_2D_globals);
 fprintf(struct_def,"const int num_2D_int_derivs=%d; \n",num_2D_int_derivs*num_2D_states);

 fprintf(struct_def,"/*locally used variables*/\n");
 fprintf(struct_def,"int __i,__j,__k; \n");

 fprintf(struct_def,"const int n_comp=%d; \n",boxes);
 fprintf(struct_def,"int l_comp=0;\n");
 fprintf(struct_def,"const int g_comp1=%d; \n",boxes1);
 fprintf(struct_def,"const int g_comp2=%d; \n",boxes2);

 fprintf(struct_h,"extern const int n_comp; \n");
 fprintf(struct_h,"extern int l_comp; \n");
 fprintf(struct_h,"extern const int g_comp1; \n");
 fprintf(struct_h,"extern const int g_comp2; \n");
 fprintf(struct_h,"extern int *i_com; \n");

/* 0D-Typen */
 fprintf(struct_h,"extern long_name *_0D_state_names; \n");
 fprintf(struct_h,"extern long_name *_0D_global_names; \n");
 fprintf(struct_h,"extern long_name *_0D_float_derivs; \n");
 fprintf(struct_h,"extern long_name *_0D_glob_derivs; \n");
 fprintf(struct_h,"extern long_name *_0D_int_derivs; \n");
 fprintf(struct_h,"extern const int num_0D_states; \n");
 fprintf(struct_h,"extern const int num_0D_float_derivs; \n");
 fprintf(struct_h,"extern const int num_0D_glob_derivs; \n");
 fprintf(struct_h,"extern const int num_0D_globals; \n");
 fprintf(struct_h,"extern const int num_0D_int_derivs; \n");

/* 1D-Typen */
 fprintf(struct_h,"extern long_name *_1D_state_names; \n");
 fprintf(struct_h,"extern long_name *_1D_global_names; \n");
 fprintf(struct_h,"extern long_name *_1D_float_derivs; \n");
 fprintf(struct_h,"extern long_name *_1D_glob_derivs; \n");
 fprintf(struct_h,"extern long_name *_1D_int_derivs; \n");
 fprintf(struct_h,"extern const int num_1D_states; \n");
 fprintf(struct_h,"extern const int num_1D_float_derivs; \n");
 fprintf(struct_h,"extern const int num_1D_glob_derivs; \n");
 fprintf(struct_h,"extern const int num_1D_globals; \n");
 fprintf(struct_h,"extern const int num_1D_int_derivs; \n");
/* for backward compatibility */
 fprintf(struct_h,"extern long_name *state_names; \n");
 fprintf(struct_h,"extern long_name *global_names; \n");
 fprintf(struct_h,"extern long_name *float_derivs; \n");
 fprintf(struct_h,"extern long_name *glob_derivs; \n");
 fprintf(struct_h,"extern long_name *int_derivs; \n");
 fprintf(struct_h,"extern const int num_states; \n");
 fprintf(struct_h,"extern const int num_float_derivs; \n");
 fprintf(struct_h,"extern const int num_glob_derivs; \n");
 fprintf(struct_h,"extern const int num_globals; \n");
 fprintf(struct_h,"extern const int num_int_derivs; \n");
/* 2D-Typen */
 fprintf(struct_h,"extern long_name *_2D_state_names; \n");
 fprintf(struct_h,"extern long_name *_2D_global_names; \n");
 fprintf(struct_h,"extern long_name *_2D_float_derivs; \n");
 fprintf(struct_h,"extern long_name *_2D_glob_derivs; \n");
 fprintf(struct_h,"extern long_name *_2D_int_derivs; \n");
 fprintf(struct_h,"extern const int num_2D_states; \n");
 fprintf(struct_h,"extern const int num_2D_float_derivs; \n");
 fprintf(struct_h,"extern const int num_2D_glob_derivs; \n");
 fprintf(struct_h,"extern const int num_2D_globals; \n");
 fprintf(struct_h,"extern const int num_2D_int_derivs; \n");
 fprintf(struct_h,"extern real ***_2D_state_ptr; \n");
 fprintf(struct_h,"extern long_name ***_2D_globals_ptr; \n");
 fprintf(struct_h,"extern real ***_2D_float_derivs_ptr; \n");
 fprintf(struct_h,"extern real ****_2D_glob_derivs_ptr; \n");

 fprintf(struct_def,"void %s(string sensitivity) {\n",function_name);
 fprintf(struct_def,"int find_changes(char*,long_name*,real**,int*,int);\n");
 fprintf(struct_def,"long_name *change_name;\n");
 fprintf(struct_def,"int *change_type;\n");
 fprintf(struct_def,"real **change_ptr;\n");
 fprintf(struct_def,"change_name=(long_name*) malloc(%d*sizeof(long_name)); \n",max_changes);
 fprintf(struct_def,"change_type=(int*) malloc(%d*sizeof(int)); \n",max_changes);
 fprintf(struct_def,"change_ptr=(real**) malloc(%d*sizeof(real*)); \n",max_changes);
/* 0D-Typen */
 fprintf(struct_def,"_0D_state_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_0D_states+1);
 fprintf(struct_def,"_0D_global_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_0D_globals+1);
 fprintf(struct_def,"_0D_glob_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_0D_glob_derivs*num_0D_states+1);
 fprintf(struct_def,"_0D_float_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_0D_float_derivs*num_0D_states+1);
 fprintf(struct_def,"_0D_int_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_0D_int_derivs*num_0D_states+1);

 fprintf(struct_def,"KKK=vector(1,%d);\n",num_0D_states);

/* 1D-Typen */
 fprintf(struct_def,"_1D_state_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_states+1);
 fprintf(struct_def,"_1D_global_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_globals+1);
 fprintf(struct_def,"_1D_glob_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_glob_derivs*num_1D_states+1);
 fprintf(struct_def,"_1D_float_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_float_derivs*num_1D_states+1);
 fprintf(struct_def,"_1D_int_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_int_derivs*num_1D_states+1);
/* for backward compatibility */
 fprintf(struct_def,"state_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_states+1);
 fprintf(struct_def,"global_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_globals+1);
 fprintf(struct_def,"glob_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_glob_derivs*num_1D_states+1);
 fprintf(struct_def,"float_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_float_derivs*num_1D_states+1);
 fprintf(struct_def,"int_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_1D_int_derivs*num_1D_states+1);

 fprintf(struct_def,"CCC=matrix(1,%d,1,%d);\n",num_1D_states,boxes);

/* 2D-Typen */
if (num_2D_states>0) {
 fprintf(struct_def,"_2D_state_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_2D_states+1);
 fprintf(struct_def,"_2D_state_ptr=(real ***) malloc(%d*sizeof(real**)); \n",num_2D_states+1);
}
if (num_2D_globals>0) {
 fprintf(struct_def,"_2D_global_names=(long_name *) malloc(%d*sizeof(long_name)); \n",num_2D_globals+1);
 fprintf(struct_def,"_2D_globals_ptr=(real ***) malloc(%d*sizeof(real**)); \n",num_2D_globals+1);
}
if (num_2D_glob_derivs>0) {
 fprintf(struct_def,"_2D_glob_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_2D_glob_derivs*num_2D_states+1);
 fprintf(struct_def,"_2D_glob_derivs_ptr=(real ***) malloc(%d*sizeof(real**)); \n",num_2D_glob_derivs+1);
}
if (num_2D_float_derivs>0 && num_2D_states>0) {
 fprintf(struct_def,"_2D_float_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_2D_float_derivs*num_2D_states+1);
 fprintf(struct_def,"_2D_float_derivs_ptr=(real ***) malloc(%d*sizeof(real**)); \n",num_2D_float_derivs*num_2D_states+1);
}
if (num_2D_int_derivs>0)
 fprintf(struct_def,"_2D_int_derivs=(long_name *) malloc(%d*sizeof(long_name)); \n",num_2D_int_derivs*num_2D_states+1);

if (num_2D_states>0)
 fprintf(struct_def,"DDD=r3tensor(1,%d,1,%d,1,%d);\n",num_2D_states,boxes1,boxes2);

if (num_2D_globals>0)
 fprintf(struct_def,"_2D_globals=r3tensor(1,%d,1,%d,1,%d);\n",num_2D_globals,boxes1,boxes2);

/*##############################################*/ 
 fprintf(struct_h,"extern real *KKK;\n");
 fprintf(struct_h,"extern real *_0D_globals;\n");
 fprintf(struct_h,"extern real **CCC;\n");
 fprintf(struct_h,"extern real **_1D_globals;\n");
 fprintf(struct_h,"extern real ***DDD;\n");
 fprintf(struct_h,"extern real ***_2D_globals;\n");
 
/* Globals anlegen und definiert mit 0 füllen */
if (num_0D_globals > 0)
 {
  fprintf(struct_def,"_0D_globals=vector(1,%d);\n",num_1D_globals);
  fprintf(struct_def,"/* Zeroising globals */\n");
  fprintf(struct_def,"for (__i=1;__i<=%d;__i++)\n",num_1D_globals); 
  fprintf(struct_def,"         _0D_globals[__i]=0.0;\n");
 }
if (num_1D_globals > 0)
 {
  fprintf(struct_def,"_1D_globals=matrix(1,%d,1,%d);\n",num_1D_globals,boxes);
  fprintf(struct_def,"/* Zeroising globals */\n");
  fprintf(struct_def,"for (__i=1;__i<=%d;__i++)\n",num_1D_globals); 
  fprintf(struct_def,"   for (__j=1;__j<=%d;__j++)\n",boxes);
  fprintf(struct_def,"         _1D_globals[__i][__j]=0.0;\n");
 }
if (num_2D_globals > 0)
 {
  fprintf(struct_def,"_2D_globals=r3tensor(1,%d,1,%d,1,%d);\n",num_2D_globals,boxes1,boxes2);
  fprintf(struct_def,"/* Zeroising _2D_globals */\n");
  fprintf(struct_def,"for (__i=1;__i<=%d;__i++)\n",num_2D_globals); 
  fprintf(struct_def,"   for (__j=1;__j<=%d;__j++)\n",boxes1);
  fprintf(struct_def,"      for (__k=1;__k<=%d;__k++)\n",boxes2);
  fprintf(struct_def,"         _2D_globals[__i][__j][__k]=0.0;\n");
 }

/* 0D derived Variablen anlegen  */
for (j=0;j<num_0D_glob_derivs;j++)
   {
   cp=strpos(_0D_glob_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_0D_glob_derivs[j],0,cp));
   if ( strpos(_0D_float_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sKKK=vector(1,%d);\n",helpstr,num_0D_states);
   }

 for (j=0;j<num_0D_float_derivs;j++)
   {
   cp=strpos(_0D_float_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_0D_float_derivs[j],0,cp));
   if ( strpos(_0D_float_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sKKK=vector(1,%d);\n",helpstr,num_0D_states);
   if ( strpos(_0D_float_derivs[j],"base") > 0)
      fprintf(struct_def,"%sKKK=vector(1,%d);\n",helpstr,num_0D_states);

   }

 for (j=0;j<num_0D_int_derivs;j++)
   {
   cp=strpos(_0D_int_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_0D_int_derivs[j],0,cp));
   if ( strpos(_0D_int_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sKKK=ivector(1,%d);\n",helpstr,num_0D_states);
   if ( strpos(_0D_int_derivs[j],"base") > 0)
      fprintf(struct_def,"%sKKK=ivector(1,%d);\n",helpstr,num_0D_states);

   }


/* 1D derived Variablen anlegen  */
for (j=0;j<num_1D_glob_derivs;j++)
   {
   cp=strpos(_1D_glob_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_1D_glob_derivs[j],0,cp));
   if ( strpos(_1D_float_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sCCC=matrix(1,%d,1,%d);\n",helpstr,num_1D_states,boxes);
   }

 for (j=0;j<num_1D_float_derivs;j++)
   {
   cp=strpos(_1D_float_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_1D_float_derivs[j],0,cp));
   if ( strpos(_1D_float_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sCCC=matrix(1,%d,1,%d);\n",helpstr,num_1D_states,boxes);
   if ( strpos(_1D_float_derivs[j],"base") > 0)
      fprintf(struct_def,"%sCCC=vector(1,%d);\n",helpstr,num_1D_states);

   }

 for (j=0;j<num_1D_int_derivs;j++)
   {
   cp=strpos(_1D_int_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_1D_int_derivs[j],0,cp));
   if ( strpos(_1D_int_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sCCC=imatrix(1,%d,1,%d);\n",helpstr,num_1D_states,boxes);
   if ( strpos(_1D_int_derivs[j],"base") > 0)
      fprintf(struct_def,"%sCCC=ivector(1,%d);\n",helpstr,num_1D_states);

   }

/* 2D derived Variablen anlegen  */
for (j=0;j<num_2D_glob_derivs;j++)
   {
   cp=strpos(_2D_glob_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_2D_glob_derivs[j],0,cp));
   if ( strpos(_2D_float_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sDDD=r3tensor(1,%d,1,%d,1,%d);\n",helpstr,num_2D_states,boxes1,boxes2);
   }

if (num_2D_states>0)
{
for (j=0;j<num_2D_float_derivs;j++)
   {
   cp=strpos(_2D_float_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_2D_float_derivs[j],0,cp));
   if ( strpos(_2D_float_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sDDD=r3tensor(1,%d,1,%d,1,%d);\n",helpstr,num_2D_states,boxes1,boxes2);
   if ( strpos(_2D_float_derivs[j],"base") > 0)
      fprintf(struct_def,"%sDDD=vector(1,%d);\n",helpstr,num_2D_states);
   }

 for (j=0;j<num_2D_int_derivs;j++)
   {
   cp=strpos(_2D_int_derivs[j],"+");
   sprintf(helpstr,"%s",strmid(_2D_int_derivs[j],0,cp));
   if ( strpos(_2D_int_derivs[j],"variable") > 0)
      fprintf(struct_def,"%sDDD=i3tensor(1,%d,1,%d,1,%d);\n",helpstr,num_2D_states,boxes1,boxes2);
   if ( strpos(_2D_int_derivs[j],"base") > 0)
      fprintf(struct_def,"%sDDD=ivector(1,%d);\n",helpstr,num_2D_states);
   }
}
 fprintf(struct_def,"i_com=ivector(1,%d); \n",boxes);
 fprintf(struct_def,"for (l_comp=1;l_comp<=n_comp;l_comp++) i_com[l_comp]=l_comp; \n");

/*
** Array mit den Namen der State-Variablen erzeugen
** und die Pointer fuer Zugriffe ueber Namen erzeugen
*/
/* 0D-States */
 for (i=1;i<=num_0D_states;i++)
   {
   fprintf(struct_def,"sprintf(_0D_state_names[%d],\"%s\",\"%s\");\n",i,"%s",_0D_state_names[i-1]);
/*    fprintf(struct_def,"%s= (real*) &KKK[%d];\n",_0D_state_names[i-1],i); */
   }
/* 1D-States */
 for (i=1;i<=num_1D_states;i++)
   {
   fprintf(struct_def,"sprintf(_1D_state_names[%d],\"%s\",\"%s\");",i,"%s",_1D_state_names[i-1]);
/* for backward compatibility */
   fprintf(struct_def,"sprintf(state_names[%d],\"%s\",\"%s\");",i,"%s",_1D_state_names[i-1]);
   fprintf(struct_def,"%s= (real*) &CCC[%d][0];\n",_1D_state_names[i-1],i);
   }
/* 2D-States */
 for (i=1;i<=num_2D_states;i++)
   {
   fprintf(struct_def,"sprintf(_2D_state_names[%d],\"%s\",\"%s\");",i,"%s",_2D_state_names[i-1]);
   fprintf(struct_def,"%s= r3tensor_submatrix(DDD,%d,1,%d,1,%d);",_2D_state_names[i-1],i,boxes1,boxes2);
   fprintf(struct_def,"_2D_state_ptr[%d]=%s;\n",i,_2D_state_names[i-1]);
   }

/*
** Array mit den Namen der abgeleiteten float Variablen erzeugen
** und die Pointer fuer Zugriffe ueber Namen erzeugen
*/
/* 0D derived Variablen */
for (j=0;j<num_0D_float_derivs;j++)
  {
  cp=strpos(_0D_float_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_0D_float_derivs[j],0,cp));
  if ( strpos(_0D_float_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_0D_states;i++)
     {
     fprintf(struct_def,"sprintf(_0D_float_derivs[%d],\"%s\",\"%s%s\");\n",j*num_0D_states+i,"%s",helpstr,_0D_state_names[i-1]);
/*      fprintf(struct_def,"%s%s=(real*) &%sKKK[%d];\n",helpstr,_0D_state_names[i-1],helpstr,i); */
     }
    }

  if ( strpos(_0D_float_derivs[j],"base") > 0)
   {
   for (i=1;i<=num_0D_states;i++)
     {
     fprintf(struct_def,"%s%s=(real) &%sKKK[%d];\n",helpstr,_0D_state_names[i-1],helpstr,i);
     }
    }
   }

/* 1D derived Variablen */
for (j=0;j<num_1D_float_derivs;j++)
  {
  cp=strpos(_1D_float_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_1D_float_derivs[j],0,cp));
  if ( strpos(_1D_float_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_1D_states;i++)
     {
/* for backward compatibility */
     fprintf(struct_def,"sprintf(_1D_float_derivs[%d],\"%s\",\"%s%s\");\n",j*num_1D_states+i,"%s",helpstr,_1D_state_names[i-1]);
     fprintf(struct_def,"sprintf(float_derivs[%d],\"%s\",\"%s%s\");\n",j*num_1D_states+i,"%s",helpstr,_1D_state_names[i-1]);
     fprintf(struct_def,"%s%s=(real*) &%sCCC[%d][0];\n",helpstr,_1D_state_names[i-1],helpstr,i);
     }
    }

  if ( strpos(_1D_float_derivs[j],"base") > 0)
   {
   for (i=1;i<=num_1D_states;i++)
     {
     fprintf(struct_def,"%s%s=(real*) &%sCCC[%d];\n",helpstr,_1D_state_names[i-1],helpstr,i);
     }
    }
   }

/* 2D derived Variablen */
for (j=0;j<num_2D_float_derivs;j++)
  {
  cp=strpos(_2D_float_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_2D_float_derivs[j],0,cp));
  if ( strpos(_2D_float_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_2D_states;i++)
     {
     fprintf(struct_def,"sprintf(_2D_float_derivs[%d],\"%s\",\"%s%s\");\n",j*num_2D_states+i,"%s",helpstr,_2D_state_names[i-1]);
     fprintf(struct_def,"%s%s=r3tensor_submatrix(%sDDD,%d,1,%d,1,%d);\n",helpstr,_2D_state_names[i-1],helpstr,i,boxes1,boxes2);
     fprintf(struct_def,"_2D_float_derivs_ptr[%d]=%s%s;\n",j*num_2D_states+i,helpstr,_2D_state_names[i-1]);
     }
    }

  if ( strpos(_2D_float_derivs[j],"base") > 0)
   {
   for (i=1;i<=num_2D_states;i++)
     {
     fprintf(struct_def,"%s%s=(real*) &%sDDD[%d];\n",helpstr,_2D_state_names[i-1],helpstr,i);
     }
    }
   }
/*
** Array mit den Namen der abgeleiteten int Variablen erzeugen
** und die Pointer fuer Zugriffe ueber Namen erzeugen
*/
/* 0D derived Variablen */
for (j=0;j<num_0D_int_derivs;j++)
  {
  cp=strpos(_0D_int_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_0D_int_derivs[j],0,cp));
  if ( strpos(_0D_int_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_0D_states;i++)
     {

     fprintf(struct_def,"sprintf(_0D_int_derivs[%d],\"%s\",\"%s%s\"),",j*num_0D_states+i,"%s",helpstr,_0D_state_names[i-1]);
     fprintf(struct_def,"%s%s=(int) &%sKKK[%d];\n",helpstr,_0D_state_names[i-1],helpstr,i);
     }
    }

  if ( strpos(_0D_int_derivs[j],"base") > 0)
   {
   for (i=1;i<=num_0D_states;i++)
     {

     fprintf(struct_def,"%s%s=(int) &%sKKK[%d];\n",helpstr,_0D_state_names[i-1],helpstr,i);
     }
    }
   }

/* 1D derived Variablen */
for (j=0;j<num_1D_int_derivs;j++)
  {
  cp=strpos(_1D_int_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_1D_int_derivs[j],0,cp));
  if ( strpos(_1D_int_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_1D_states;i++)
     {
/* for backward compatibility */
     fprintf(struct_def,"sprintf(_1D_int_derivs[%d],\"%s\",\"%s%s\"),",j*num_1D_states+i,"%s",helpstr,_1D_state_names[i-1]);
     fprintf(struct_def,"sprintf(int_derivs[%d],\"%s\",\"%s%s\"),",j*num_1D_states+i,"%s",helpstr,_1D_state_names[i-1]);
     fprintf(struct_def,"%s%s=(int*) &%sCCC[%d][0];\n",helpstr,_1D_state_names[i-1],helpstr,i);
     }
    }

  if ( strpos(_1D_int_derivs[j],"base") > 0)
   {
   for (i=1;i<=num_1D_states;i++)
     {

     fprintf(struct_def,"%s%s=(int*) &%sCCC[%d];\n",helpstr,_1D_state_names[i-1],helpstr,i);
     }
    }
   }

/* 2D derived Variablen */
for (j=0;j<num_2D_int_derivs;j++)
  {
  cp=strpos(_2D_int_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_2D_int_derivs[j],0,cp));
  if ( strpos(_2D_int_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_2D_states;i++)
     {

     fprintf(struct_def,"sprintf(_2D_int_derivs[%d],\"%s\",\"%s%s\");",j*num_2D_states+i,"%s",helpstr,_2D_state_names[i-1]);
     fprintf(struct_def,"%s%s=i3tensor_submatrix(%sDDD,%d,1,%d,1,%d);\n",helpstr,_2D_state_names[i-1],helpstr,i,boxes1,boxes2);
     }
    }

  if ( strpos(_2D_int_derivs[j],"base") > 0)
   {
   for (i=1;i<=num_2D_states;i++)
     {

     fprintf(struct_def,"%s%s=(int*) &%sDDD[%d];\n",helpstr,_2D_state_names[i-1],helpstr,i);
     }
    }
   }

/*
** Array mit den Namen der abgeleiteten global Variablen erzeugen
** und die Pointer fuer Zugriffe ueber Namen erzeugen
*/
/* 0D fluxes */
for (j=0;j<num_0D_glob_derivs;j++)
  {
  cp=strpos(_0D_glob_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_0D_glob_derivs[j],0,cp));
  if ( strpos(_0D_glob_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_0D_states;i++)
     {
     fprintf(struct_def,"sprintf(_0D_glob_derivs[%d],\"%s\",\"%s%s\"),",j*num_0D_states+i,"%s",helpstr,_0D_state_names[i-1]);
     fprintf(struct_def,"%s%s=(real*) &%sKKK[%d][0];\n",helpstr,_0D_state_names[i-1],helpstr,i);
     }
   }
   }

/* 1D fluxes */
for (j=0;j<num_1D_glob_derivs;j++)
  {
  cp=strpos(_1D_glob_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_1D_glob_derivs[j],0,cp));
  if ( strpos(_1D_glob_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_1D_states;i++)
     {
/* for backward compatibility */
     fprintf(struct_def,"sprintf(_1D_glob_derivs[%d],\"%s\",\"%s%s\"),",j*num_1D_states+i,"%s",helpstr,_1D_state_names[i-1]);
     fprintf(struct_def,"sprintf(glob_derivs[%d],\"%s\",\"%s%s\"),",j*num_1D_states+i,"%s",helpstr,_1D_state_names[i-1]);
     fprintf(struct_def,"%s%s=(real*) &%sCCC[%d][0];\n",helpstr,_1D_state_names[i-1],helpstr,i);
     }
   }
   }

/* 2D fluxes */
for (j=0;j<num_2D_glob_derivs;j++)
  {
  cp=strpos(_2D_glob_derivs[j],"+");
  sprintf(helpstr,"%s",strmid(_2D_glob_derivs[j],0,cp));
  if ( strpos(_2D_glob_derivs[j],"variable") > 0)
   {
   for (i=1;i<=num_2D_states;i++)
     {
     fprintf(struct_def,"sprintf(_2D_glob_derivs[%d],\"%s\",\"%s%s\");",j*num_2D_states+i,"%s",helpstr,_2D_state_names[i-1]);
     fprintf(struct_def,"%s%s=r3tensor_submatrix(%sDDD,%d,1,%d,1,%d);",helpstr,_2D_state_names[i-1],helpstr,i,boxes1,boxes2);
     fprintf(struct_def,"_2D_glob_derivs_ptr[%d]=%s%s;\n",i,helpstr,_2D_state_names[i-1]);
     }
   }
   }

/*
** Array mit den Namen der globalen Variablen erzeugen
** und die Pointer fuer Zugriffe ueber Namen erzeugen
*/
 /* 0D-Globals */
for (i=1;i<=num_0D_globals;i++)
   {
   fprintf(struct_def,"sprintf(_0D_global_names[%d],\"%s\",\"%s\"),",i,"%s",_0D_global_names[i-1]);
/*   fprintf(struct_def,"%s= (real*) &_0D_globals[%d];\n",_0D_global_names[i-1],i);*/
   }
/* 1D-Globals */
 for (i=1;i<=num_1D_globals;i++)
   {
/* for backward compatibility */
   fprintf(struct_def,"sprintf(_1D_global_names[%d],\"%s\",\"%s\"),",i,"%s",_1D_global_names[i-1]);
   fprintf(struct_def,"sprintf(global_names[%d],\"%s\",\"%s\"),",i,"%s",_1D_global_names[i-1]);
   fprintf(struct_def,"%s= (real*) &_1D_globals[%d][0];\n",_1D_global_names[i-1],i);
   }
/* 2D-Globals */
 for (i=1;i<=num_2D_globals;i++)
   {
   fprintf(struct_def,"sprintf(_2D_global_names[%d],\"%s\",\"%s\");",i,"%s",_2D_global_names[i-1]);
   fprintf(struct_def,"%s= r3tensor_submatrix(_2D_globals,%d,1,%d,1,%d);",_2D_global_names[i-1],i,boxes1,boxes2);
   fprintf(struct_def,"_2D_globals_ptr[%d]=%s;\n",i,_2D_global_names[i-1]);
  }

}

 
