/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#define __PREPARE__
#include "prep_types.h"
#include "prepare.h"

int check_keyword (int* type,const char input[])
{
      int keyword=0;
      int my_type=-99; 
      if (strpos(input,change_id)      >= 0) my_type=0;

      if (strpos(input,_0D_state_id)          >= 0) my_type=_0D_STATE;
      if (strpos(input,_0D_glob_id)           >= 0) my_type=_0D_GLOBAL;

      if (strpos(input,state_id)          >= 0) my_type=STATE;
      if (strpos(input,glob_id)           >= 0) my_type=GLOBAL;
      if (strpos(input,int_param_id)  >= 0) my_type=INT_PARAM;
      if (strpos(input,flt_param_id)   >= 0) my_type=REAL_PARAM;
      if (strpos(input,flt_const)          >= 0) my_type=REAL_CONST;
      if (strpos(input,int_const)         >= 0) my_type=INT_CONST;
      if (strpos(input,derives)            >= 0) my_type=DERIVES;
      if (strpos(input,features)           >= 0) my_type=FEATURES;
      if (strpos(input,fluxes)              >= 0) my_type=FLUXES;

      if (strpos(input,_2D_state_id)          >= 0) my_type=_2D_STATE;
      if (strpos(input,_2D_glob_id)           >= 0) my_type=_2D_GLOBAL;
      if (strpos(input,_2D_int_param_id)  >= 0) my_type=_2D_INT_PARAM;
      if (strpos(input,_2D_flt_param_id)   >= 0) my_type=_2D_REAL_PARAM;
/*      if (strpos(input,_2D_flt_const)          >= 0) my_type=_2D_REAL_CONST;
      if (strpos(input,_2D_int_const)         >= 0) my_type=_2D_INT_CONST;*/
      if (strpos(input,_2D_derives)            >= 0) my_type=_2D_DERIVES;
      if (strpos(input,_2D_features)           >= 0) my_type=_2D_FEATURES;
      if (strpos(input,_2D_fluxes)              >= 0) my_type=_2D_FLUXES;

      if (strpos(input,_3D_state_id)          >= 0) my_type=_3D_STATE;
      if (strpos(input,_3D_glob_id)           >= 0) my_type=_3D_GLOBAL;
      if (strpos(input,_3D_int_param_id)  >= 0) my_type=_3D_INT_PARAM;
      if (strpos(input,_3D_flt_param_id)   >= 0) my_type=_3D_REAL_PARAM;
/*      if (strpos(input,_3D_flt_const)          >= 0) my_type=_3D_REAL_CONST;
      if (strpos(input,_3D_int_const)         >= 0) my_type=_3D_INT_CONST;*/
      if (strpos(input,_3D_derives)            >= 0) my_type=_3D_DERIVES;
      if (strpos(input,_3D_features)           >= 0) my_type=_3D_FEATURES;
      if (strpos(input,_3D_fluxes)              >= 0) my_type=_3D_FLUXES;

      if (my_type > -99)
      {
              *type=my_type;
              keyword=1;
      }
return(keyword);
}

float my_sscan(char* input)
{
float value;
sscanf(input,"%g",&value);
return(value);
}

long int strpos(char* instring,char* search)
 {
 char *pos;
 pos=strstr(instring,search);
 if (pos != NULL)
    pos=(char*) (pos-instring);
 else
    pos=(char*) -1;

 return (long int) pos;
 }


char *strmid(char* instring,int start, int len)
 {
 static char output[2*_BUFSIZE_];
 char *s_pos;

 if (start != -1)
    {
    s_pos=(char*) instring+start;
    strncpy(output,s_pos,len);
    output[len]=(char) 0;
    }
  return(output);
  }

/*float fmax( float a, float b)
{ 
return (a>b) ? a : b; 
}

float fmin( float a, float b)
{ 
return ((a<b) ? a : b); 
}*/

float fsign(float a)
{
return ( (a!=0.)?(a/fabs(a)):0.0);
}

void strtrim(char* instring)
 {
 char output[2*_BUFSIZE_];
 int i,j=0;
 for (i=0;i<(int)strlen(instring);i++) if (!isspace(instring[i])) output[j++]=instring[i];
 output[j]=(char) 0;
 sprintf(instring,"%s",output);
 }

char *strclip(char* string)
 {
 static char output[401];
 char *s_pos;
 strncpy(output,string,(size_t) 400);
 output[400]=(char) 0;
 return(output);
  }

int numchar(char* string,char* search)
{
unsigned int i;
int cnt=0;

  for (i=0;i<strlen(string);i++)
  {
     if ( strpos(strmid(string,i,1),search) >= 0) cnt++;
  }
return(cnt);
}

void expand(char* instring)
 {
 char output[2*_BUFSIZE_] ;
 char helpstr[_BUFSIZE_];
 char value[_BUFSIZE_];
 int num,counter,i,j,bp1;
 num=numchar(instring,",");
/*  printf("Input:%s\n",instring); */

sprintf(output,"");
  for (i=0;i<=num;i++)
  {
      bp1=strpos(instring,",");
      if (bp1 > 0)
      {
          sprintf(helpstr,"%s",strmid(instring,0,bp1));
          sprintf(instring,"%s",strmid(instring,bp1+1,strlen(instring)-bp1));
      }
      else
      {
          sprintf(helpstr,"%s",instring);
      }
      
      bp1 = strpos(helpstr,"*");
      if (bp1>0)
      {
          counter=atoi(strmid(helpstr,0,bp1));
	  sprintf(value,"%s",strmid(helpstr,bp1+1,strlen(helpstr)-bp1-1));
          for (j=1;j<counter;j++) sprintf(output,"%s%s,",output,value);
	  strcat(output,value);
      }
      else
      {
         strcat(output,helpstr);
      }
      if (i<num) strcat(output,",");
  }
      	  
 sprintf(instring,"%s",output);
/*  printf("Output:%s\n",instring); */
 }

int get_entries(int* entries,string input,string _svar)
{
int b1,b2,num_entries;
string helpstr;
 sprintf(helpstr,"%s",input);

 b1=numchar(helpstr,"[");
 b2=numchar(helpstr,"]");
 
if (b1!=b2 || b1 <1 || b2 <1 || b1 > MAX_DIMENSION || b2 > MAX_DIMENSION)
 {
    printf("ERROR: Wrong number of brackets or indices in %s\n",helpstr);
    exit (1);
 }

 num_entries=b1;

 b1=strpos(helpstr, "[");
 b2=strpos(helpstr, "]");
 sprintf(_svar,"%s",strmid(helpstr,0,b1));
 entries[0]=atoi(strmid(helpstr,b1+1,b2-b1-1));
 
 if (num_entries > 1)
 {
    sprintf(helpstr,"%s",strmid(helpstr,b2+1,strlen(helpstr)-b2));
    b1=strpos(helpstr, "[");
    b2=strpos(helpstr, "]");
    entries[1]=atoi(strmid(helpstr,b1+1,b2-b1-1));
    if (num_entries > 2)
   {
       sprintf(helpstr,"%s",strmid(helpstr,b2+1,strlen(helpstr)-b2));
       b1=strpos(helpstr, "[");
       b2=strpos(helpstr, "]");
       entries[2]=atoi(strmid(helpstr,b1+1,b2-b1-1));
   }
}

return(num_entries);
}

