/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include <math.h>
#include "struct.h"
extern void model(void);
extern void reset_derivs(void);

void fixstep(real x1,real h)
{
long i,j,k;

  reset_derivs();
  
  sim_time=x1;
  delt=h;
  steps_of_int_to_go=0;
  model();
  if (num_0D_states>0)
  {
     make_global_0D_states();
     make_global_0D_rates();
     for (i=1; i<=num_0D_states; i++)  KKK[i] += h*SKKK[i];
     make_local_0D_states();
     make_local_0D_rates();
  }

  for (i=1; i<=num_1D_states; i++)
    {
    for (j=1; j<=l_comp; j++)
        {
        CCC[i][i_com[j]]+=h*SCCC[i][i_com[j]];
	}
    }

  for (i=1; i<=num_2D_states; i++)
    {
    for (j=1; j<=g_comp1; j++)
        {
        for (k=1;k<=g_comp2;k++)  DDD[i][j][k]+=h*SDDD[i][j][k];
	}
    }
 
}
