/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include <stdio.h>
#include "constructs.h"
#include "types.h"

extern void control_main(int,real,real,real*,real*);
extern real *dym,*dyt,*yt;

void rk23(real *y, real *dydx, long n, real x, real h, real *yout2,real *yout3)
{
        long i;
        real xh,hh,h6,h_2;

	hh=h*0.5;
	h6=h/6.0;
        h_2=2.0*h;
	xh=x+hh;
	for (i=1;i<=n;i++) yt[i]=y[i]+hh*dydx[i];
	control_main(2,xh,hh,yt,dyt);

	for (i=1;i<=n;i++) yt[i]=y[i]-h*dydx[i]+h_2*dyt[i];
	control_main(1,x+h,h,yt,dym);

	for (i=1;i<=n;i++)
          {
	  yout2[i]=y[i]+h*dyt[i];
	  yout3[i]=y[i]+h6*(dydx[i]+4.0*dyt[i]+dym[i]);
          }

}
