/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include <stdio.h>
#include "constructs.h"
#include "types.h"

extern void control_main(int,real,real,real*,real*);
extern real *dym,*dyt,*yt;

void rk45(int call,real y[],real dydx[],long n,real x,real h,real yout[])
{
	long i;
	real xh,hh,h6;

	hh=h*0.5;
	h6=h/6.0;
	xh=x+hh;
	for (i=1;i<=n;i++) yt[i]=y[i]+hh*dydx[i];
	control_main(call ,xh,hh,yt,dyt);

	for (i=1;i<=n;i++) yt[i]=y[i]+hh*dyt[i];
	control_main(call-1,xh,hh,yt,dym);
	for (i=1;i<=n;i++) {
		yt[i]=y[i]+h*dym[i];
		dym[i] += dyt[i];
	}
	control_main(call-2,x+h,h,yt,dyt);
	for (i=1;i<=n;i++)
		yout[i]=y[i]+h6*(dydx[i]+dyt[i]+2.0*dym[i]);
}
