/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "constructs.h"
#include "prepare.h"
#include "struct.h"

void read_2D_start_values(char *filename )
{
FILE *startfile;
char *input_buf,*line_buf,*list,*change_buf,*message,komma[2];
int bp1,bp2,i,k,cp,found=0,index1, index2;
name test_name,left_part;

sprintf(komma,"%s",",");

line_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
message=(char *) malloc(_BUFSIZE_*sizeof(char));
change_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
input_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
list=(char *) malloc(_BUFSIZE_*sizeof(char));

startfile=fopen(filename,"rb");

/* Suche nach "%change" */
while ( (k=fgetc(startfile)) != EOF )
  {
  ungetc(k,startfile);
  input_buf=fgets(input_buf,100,startfile);
  if (strpos(input_buf,_keyword_) == 0)
     if (strpos(input_buf,change_id)>=0) 
      {
      found=1;
      break;
      }
  }
/* "%change" gefunden, eine Zeile einlesen */

if (found==0) goto stop_label;

printf("Reading 2D start values.....\n");

while ( (k=fgetc(startfile)) != EOF )
 {
 ungetc(k,startfile);
 input_buf=fgets(input_buf,100,startfile);

 while(strlen(input_buf)<3) 
  {
  k=fgetc(startfile);
  if (k == EOF ) goto stop_label;
   
  ungetc(k,startfile);
  input_buf=fgets(input_buf,100,startfile);
  }

 sprintf(line_buf,"%s",input_buf);

/* Eingelesene Zeile analysieren */

 while(strlen(line_buf)>0)
  {
  cp=strpos(line_buf,";");

  sprintf(change_buf,"%s",strmid(line_buf,0,cp+1));
  sprintf(line_buf,"%s",strmid(line_buf,cp+1,(int) strlen(line_buf)-cp-1));

/* Fuehrende white-space abschneiden */
  while(strpos(change_buf," ")==0) sprintf(change_buf,"%s",strmid(change_buf,1,(int) strlen(change_buf)-1));
     if (strlen(change_buf)==0) break;
     if (strpos(change_buf,"=") < 0) break;

/* Nach passender Variablen suchen */
       cp = strpos(change_buf,"[");
       if (cp<0) break;
       sprintf(left_part,"%s",strmid(change_buf,0,cp));

     for (i=1; i<=num_2D_states; i++)
       {
       sprintf(test_name,"%s",_2D_state_names[i]);
       if (strpos(left_part,test_name) == 0 &&
           strlen(test_name)==strlen(left_part))
        {
/* Prüfen, ob zwei Indizes angegeben sind */
                bp1=numchar(change_buf,"[");
                bp2=numchar(change_buf,"]");
                if (bp1 != 2 || bp2 != 2) 
                {
                        printf("Error in line containing: %s\n",change_buf);
                        std_error("Brackets missing or wrong number of indices");
                }
                bp1=strpos(change_buf,"[");
                bp2=strpos(change_buf,"]");
                cp=strpos(change_buf,";");
                sprintf(list,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
                sscanf(list,"%d",&index1);
                sprintf(list,"%s",strmid(change_buf,bp2+1,cp-bp2));
                bp1=strpos(list,"[");
                bp2=strpos(list,"]");
                sprintf(list,"%s",strmid(list,bp1+1,bp2-bp1-1));
                sscanf(list,"%d",&index2);
                /* nur ein Wert fuer eine indizierte Variable */
        
                bp1=strpos(change_buf,"=");
                bp2=strpos(change_buf,";");
        
	        sprintf(list,"%s",strmid(change_buf,bp1+1,bp2-bp1-1));
                if (numchar(list,"{")>0 || numchar(list,"}")>0) 
                {
                    printf("Error in line containing '%s'\n",change_buf);
                    printf("Start values must not be given as lists nor by ranges of indices!\n");
                    std_error("Only single grid cells may be defined for start values!");
                }
                /* Listenelemente abarbeiten und Werte auf die Pointer schreiben */
                printf("%s\n",change_buf);
                fflush(stdout);
                DDD[i][index1][index2]=my_sscan(list);
        } /* Ende von if(strpos(change_buf,list)==0) */
       } /* Ende von for (i=0;i<number;i++) */
  } /* Ende von while strlen(line_buf)>0 */
 } /* Ende von while != EOF */

stop_label:
fclose(startfile);
free(line_buf);
free(input_buf);
free(change_buf);
free(list);
free(message);
}


   
