/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#if defined(__verbose__)
      printf("storestart=%d storestep=%ld  time=%g end_of_int=%g\n",storestart,step,(float) sim_time,end_of_int-outdelt);
      fflush(stdout);
#endif

/* Speichern vorbereiten: 1. ueber store_ptr extrahieren und 2. auf float casten und store_vector schreiben */
     make_store(store_ptr,store_vector,num_stores);

if (netcdf_output==1) {
     netcdf_start[0] = netcdf_store;
     netcdf_start_2D[0]= netcdf_store;
     netcdf_stop[0] = 1;
     value=(float) (end_of_int-outdelt);
     status=ncvarput(ncid,time_id,netcdf_start,netcdf_stop,(void *)&value);
     if (status != NC_NOERR) {
         sprintf(report,"netCDF-Error when storing actual time\n");
         std_error(report);
     }
     for (ui=0;ui<num_stores;ui++)
     {
        status=ncvarput(ncid,var_id[ui],netcdf_start,netcdf_stop,(void *)&store_vector[ui]);
        if (status != NC_NOERR) {
          sprintf(report,"netCDF-Error when storing variable %s\n",store_names[ui]);
          std_error(report);
       }     
     }

     for (ui=0;ui<num_2D_stores;ui++)
     {
/* Zeilenweise (Y-Koordinate = j) (X-Koordinate = i) schreiben */

#if defined (NC_FLIP)
         for (i=0;i<g_comp1;i++)
         {
             for (j=0;j<g_comp2;j++)
             {
                store_2D_vector[j+i*g_comp2] = store_2D_ptr[ui][g_comp1-i][j+1];
             }
         }
#else
         for (j=0;j<g_comp2;j++)
         {
             for (i=0;i<g_comp1;i++)
             {
                store_2D_vector[i+j*g_comp1] = store_2D_ptr[ui][i+1][j+1];
             }
         }
#endif
         status=nc_put_vara_float(ncid,_2D_var_id[ui],netcdf_start_2D,netcdf_count_2D,store_2D_vector);
         if (status != NC_NOERR) {
            sprintf(report,"netCDF-Error when storing variable %s at time %f\n",stores_2D[ui], (double) sim_time);
            std_error(report);
        }     
     }
     netcdf_start[0] = 0;
     value = (float) netcdf_store;
     status=ncvarput(ncid,proceed_id,netcdf_start,netcdf_stop,(void *)&value);
     if (status != NC_NOERR) {
        sprintf(report,"netCDF-Error when storing actual step iformation\n");
        std_error(report);
     }

     netcdf_store++;
} else {
	if (strcmp(resulttype,"outa") == 0) 
    {
		fprintf(outfile,"%6.2f,",(float) sim_time); 
        for (ui=0;ui<num_stores-1;ui++) fprintf(outfile,"%f,",(float) store_vector[ui]);
        fprintf(outfile,"%f\n",(float) store_vector[num_stores-1]);
	} else {
     fwrite(&store_vector[0],sizeof(float),(size_t) num_stores,outfile);
     fflush(outfile);
	}
}

/* abgeleitete global-Variablen loeschen */
     reset_glob_derivs();
     if (recalc_globals==1) reset_derivs();
     next_store+=store_step; 
