/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
/*
last change:
2005/08/07 FH: 
- filtering of empty lines in the .csv file
- check for consistency of number of data point for all columns
*/
#include "stdinc.h"
#include "types.h"
#include "constructs.h"
#define _BUFSIZE_ 655360

int read_csv(string input_file,int column,real *value_vec)
{
 char *input, *helpstr, *helpname, *dummy __attribute__((unused));
 int timnum=0;
 long int cp,len;
 unsigned int nvars=0;
 unsigned int count;

  float *dat;
  real argu;

  FILE *in_file;

  input=   (char *) malloc( _BUFSIZE_*sizeof(char));
  helpstr=(char *) malloc( _BUFSIZE_*sizeof(char));
  helpname=(char *) malloc( _BUFSIZE_*sizeof(char));

/* Check the csv file and get the ranges */

  in_file=fopen(input_file,"r");

  if (in_file == NULL)
  {
     std_error("READ_CSV: Error when opening data file for reading");
  }

/*  Erste Zeile mit dem Header lesen*/
  if ( fgets(input,_BUFSIZE_,in_file) == 0)
  {
     std_error("READ_CSV: Error no data in input file");
  }

/* Feststellen, wieviele Zeilen die Datei enthaelt */
  timnum = 1;
  while ( fgets(input,_BUFSIZE_,in_file) != 0) 
  {  
      strtrim(input);
      if (strlen(input) >0 ) timnum++;
  }
  rewind(in_file);

/* Bei Aufruf mit column==0 wird nur die Anzahl der Zeilen zurueckgegeben   */
  if (column > 0)
  {
/* Header analysieren    */

/* Eine Variable muss es ja geben und am Ende der Zeile steht _kein_ Komma    */
   nvars = 1;
   dummy= fgets(input,_BUFSIZE_,in_file);
   sprintf(helpstr,"%s",input);
   strtrim(helpstr);
   cp = strpos(helpstr,",");
   while ( cp >= 0)
   {
      len= strlen(helpstr);
      sprintf(helpname,"%s",strmid(helpstr,0,cp));

      strtrim(helpname);
      sprintf(helpstr,"%s",strmid(helpstr,cp+1,len-cp));
      cp = strpos(helpstr,",");
      nvars++;

     }

/* Vektor zur Aufnahme der Daten fuer einen Zeitschritt anlegen */
  dat = malloc(nvars*sizeof(float));

/* Zaehler wieder zuruecksetzen */
  timnum = 1;
/* Daten einlesen */
  while ( fgets(input,_BUFSIZE_,in_file) != 0)
  {
    strtrim(input);
    if (strlen(input)>0)
    {
    sprintf(helpstr,"%s %s",input,","); /*Eine Variable gibt es mindestens*/
    strtrim(helpstr);
    cp = strpos(helpstr,",");
    count = 0;
         while ( cp >= 0)
         {
         len= strlen(helpstr);
         sprintf(helpname,"%s",strmid(helpstr,0,cp));
         strtrim(helpname);
         sprintf(helpstr,"%s",strmid(helpstr,cp+1,len-cp));
         cp = strpos(helpstr,",");
            if (strlen(helpname)>0) 
            {
            argu = my_sscan(helpname);
            dat[count] = argu;
            count ++;
            }
         }

     value_vec[timnum]=dat[column-1];
     if (count==nvars) timnum++;
     }   
   }
  }
  free(input);
  free(helpstr);
  free(helpname);
  fclose(in_file);
  return(timnum-1);
}
