# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cem_run {overrule {back {}}  } {

global simname outputtype command DOS pwd resultdir GUI allbuts
set parfile .parfile.tmp
cd $pwd

set BG -bg

#put "DOS=$DOS"

if {$DOS==0 || $DOS==2} {
  if [file exists $parfile] {remove $parfile}
} else {
  copy cemos.par cemos.c
  eval exec gcc -E cemos.c > $parfile
  remove cemos.c
}

if {[string match "/*" $simname]==1} {
   set logname $simname.log
   } else {
   if [info exist resultdir] {
      set logname $resultdir/$simname.log
      } else {
      set logname $simname.log
      }
   }

if ![file isdirectory $pwd/.tmp] {
   file mkdir $pwd/.tmp
}

if {![file exists $pwd/cemos-model]} {
   put "No executable cemos-model found!"
   put "Please (re-)compile the model."
   activate $allbuts
   activate_start
} else {
  if { $back == $BG } {

   put "Starting background simulation with logging to $logname......."
   set cmd "exec nohup ./cemos-model --overrule=$overrule --outputfile=$simname --resulttype=$outputtype > $logname & "
   catch $cmd STATUS
   put $STATUS

  } else {

    if {$GUI==1} {
        put "Starting simulation"
        if {$DOS==0 || $DOS==2} {
              set command "./cemos-model  --overrule=$overrule --outputfile=$simname --resulttype=$outputtype | tee $logname"
        } else {
              set command "./cemos-model.exe  --overrule=$overrule --outputfile=$simname --resulttype=$outputtype"
        }
        Run
        put "Starting simulation to $simname.$outputtype"
     } else {

        #exec ./cemos-model $overrule $simname  $outputtype
        set cmd "exec  ./cemos-model  --overrule=$overrule --outputfile=$simname --resulttype=$outputtype   | tee $logname  "
        catch $cmd STATUS
        global cevlog
        set cevlog $STATUS

        puts "Starting simulation to $simname.$outputtype"

     }
  }
}
}
