# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc clean {dir} {

global env pwd cemoshome

cd $pwd
file delete cemos-model
file delete cemos.a
file delete .runtime.par

set model_path $pwd/$dir
puts $model_path
cd $model_path

put "Removing archives...."
set help [myls [pwd] *.a]; remove $help

put "Removing object-files...."
set help [myls [pwd] *.o]; remove $help

put "Removing header-files...."
set help [myls [pwd] *.h]; remove $help

put "Removing core-files...."
set help [myls [pwd] core]; remove $help

put "Removing %-files...."
set help [myls [pwd] *.*%]; remove $help

put "Removing CEMoS-files...."
set help [myls [pwd] read__*]; remove $help
set help [myls [pwd] *_prae.*]; remove $help



set list "reset_derivs.c struct_def.c struct_model.c"

cd $cemoshome/frame
set help_list [myls [pwd] *.c]
set list [concat $list $help_list]

cd $cemoshome/util
set help_list [myls [pwd] *.c]
set list [concat $list $help_list]

cd $cemoshome/driver
set help_list [myls [pwd] *.c]
set list [concat $list $help_list]

cd $model_path

foreach file $list {
  set help [myls [pwd] $file]; remove $help
}

if {[file exists install.tcl]} { 
   set dummy [catch {exec ./install.tcl u} result]   
   #put $result
}
cd $pwd

put "Ready !"
put ""

}
