# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cup {mpath gflags cflags lflags} {

global DOS env cemoshome pwd netCDFHOME plat arch

set NULL {}

set pattern "-g"
set dbf 0

foreach item $gflags {
      if [string match $pattern $item] {set dbf 1}
}
if {$plat=="arm64"} {
	set CC "gcc -target arm64-apple-macos"
} else {
	set CC gcc
}	
	
set model_dir {}
set STATUS {}

set model_dir  $mpath
set model_path $pwd

if {$model_dir != $NULL} {
   set model_path $pwd/$model_dir
}

set MODEL $model_path
if ![file isdirectory $MODEL] {
   put "Error no such directory: $MODEL"
   exit
}

set INCLUDE_PATH "-I$cemoshome/include -I$model_path -I$netCDFHOME/include"
put "Updating cemos-model with $MODEL"

cd $model_path
set list [mylst .]
set list1 {}
set check 0
#puts $list
foreach file $list {
   set check [string match cemos.a $file]
   if {$check == 0 } {
     lappend list1 $file 
   } else {break}

}
set list {}
put $list1

foreach file $list1 {
  put "$CC $gflags $cflags -c $file"
  set cmd "eval exec $CC $gflags $cflags $INCLUDE_PATH -c $file"
  catch $cmd STATUS
  if {$STATUS != {} } {
     put $STATUS
    # put "ERROR: Correct the C-code in this file!"
     put "*****************************************************************"
     #exit
  }
}
  
set list [myls [pwd] *.o]


if {$list!= {} } {
   put "Updating the archive cemos.a ...."

   foreach file $list {
        set cmd "eval exec ar rv cemos.a $file"
        catch $cmd STATUS
        put $STATUS
   }

   exec touch cemos.a   
   exec ranlib cemos.a


   put "Creating new executable...."

   if {$DOS==0 || $DOS==2} {
      set cmd "eval exec $CC -o cemos-model cemos.a -L$netCDFHOME/lib -lm $lflags"
      catch $cmd STATUS
      put $STATUS
      put "Removing object-files...."
      remove $list
      move cemos-model $pwd
   } else {
      set cmd "eval exec $CC -o cemos-model.exe cemos.a -L$netCDFHOME/lib -lm -lnetcdf"
      catch $cmd STATUS
      put $STATUS
      put "Removing object-files...."
      remove $list
      move cemos-model.exe $pwd
   }
  
   put "Model is ready........."
} else {
   put "Model is up to date...."
}

cd $pwd
}
