# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cev_gui_make_par_window {} {
global cevvar cevvalfrom cevval cevvalto cevvalrem cevvarnum cevcom cevstart
global c2 lfont allbuts alltext
global active
global parwin 
global undockedpars 
global remheight

set enable_series 0
set series 0
set series_but ""
if ![info exist undockedpars] {set undockedpars 0}
if [info exist cevvarnum] {

    if {$undockedpars==0} {
	     set pars .topp.pars
	     set labelwidth 50
    	 set max_frameheight 200
		 set max_framewidth 2000
		 set meaningwidth 60
		} else {
		  set pars .pars
          toplevel $pars
          wm title $pars {Parameters}
          wm geometry $pars "+800+100"
          wm protocol $pars WM_DELETE_WINDOW {set undockedpars 0; destroy .pars; cev_gui_make_par_window}
	      set labelwidth 40
		  set meaningwidth 100
		  set max_frameheight [expr int(0.8*[winfo screenheight .])]
    	  set max_framewidth [expr int(0.5*[winfo screenwidth .])]
        } 
 # in mainfraime     
	  #set framewidth [winfo reqwidth .]
      set parwin $pars.parwin
      if {![winfo exist $parwin]} {
	      labelframe $parwin -bg $c2 -text "Optimisation Parameters" 
	      pack $parwin -side left -fill both -expand true -padx {0 10}
	
	      frame $parwin.fx
	      grid $parwin.fx -column 0 -row 0 -sticky ne -padx {50 0}
	      
	      label $parwin.fx.ax -anchor w -text " " -bg $c2 -width 5 -font $lfont
	      label $parwin.fx.lx -anchor w -text "Parameter" -bg $c2 -width 15 -font $lfont
	      label $parwin.fx.lex -anchor w  -text "from" -bg $c2 -width 15 -font $lfont
	      label $parwin.fx.le1x -anchor w  -text "Value (absbest)" -bg $c2 -width 25 -font $lfont
	      label $parwin.fx.le2x -anchor w  -text "to" -bg $c2 -width 15 -font $lfont
	      label $parwin.fx.le3x -anchor w  -text "start" -bg $c2 -width 15 -font $lfont
	      label $parwin.fx.llx -anchor w  -text "Meaning" -bg $c2 -width $labelwidth  -font $lfont
	      if {$undockedpars==0} {
			button $parwin.fx.undock -text "undock" -anchor e -bg $c2 -width 6 -font $lfont \
									 -command {destroy $parwin;set undockedpars 1;cev_gui_make_par_window} 
	      }
	      pack $parwin.fx.ax $parwin.fx.lx -side left
	      pack $parwin.fx.lex $parwin.fx.le1x $parwin.fx.le2x -side left
	      pack $parwin.fx.le3x $parwin.fx.llx -side left -fill x 
  	      if {$undockedpars==0} {
				pack $parwin.fx.undock -side right
				lappend $parwin.fx.undock
		  }
	      lappend alltext $parwin.fx.ax $parwin.fx.lx
	      lappend alltext $parwin.fx.lex $parwin.fx.le1x $parwin.fx.le2x
	      lappend alltext $parwin.fx.le3x $parwin.fx.llx $parwin.fx.undock
	
	      scrolledframe  $parwin.c -xscroll [list $parwin.hscroll set]  -yscroll [list $parwin.vscroll set] 
	      scrollbar $parwin.vscroll -command [list $parwin.c yview]
	      scrollbar $parwin.hscroll -command [list $parwin.c xview] -orient horizontal
	      
	      grid $parwin.c -row 1 -column 0 -sticky news
	      grid $parwin.vscroll -row 1 -column 1 -sticky ns
	      grid $parwin.hscroll -row 2 -column 0 -sticky ew
		  grid rowconfigure $parwin 0 -weight 1
	      grid columnconfigure $parwin 0 -weight 1      
	  }      
          
      if {[winfo exist $parwin.c.scrolled.out]} {destroy $parwin.c.scrolled.out}
      frame $parwin.c.scrolled.out -bg $c2
      pack $parwin.c.scrolled.out 
            
      for {set pc 0} {$pc<=$cevvarnum} {incr pc} {
                frame $parwin.c.scrolled.out.f$pc -bg $c2
                pack $parwin.c.scrolled.out.f$pc
                        
                checkbutton $parwin.c.scrolled.out.f$pc.a$pc -variable active($pc) -width 5 -bg $c2    
                label $parwin.c.scrolled.out.f$pc.l$pc -width 15  -anchor w -text $cevvar($pc) -bg $c2 -font $lfont -relief sunken          
                entry $parwin.c.scrolled.out.f$pc.e$pc -width 15  -textvariable cevvalfrom($pc) -bg $c2 -font $lfont -relief sunken
                entry $parwin.c.scrolled.out.f$pc.ew$pc -width 25 -textvariable cevval($pc) -bg $c2 -font $lfont -relief sunken
                entry $parwin.c.scrolled.out.f$pc.ex$pc -width 15 -textvariable cevvalto($pc) -bg $c2 -font $lfont -relief sunken
                entry $parwin.c.scrolled.out.f$pc.ey$pc -width 15 -textvariable cevstart($pc) -bg $c2 -font $lfont -relief sunken
                label $parwin.c.scrolled.out.f$pc.ll$pc -width $meaningwidth -anchor w  -text $cevcom($pc) -bg $c2 -font $lfont -relief sunken

                pack $parwin.c.scrolled.out.f$pc.a$pc -side left -padx {5 5}      
                pack $parwin.c.scrolled.out.f$pc.a$pc $parwin.c.scrolled.out.f$pc.l$pc -side left 
                pack $parwin.c.scrolled.out.f$pc.e$pc  -side left
                pack $parwin.c.scrolled.out.f$pc.ew$pc $parwin.c.scrolled.out.f$pc.ex$pc  -side left
                pack $parwin.c.scrolled.out.f$pc.ey$pc  $parwin.c.scrolled.out.f$pc.ll$pc -side left     

                lappend allbuts $parwin.c.scrolled.out.f$pc.a$pc  
                lappend alltext $parwin.c.scrolled.out.f$pc.a$pc  
                lappend alltext $parwin.c.scrolled.out.f$pc.a$pc $parwin.c.scrolled.out.f$pc.l$pc
                lappend alltext $parwin.c.scrolled.out.f$pc.e$pc
                lappend alltext $parwin.c.scrolled.out.f$pc.ew$pc $parwin.c.scrolled.out.f$pc.ex$pc
                lappend alltext $parwin.c.scrolled.out.f$pc.ey$pc  $parwin.c.scrolled.out.f$pc.ll$pc  
      }     
 
      set pc [expr $cevvarnum -1]

      if {$undockedpars==1} {update} 

      set req_frameheight [expr $pc * [winfo reqheight $parwin.c.scrolled.out.f$pc.e$pc] + 2*[winfo reqheight $parwin.fx.ax]]
      set req_framewidth [expr [winfo reqheight $parwin.c.scrolled.out]]
      
      set frameheight [min $max_frameheight $req_frameheight]
      set framewidth [min $max_framewidth $req_framewidth] 
   	  
	  if {$req_frameheight<$max_frameheight} {
			grid forget $parwin.vscroll
	  }
	  if {$req_framewidth<$max_framewidth} {
			grid forget $parwin.hscroll
	  }
	  $parwin.c configure -height $frameheight 
      if {$undockedpars==1} {$parwin.c configure -width $framewidth} 
      if [info exist remheight] {
		  . configure -height $remheight
		  .topp configure -height [expr $remheight -1]
		  update
		  }
	  

} else {
      put "No parameters given"
}
}




