# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cev_gui_make_window {} {
global home cemhome pwd
global cev_file cin_file cev_reference_file
global cev_resultdir 
global difftype oldtype outputtype
global smallchange bigchange
global maxruns maxsteps
global posval groupchange
global SA T Trem rate

#Globals fuer GUI version
global allbuts alltext startbuts firstread  log
global tkfbox_hidehidden
global lfont sfont
global geom xc
global command cancel rndstop undockedpars
global c2
global editor
global pady
global bestdist absbestdist distance counter changecounter broken

global remheight

set tkfbox_hidehidden 1
set bg 0
set debug 0
set geom +150+0
set cancel 0
set rndstop 1
set allbuts ""
set startbuts ""
set alltext ""
set undockedpars 0
if {[catch {package require Scrolledframe}]} \
{
   source [file join $cemhome/cevutil/scrolledframe.tcl]
   package require Scrolledframe
}
namespace import ::scrolledframe::scrolledframe


if ![file exist $home/.cev5defaults] {
	file copy $cemhome/cev5defaults $home/.cev5defaults
}

cev_readdefaults
cev_colorswitch
set defcol [option get . background {}]

#------------------------------
# Window manager configurations
#------------------------------
wm title . {Tiger Graphics CEvoS}
set screenheight [winfo screenheight .]
set windowheight [expr 0.8*$screenheight]

 if {$screenheight < 1100} {
      wm geometry . "+150+0"
} else {
      wm geometry . "+150+50"
}
set pady 0

wm iconbitmap . @$cemhome/icons/tinylogo.pic
wm iconmask . @$cemhome/icons/tinylogo.pic
wm protocol . WM_DELETE_WINDOW {.topp.misc.exit invoke}

# Create a frame for buttons and entry.
frame .topp -bg $c2 -padx 10
pack .topp -side top -fill x -fill y

# Initializing of the info window
#---------------------------------

# Model Control
#----------------------------
frame .topp.lab
grid .topp.lab -row 0 -column 0 -sticky news

label .topp.lab.1 -text "MODEL: " -font $lfont -anchor w -bg $c2
pack .topp.lab.1 -side left

label .topp.lab.2 -text "$pwd" -font $lfont -anchor w -bg $c2
pack .topp.lab.2 -side left
lappend alltext .topp.lab.1 .topp.lab.2

execlog

frame .topp.pars
grid  .topp.pars -row 3 -column 0  -sticky news

cev_gui_make_par_window

#------------------
#Distanzanzeige
#------------------
labelframe .topp.dist -text "Optimisation Status" -bg $c2 
grid  .topp.dist -row 4 -column 0 -sticky news

label .topp.dist.bestdist -text "Best distance" -anchor e -width 12 -bg $c2 -font $lfont
entry .topp.dist.bestdist_val -width 12 -textvariable bestdist -bg $c2  -font $lfont -relief sunken                
label .topp.dist.actdist -text "Actual Distance" -anchor e -width 14 -bg $c2  -font $lfont
entry .topp.dist.actdist_val -width 12  -textvariable distance -bg $c2  -font $lfont -relief sunken                
label .topp.dist.absbestdist -text "Absolute Best Distance" -anchor e -width 22 -bg $c2 -font $lfont
entry .topp.dist.absbestdist_val -width 12  -textvariable  absbestdist -bg $c2  -font $lfont -relief sunken                
label .topp.dist.runs -text "Runs" -anchor e -width 5 -bg $c2  -font $lfont
entry .topp.dist.runs_val -width 6  -textvariable counter -bg $c2  -font $lfont -relief sunken                
label .topp.dist.runs_last -text "Runs since last change" -anchor e -width 22 -bg $c2 -font $lfont
entry .topp.dist.runs_last_val -width 6  -textvariable changecounter -bg $c2  -font $lfont -relief sunken                
label .topp.dist.broken -text "Broken runs" -anchor e -width 12 -bg $c2  -font $lfont
entry .topp.dist.broken_val -width 6  -textvariable broken -bg $c2  -font $lfont -relief sunken                

pack .topp.dist.bestdist .topp.dist.bestdist_val -side left -pady $pady
pack .topp.dist.actdist .topp.dist.actdist_val -side left -pady $pady
pack .topp.dist.absbestdist .topp.dist.absbestdist_val -side left -pady $pady
pack .topp.dist.runs .topp.dist.runs_val -side left -pady $pady
pack .topp.dist.runs_last .topp.dist.runs_last_val -side left -pady $pady
pack .topp.dist.broken -side left -pady $pady
pack .topp.dist.broken_val -side left -pady $pady -padx {0 5}
            
lappend alltext .topp.dist.bestdist .topp.dist.bestdist_val
lappend alltext .topp.dist.actdist .topp.dist.actdist_val
lappend alltext .topp.dist.absbestdist .topp.dist.absbestdist_val
lappend alltext .topp.dist.runs .topp.dist.runs_val
lappend alltext .topp.dist.runs_last .topp.dist.runs_last_val 
lappend alltext .topp.dist.broken .topp.dist.broken_val 
            
#------------------
#Fileanzeige
#------------------
set filo .topp.filo
frame $filo -bg $c2
grid $filo -row 5 -column 0 -sticky news

set info $filo.info
labelframe $info -bg $c2 -text "File Control"
grid $info -row 0 -column 0 -sticky news

set info0 $info.info0
frame $info0 -bg $c2
grid $info0 -row 0 -column 0 -sticky news
button $info0.refs -text {Reference File} -width 13 -bg $c2 -font $lfont -command {cev_gui_select_ref} 
label $info0.ref -width 80 -text "$cev_reference_file" -font $lfont -bg $c2 -anchor w
pack  $info0.refs $info0.ref -side left -padx {10 0} -pady {5 0} 
lappend allbuts $info0.refs
lappend alltext $info0.ref $info0.refs

set info1 $info.info1
frame $info1 -bg $c2
grid $info1 -row 1 -column 0 -sticky news
button $info1.cevs -text {CEV File} -width 13 -bg $c2 -font $lfont -command {cev_gui_select_cev} 
label $info1.cev -width 80 -text "$cev_file" -font $lfont -anchor w
pack $info1.cevs $info1.cev -side left -padx {10 0}
lappend allbuts $info1.cevs
lappend alltext $info1.cev $info1.cevs

set info2 $info.info2
frame $info2 -bg $c2
grid $info2 -row 2 -column 0 -sticky news

button $info2.cins -text {CIN File} -width 13 -bg $c2 -font $lfont -command {cev_gui_select_cin}
label $info2.cin -width 80 -text "$cin_file" -font $lfont -anchor w

pack $info2.cins $info2.cin -side left -padx {10 0} -pady {0 5}
lappend allbuts $info2.cins
lappend alltext $info2.cin $info2.cins

set sim $filo.sim
labelframe $sim -bg $c2 -text "Run Control"
grid $sim -row 0 -column 1 -sticky ne -padx {20 0}
grid columnconfigure $filo 1 -weight 1
button $sim.stop -text {Stop Rnd} -font $lfont  -bg $c2 -state disabled -command {set rndstop 1;activate $allbuts;deactivate $stopbut;deactivate .topp.filo.sim.stop}
pack $sim.stop -side right -padx 10 -pady 5
lappend alltext $sim.stop

button $sim.rnd -text {Start Rnd} -font $lfont  -bg $c2 -command {set rndstop 0; deactivate $allbuts;
	activate "$stopbut .topp.filo.sim.stop .topp.misc.exit .topp.misc.movtk";
	cev_start_random
	}
pack $sim.rnd -side right -padx {10 0} -pady 5
lappend allbuts $sim.rnd 
lappend alltext $sim.rnd 
lappend startbuts $sim.rnd


#------------------------------
# Distanzmenu
#------------------------------
cev_gui_distmenu

checkbutton .topp.distance.group -text {Change all active} -bg $c2 -variable groupchange -font $lfont
pack .topp.distance.group  -side left -padx 5

checkbutton .topp.distance.pos -text {Positive Par} -bg $c2 -variable posval -font $lfont
pack .topp.distance.pos  -side left -padx 5 
lappend allbuts .topp.distance.group .topp.distance.pos
lappend alltext .topp.distance.group .topp.distance.pos
#------------------------------
# Optimierungsmenu
#------------------------------
#set pady 0

set opt .topp.distance.opt 
frame $opt -bg $c2
pack $opt -side right

label $opt.lab -text "Optimization:" -font $lfont
pack $opt.lab  -side left -padx 5 
lappend alltext $opt.lab

radiobutton $opt.ta -text {exact} -bg $c2 -variable SA -value 0 -font $lfont
pack $opt.ta  -side left -pady 5 -padx {0 5} 
radiobutton $opt.ex -text {threshold accepting} -bg $c2 -variable SA -value 1 -font $lfont
pack $opt.ex  -side left -pady 5 -padx {0 5} 
radiobutton $opt.sa -text {simulated annealing} -bg $c2 -variable SA -value 2 -font $lfont
pack $opt.sa  -side left -pady 5 -padx {0 5} 

lappend allbuts $opt.ta $opt.ex $opt.sa
lappend alltext $opt.ta $opt.ex $opt.sa
labelframe .topp.opt2 -bg $c2 -text "Optimization Parameters" 
grid .topp.opt2 -row 9 -column 0 -sticky news

label .topp.opt2.lsc -text "Variation rate:" -font $lfont
pack .topp.opt2.lsc  -side left -padx {10 0} -pady $pady

entry .topp.opt2.sc -width 5 -textvariable smallchange -justify right -font $lfont
pack .topp.opt2.sc  -side left -pady $pady

label .topp.opt2.lbc -text "Big Variation rate:" -font $lfont
pack .topp.opt2.lbc  -side left -padx {10 0} -pady $pady

entry .topp.opt2.bc -width 5 -textvariable bigchange -justify right -font $lfont
pack .topp.opt2.bc  -side left -pady $pady

label .topp.opt2.lms -text "Max. steps" -font $lfont
pack .topp.opt2.lms -side left -padx {10 0} -pady $pady

entry .topp.opt2.ms -width 5 -textvariable maxsteps -justify right -font $lfont
pack .topp.opt2.ms  -side left -pady $pady

label .topp.opt2.lmr -text "Max. runs" -font $lfont
pack .topp.opt2.lmr -side left -padx {10 0} -pady $pady

entry .topp.opt2.mr -width 5 -textvariable maxruns -justify right -font $lfont
pack .topp.opt2.mr  -side left -pady $pady

# frame .topp.opt3 -bg $c2
# pack .topp.opt3 -fill x -ipady 10


label .topp.opt2.lt -text "Temp./Thres.:" -font $lfont
pack .topp.opt2.lt  -side left -padx {10 0} -pady $pady

entry .topp.opt2.t -width 5 -textvariable T -justify right -font $lfont
pack .topp.opt2.t  -side left -pady $pady

label .topp.opt2.lat -text "Annealing rate:" -font $lfont
pack .topp.opt2.lat  -side left -padx {10 0} -pady $pady

entry .topp.opt2.at -width 5 -textvariable rate -justify right -font $lfont
pack .topp.opt2.at  -side left -pady $pady
lappend allbuts .topp.opt2.t .topp.opt2.at .topp.opt2.sc .topp.opt2.bc .topp.opt2.ms .topp.opt2.mr
lappend alltext .topp.opt2.lt .topp.opt2.t .topp.opt2.lat .topp.opt2.at .topp.opt2.lsc .topp.opt2.sc .topp.opt2.lbc .topp.opt2.bc .topp.opt2.lms .topp.opt2.ms .topp.opt2.lmr .topp.opt2.mr

activate_start
set startbuts ""
#set startbuts ".sim.sim"


# Miscs
#------------------
frame .topp.misc -bg $c2
grid .topp.misc -row 10 -column 0 -sticky news

button  .topp.misc.license -text License -font $lfont \
        -command {deactivate $allbuts;deactivate $startbuts;tatzetool license} -bg $c2
pack  .topp.misc.license -side left -pady 10

button  .topp.misc.options -text Options -font $lfont \
        -command {cev_customtool} -bg $c2
pack  .topp.misc.options -side left -padx {10 0} -pady 10
lappend allbuts .topp.misc.options .topp.misc.license
lappend alltext .topp.misc.options .topp.misc.license

button  .topp.misc.tatze -bitmap @$cemhome/icons/tinylogo.pic \
        -command {deactivate $allbuts;deactivate $startbuts;tatzetool cemos} -bg $c2
pack  .topp.misc.tatze -side right

button  .topp.misc.exit -text {   Exit  }  -font $lfont -bg $c2\
   -command { if {$rndstop==0} {Stopmodel}
			  set rndstop 1
	          after 1000
              destroy .topp
		      destroy .
			  if [file exists $pwd/integrat.par] {file delete $pwd/integrat.par}
              if [file exists $pwd/.sensitivity.par] {file delete $pwd/.sensitivity.par}
              if [file exists $pwd/.sensitivity.def] {file delete $pwd/.sensitivity.def}
              if [file exists $pwd/.parfile.tmp] {file delete $pwd/.parfile.tmp}
            }
pack  .topp.misc.exit  -side right -fill x
lappend allbuts .topp.misc.exit
lappend alltext .topp.misc.exit
button  .topp.misc.movtk -text {Tiger Graphics MoViE} -font $lfont  -bg $c2 \
        -command {cev_start_movie 1}

pack  .topp.misc.movtk  -side right -fill x
lappend allbuts .topp.misc.movtk
lappend alltext .topp.misc.movtk

global oldtype
button .topp.misc.res -text {Reset} -bg $c2 -command {set oldtype -1;cev_reset; cev_put_info} -font $lfont
pack .topp.misc.res  -side right -padx {10 10} -pady 10
lappend allbuts .topp.misc.res 
lappend alltext .topp.misc.res 

button .topp.misc.resa -text {Reset to AbsBest} -bg $c2 -command {cev_reset_toabsbest} -font $lfont
pack .topp.misc.resa  -side right -padx {10 0} -pady 10
lappend allbuts .topp.misc.resa
lappend alltext .topp.misc.resa
button .topp.misc.resbest -text {Reset to Best } -bg $c2 -command {cev_reset_tobest} -font $lfont
pack .topp.misc.resbest  -side right -padx {10 0} -pady 10
lappend allbuts .topp.misc.resbest
lappend alltext .topp.misc.resbest
button .topp.misc.ren -text {Rename} -bg $c2 -command {cev_gui_rename_best} -font $lfont
pack .topp.misc.ren  -side left -padx {10 0} -pady 10
lappend allbuts .topp.misc.ren
lappend alltext .topp.misc.ren

.topp configure -height $windowheight -width [winfo reqwidth .topp]
. configure -bg $c2 -height [winfo reqheight .topp] -width [expr [winfo reqwidth .topp]+40]

update
update idletasks
global anzp
if {$difftype<11} {set index [expr $difftype -1]} else {set index [expr $difftype+$anzp-10]}
.topp.distance.distp.diff.menu invoke $index

set remheight [winfo height .topp]


}
