# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Select Reference  Resultfile
#--------------------
proc cev_gui_select_ref {} {
global lfont sourcename pwd simtype resultdir browsedir 

.topp.filo.info.info0.refs configure -state disabled

toplevel .ref
wm title .ref {Select Reference File}
wm geometry .ref "+270+170"
wm protocol .ref  WM_DELETE_WINDOW {cancelref}
wm attributes .ref -topmost yes

set browsedir $pwd
set sourcename "$browsedir/result.$simtype"

frame .ref.up
pack .ref.up
entry .ref.up.text -width 50 -textvariable sourcename -font $lfont
pack .ref.up.text -side left

button .ref.up.choose -font $lfont -text {Browse}\
       -command { set browsedir [file dir $sourcename]
				  set sourcename [fileselect "Reference file" $simtype $browsedir open]
                  if [winfo exist .ref] { raise .ref}
         }
pack .ref.up.choose -side left

frame .ref.but
pack .ref.but
button .ref.but.cancel -font $lfont -text {cancel} -command {cancelref}
pack .ref.but.cancel -side left

button .ref.but.close -font $lfont -text {ok} -command {selectOKref}
pack .ref.but.close -side left
}

proc selectOKref {} {
global sourcename cev_reference_file
global pwd

if ![file exist $pwd/cevos] {exec mkdir $pwd/cevos}

if {$sourcename == {} } {textinfo "No source filename given!";return}

if [file exists $sourcename] {
    set cev_reference_file $sourcename
    set dummy [file delete -force [file rootname $sourcename]\_pk.outc]
    put "$sourcename set as reference file"
} else {
    put "No file $sourcename"
}

set sourcename {}
destroy .ref
.topp.filo.info.info0.refs configure -state normal
.topp.filo.info.info0.ref configure -text "[file tail $cev_reference_file]"
}

proc cancelref {} {
global sourcename
set sourcename {}
destroy .ref
.topp.filo.info.info0.refs configure -state normal
}

