# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
# mean value of a list
proc lmean {list} {
return [expr ([join $list +])/[llength $list]]
}

# standard deviation of a list
proc lstd {list} {
set len [llength $list]
set lm 0
if {$len > 1} {
  set mean [lmean $list]
  foreach a $list {
     set lm [expr $lm + ($a -$mean)*($a -$mean)]
  }
  set lm [expr sqrt(1.0*$lm/($len-1))]
} else {
  set lm -
}
return $lm
}

# Writing absbest_mean.cin parallel to cemos.par
proc cev_multi_mean {dir} {
global pwd

cd $dir
set files [exec ls]

set anzfiles 0; #number of files
foreach file $files {
    incr anzfiles
    set id  [open $file r]
    # ersten 3 Zeilen weg
    gets $id line
    gets $id line
    gets $id line

    # Loop over Variables
    set k 0
    while {[gets $id line] >=0} {
            incr k
            set out [split $line =\;]
            set var($k) [lindex $out 0]
            set val($k) [lindex $out 1]
            lappend vallist($k) $val($k) 
    }
    close $id
}

set anzvar $k; # number of variables
puts " Number of files $anzfiles"
cd ..
# Writing absbest_mean.cin
set wid [open absbest_mean.cin w]
puts $wid "%change"
puts $wid "// mean absbest.cin"
puts $wid "// Number of files $anzfiles "

for {set k 1} {$k<=$anzvar} {incr k} {
  puts $wid "$var($k)=[lmean $vallist($k)]; // std = [lstd $vallist($k)]"
}
close $wid
puts "Ready"
}
