# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cev_reset {} {
global pwd cev_resultdir GUI cev_file cev_absbestdir
global reallyreset
global counter changecounter broken
global multiruns oldtype difftype mp anzp

if {($GUI==1 && [info exists oldtype] && $oldtype!=$difftype)} {
#	puts "cev_reset oldtype:$oldtype difftype:$difftype"
  askbox
  tkwait variable reallyreset
  if {$reallyreset==0} {
	  set difftype $oldtype
	  if {$difftype<11} {set index [expr $difftype -1]} else {set index [expr $difftype+$anzp-10]}
#      puts "cev_reset: difftyp:$difftype oldtype:$oldtype index:$index"
	  $mp invoke $index
	  } 
} else {
  set reallyreset 1
}

if {($reallyreset==1 && [info exists oldtype] && $oldtype!=$difftype)} {
      set counter 0
      set changecounter 0
      set broken 0
      if [info exist difftype] {set oldtype $difftype}
      if [info exist absbestdist] {unset absbestdist}
 
      set date [clock format [clock seconds] -format "%Y%m%d_%H%M%S" ]

      if ![file exists $cev_absbestdir] {file mkdir $cev_absbestdir} 

      set files [glob -nocomplain -directory  $cev_resultdir *]

      foreach item $files {
          set item [file tail $item]

          if [string match best.outc $item] {file delete $cev_resultdir/$item}
          if [string match best.log $item] {file delete $cev_resultdir/$item}
          if [string match best.info $item] {file delete $cev_resultdir/$item}
          if [string match best.nc $item] {file delete $cev_resultdir/$item}
          if [string match best.dist $item] {file delete $cev_resultdir/$item}
          if [string match best.bat $item] {file delete $cev_resultdir/$item}
          if [string match best.cin $item] {file delete $cev_resultdir/$item}
          if [string match best_pk.outc $item] {file delete $cev_resultdir/$item}
          if [string match count.dat $item] {file delete $cev_resultdir/$item}

          if {$multiruns==0} {
            if [string match absbest.outc $item]  {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.outc}
            if [string match absbest.log $item]  {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.log}
            if [string match absbest.info $item] {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.info}
            if [string match absbest.nc $item] {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.nc}
            if [string match absbest.dist $item]  {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.dist}
            if [string match absbest.bat $item] {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.bat}
            if [string match absbest.cin $item] {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date.cin}
            if [string match absbest_pk.outc $item] {file copy -force $cev_resultdir/$item $cev_absbestdir/absbest_$date\_pk.outc}
          }
          
          if [string match absbest.outc $item] {file delete $cev_resultdir/$item}
          if [string match absbest.log $item] {file delete $cev_resultdir/$item}
          if [string match absbest.info $item] {file delete $cev_resultdir/$item}
          if [string match absbest.nc $item] {file delete $cev_resultdir/$item}
          if [string match absbest.dist $item] {file delete $cev_resultdir/$item}
          if [string match absbest.bat $item] {file delete $cev_resultdir/$item}
          if [string match absbest.cin $item] {file delete $cev_resultdir/$item}
          if [string match absbest_pk.outc $item] {file delete $cev_resultdir/$item}
  
          if [string match result* $item] {file delete $cev_resultdir/$item}
          if [string match *.dist $item] {file delete $cev_resultdir/$item}
          if [string match *.L2dist $item] {file delete $cev_resultdir/$item}

          if [string match sensitivity.bat $item] {file delete $cev_resultdir/$item}

        }
        if [file exist .sensitivity.def] {file delete .sensitivity.def}
        if [file exist $pwd/.sensitivity.def] {file delete .sensitivity.def}
        if [file exist $pwd/.sensitivity.par] {file delete $pwd/.sensitivity.par}
        if [file exist $pwd/.parfile.tmp] {file delete $pwd/.parfile.tmp}

      }
            
      if {$GUI==1} { } else {puts "Reset ready!"}


      if [file exist $cev_file] {
            cev_readpar $cev_file
            cev_write_sensitivitybat
            cev_init_best       
#            cev_init_count

            #cev_setvars
      } else {
           if {$cev_file !=""} { put "$cev_file not found"}
      }

}


proc askbox {} {
global reallyreset lfont
set w .askbox

toplevel $w
wm title $w "Tiger Graphics"
wm geometry $w "400x200+400+400"

label $w.msg -justify center -font $lfont -text "Really reset and loose last best approximation ?"
pack $w.msg -side top -pady 50

frame $w.buttons
pack $w.buttons -side bottom -fill x -pady 2m
button $w.buttons.no -font $lfont -text "Oh, no" -command "set reallyreset 0; destroy $w"
button $w.buttons.yes -font $lfont -text Yes -command "set reallyreset 1; destroy $w"
pack $w.buttons.yes $w.buttons.no -side left -expand 1
focus $w.buttons.no 
}

