# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cev_start_random { } {
global counter changecounter broken 
global rndstop enable_series GUI check_series bestdist
global cev_resultdir simname outputtype
global maxruns maxsteps
global smallchange bigchange rndchange
global init SA  T Trem rate difftype
global absbestdist distance
# for cevmulti run stops if maxruns is reached
global multiruns 

# Loop bis maxruns aus cevmulti heraus oder bis gestoppt wird
if {![info exist multiruns]} {
  set runcontrol inf
} else {
  if {$multiruns==0} {
    set runcontrol inf    
  } else {  
    set runcontrol $maxruns  
  }
}
#Only for the output
switch $SA {
0 {set method "exact"}
1 {set method "threshold accepting"}
2 {set method "simulated annealing"}
}

set rndchange $smallchange

# Falls schon der erste lauf aufrummst
#if ![info exist counter] {set counter 0} 
#if ![info exist changecounter] {set changecounter 0} 
#if ![info exist broken] {set broken 0} 
if ![info exist sacounter] {set sacounter 0} 
#if ![info exist counter] {set counter 0} 
if ![info exist rndstop] {set rndstop 0} 
#if ![info exist difftype] {set difftype 1} 

cev_check_best

set start [clock clicks -milliseconds]
while {$rndstop==0 && $changecounter<$runcontrol} {     
	 if {$GUI==0} {puts "Lauf $counter"}
     cev_delete

# Evaluating Escape Condition
    switch $SA {
        0 {
        # Exact Optimization
            if {$changecounter<=$maxruns} {
                # setzen auf aktuelle Bestwerte
                set init 1
        
                # mehr als maxsteps: zufaellige Variation auf bigchange
                # maximal smallchange  Variabilität vom Bestwert zulassen
                if {$changecounter<=$maxsteps} {
                        set rndchange $smallchange

                } else {
                        # wenn lange nichts passiert  
                        set rndchange $bigchange    
                }
        
            } else {

                # mehr als maxruns: neu initialisieren auf Werte in der cevos.cev
                set init 2
                set changecounter 0
                set rndchange $smallchange
                 if {$GUI==0} {puts "Reinitializing after $maxruns runs without change"}

            }

          } 
          # Threshold accepting OR Simulated Annealing
          1 -
          2 {

              if {$changecounter<=$maxsteps} {
                    set init 0
                    # mehr als maxsteps: Temperatur erniedrigen
                    if {$sacounter>=$maxsteps} {
                            set T [expr $T*$rate]
                            set sacounter 0
                            set init 1
                    }
                } else {
                      # mehr als maxsteps ohne Aenderung, d.h. ein Temperaturdurchlauf ohne AenderunG:
                      # neu initialisieren auf Werte in der cevos.cev
                      set init 2
                      set changecounter 0
                      set sacounter 0
                      set T $Trem
              }
          }
          }
          cev_make_random_batch
          startbatch
          set distance [cev_compare_results $simname.$outputtype]

# Auswertung

# Kriterium fuer Annahme des aktuellen Laufes als Bestlauf
#----------------------------------------------------------------------------------------
#Normal

        if ![info exist absbestdist] {set absbestdist $bestdist}
        if {$bestdist<$absbestdist} {set absbestdist $bestdist}
        set crit $bestdist
        
        switch $SA {
            0 {
               # exact method
               # aus Konsistenz absolut besten wert sichern, auch wenn er immer gleich dem besten ist
                if {$distance>=0 && $distance<$crit} {                
                   set bestdist $distance
                   set absbestdist $distance                          
                   cev_write_best absbest $simname.$outputtype $distance $absbestdist

                }

              }
            1 { 
            # Threshold accepting  
            # erstmal absolut besten wert sichern, man weiss ja nie              
                    if {$distance>=0 && $distance<$absbestdist} {    
                        set absbestdist $distance
                        cev_write_best absbest $simname.$outputtype $distance $absbestdist                      
                    }
                    if {$crit<inf} {set crit [expr $bestdist*(1.0+$T*0.1)]}
            }
            
            2 { 
            #simulated Annealing
            # erstmal absolut besten wert sichern, man weiss ja nie              
                    if {$distance>=0 && $distance<$absbestdist} {    
                          set absbestdist $distance
                          cev_write_best absbest $simname.$outputtype $distance $absbestdist
                    }                                

                    if {$crit<inf} {
                        set rnd [cev_random]
                        set crit [expr $bestdist - $T * log($rnd)]
                    }
            }
        }
		  cev_put_info 
		  cev_write_count 
	                       
        if {$distance>=0 && $distance<$crit} {                
                set bestdist $distance
                cev_read_count
                cev_write_best best $simname.$outputtype $bestdist $absbestdist
                set changecounter -1
        }
	          
		incr counter
		incr changecounter
		incr sacounter

		 set stop [clock clicks -milliseconds]
		 put "Time=[expr $stop-$start] milliseconds"
		 set start $stop
	
		 # Only for debugging
		 # set rndstop 1
}
if {$GUI==0} {
   puts "runcontrol exceeded limit with runcontrol=$runcontrol maxruns=$maxruns maxsteps=$maxsteps"
   exit
}
}
