/* CEMOS/CEMTK 4.0 Copyright (C) 2007, Cora Kohlmeier, Frank Hamberg */
#include "stdinc.h"
#include <math.h>

real L2_norm(int length, real *input)
{
  int i;
  real y=0.0;
  for (i=1;i<=length;i++) y+=input[i]*input[i];
  y = sqrt(y);
  return (y); 
}

real L2_normsum(int length, real *input1, real* input2)
{
  int i;
  real z;
  real y=0.0;
  for (i=1;i<=length;i++) 
  {
     z = input1[i]*input2[i];
     y+=z*z;
  }
  z = sqrt(y);
  return (z); 
}

real L2_normdiff(int length, real *input1, real* input2)
{
  int i;
  real z;
  real y=0.0;
  for (i=1;i<=length;i++) 
  {
     z = input1[i]-input2[i];
     y+=z*z;
  }
  z = sqrt(y);
  return (z); 
}

real L2_scalar(int length, real *input1, real* input2)
{
  int i;
  real z;
  real y=0.0;
  for (i=1;i<=length;i++) 
  {
   z =input1[i]*input2[i];
   y += z;
  }  
return(y);
}
