/* CEMOS/CEMTK 4.0 Copyright (C) 2007, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[])
{
 void *readheader(FILE*,header*,int);
 void writeheader(FILE *, header*, long_name*, int);

 string in_name1,in_name2,out_name,shortname,para,var1,var2,helpname;
 long int timnum,timnum1,timnum2;

 int i,j,k,l,n,m,found,method,cp;
 int namelength,namelength1, namelength2;
 int years1,years2;
 int nanflag=0;

 unsigned int nvars;

 void *names1,*names2;
 long_name *out_names,one_name;

 float *dat;
 float finaldist,val,normfac;
 float *weight,*dist;
 float weightmax;

 unsigned int *index1, *index2, count;

  real inp1,inp2,outp,sum,diff,y1,y2,y3,y4;
  real **all_data1,**all_data2,**target_data;
  real __zero = 1e-14;
  real __minf = -1.e-14;
  FILE *in_file1, *in_file2, *out_file;

  header oh,oh1,oh2;


  sprintf(in_name1,"%s",argv[1]);
  sprintf(in_name2,"%s",argv[2]);

  sprintf(para,"%s",argv[3]);
  sscanf(para,"%d",&method);
/*  printf("Method = %d\n",method);*/

  in_file1=fopen(in_name1,"rb");
  in_file2=fopen(in_name2,"rb");

  if (in_file1 == NULL)
  {
     std_error("COMPARE_RESULT: Error when opening result file 1 for reading");
  }

  if (in_file2 == NULL)
  {
     std_error("COMPARE_RESULT: Error when opening result file 2 for reading");
  }

  cp = strpos(in_name2,"/");
  while (cp >= 0)
  {
    sprintf(in_name2,"%s",strmid(in_name2,cp+1,strlen(in_name2)-cp-1));
    cp = strpos(in_name2,"/");
  }

   if (strpos(in_name1,".outb") > 0) {
      namelength1 = sizeof(name12);
   } else {
      namelength1 = sizeof(long_name);
   }
   names1 = readheader(in_file1,&oh1,namelength1);

  if (strpos(in_name2,".outb") > 0) {
      namelength2 = sizeof(name12);
   } else {
      namelength2 = sizeof(long_name);
   }
   names2 = readheader(in_file2,&oh2,namelength2);

/*    Ausgabenamen zusammenbauen und dabei die Extension ".outb" oder ".outc" abschneiden */
   i=strpos(in_name1,".out");
   sprintf(in_name1,"%s",strmid(in_name1,0,i));
   i=strpos(in_name2,".out");
   sprintf(in_name2,"%s",strmid(in_name2,0,i));
   sprintf(out_name,"%s_%s_m%s.dist",in_name1,in_name2,argv[3]);


  if (oh1.outdelt != oh2.outdelt)
  {
     std_error("COMPARE_RESULT: outdelts of resultfiles are not compatible");
  }

 namelength = sizeof(long_name)+1;

  timnum1 = (long int) (0.5+(oh1.endtim-oh1.startim)/oh1.outdelt) + 1;
  years1 = (int) (oh1.endtim-oh1.startim)/oh1.cycle;

  timnum2 = (long int) (0.5+(oh2.endtim-oh2.startim)/oh2.outdelt) + 1;
  years2 = (int) (oh2.endtim-oh2.startim)/oh2.cycle;

  timnum = IMIN(timnum1,timnum2);


/* Variablennamen einlesen */

/* mehr als die kleinere Anzahl von Variablen koennen es nicht werden*/
  oh.nvars = IMIN(oh1.nvars,oh2.nvars);
  out_names = malloc(oh.nvars*namelength);

  index1 = malloc(oh1.nvars*sizeof(unsigned int));
  index2 = malloc(oh2.nvars*sizeof(unsigned int));

  count = 0;

/*Variable-Liste zusammenbauen und die entsprechenden Spalten-Indizes dieser Daten merken */
  for (i=0;i<oh1.nvars;i++)
  {
     sprintf(var1,"%s",strtolower(strmid(names1,i*namelength1,namelength1)));
     for (j=0;j<oh2.nvars;j++)
     {
        sprintf(var2,"%s",strtolower(strmid(names2,j*namelength2,namelength2)));
	found = 0;
        if ( strpos(var1,var2) == 0)
	{
           sprintf(helpname,"%s",strmid(var1,0,namelength1));

           for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;

           sprintf(out_names[count],"%s",strmid(helpname,0,namelength));
           strtrim(out_names[count]);

/*           printf("%d %s\n",count,out_names[count]); */

           index1[count] = i+1;
	   index2[count] = j+1;
	   count++;
	   found = 1;
	}
     }
  }

  oh.nvars=   count;
 

/* Speicherplatz fuer gesamten binaeren Datenanteil reservieren ('mal sehen wie lange es geht...) */
  all_data1   = matrix(1,oh1.nvars,1,timnum1);
  all_data2   = matrix(1,oh2.nvars,1,timnum2);
  target_data = matrix(1,oh.nvars,1,timnum);

/* Vektor fuer die Distanzen (Kosten) und Gewichte der einzelnen Variablen */
  dist = fvector(1,oh.nvars);
  weight = fvector(1,oh.nvars);
  for (i=1;i<=oh.nvars;i++) {dist[i]=0.0;weight[i]=0.0;}

/* Simulationsdaten einlesen */

/* Resultfile 1
------------------*/
/* Speicherplatz fuer einen Satz von Resultfile 1*/
  dat = fvector(1,oh1.nvars);

/*   printf("Reading data of %s..\n",argv[1]); */
  fflush(stdout);
/* Hauptschleife ueber alle Variablen */
  for (k=1;k<=timnum1;k++)
     {
/* Einen "Tag" einlesen */
      fread(&dat[1],sizeof(float),oh1.nvars,in_file1);

      for (i=1;i<=oh1.nvars;i++)
        {
        all_data1[i][k] = (real) dat[i];
        }
     }
  fclose(in_file1);
  free_fvector(dat,1,oh1.nvars);

/* Resultfile 2
------------------*/
/* Speicherplatz fuer einen Satz von Resultfile 2*/
  dat = fvector(1,oh2.nvars);

/*   printf("Reading data of %s..\n",argv[2]); */
  fflush(stdout);
/* Hauptschleife ueber alle Variablen */
  for (k=1;k<=timnum2;k++)
     {
/* Einen "Tag" einlesen */
      fread(&dat[1],sizeof(float),oh2.nvars,in_file2);

      for (i=1;i<=oh2.nvars;i++)
        {
        all_data2[i][k] = (real) dat[i];
        }
     }
  fclose(in_file2);
  free_fvector(dat,1,oh2.nvars);
  fflush(stdout);


/* Berechnung ausfuehren  */
/*   printf("Analysing data with method %d\n",method); */

  normfac=0.0;

/* Zeitschleife */

  for (j=1;j<=timnum;j++)
  {

/* Schleife ueber die Variablen */

     for (i=1;i<=oh.nvars;i++)
     {
        inp1 = all_data1[index1[i-1]][j];
	inp2 = all_data2[index2[i-1]][j];

        if (inp1==-9999.0 || inp2==-9999.0) 
        {
           outp=-9999.0;
        } else {

      
              if (isnan(inp1) || isnan(inp2)) 
              {
                nanflag=1;
                outp=-9999.0;
              } else {
      
      
              outp=-9999.0;
              switch (method)
              {
            /*
            1: least square method see Lawson et al. 1995,1996
            2: |f(t)-g(t)|/|f(t)+g(t)|
            3: |f(t)-g(t)|/min\[|f(t)|,|g(t)|\]
            4: |f(t)-g(t)|/(|f(t)|+|g(t)|-|f(t)-g(t)|)
            5: |ln(|f(t)/g(t)|)|
            6: max\[|g(t)/f(t)|,|f(t)/g(t)|\]-1
            */
            
            /* least square method */
                    case 1: outp=(inp1-inp2)*(inp1-inp2);
                                normfac=0.5;
                                /*   Referenzmittel ueber die Zeit*/
                                weight[i]+=inp1;
                                break;
            
                    case 2: y1= rabs(inp1 +inp2);
                                if (y1 > __zero) outp = rabs(inp1-inp2)/y1;
                                normfac=1.0;
                                break;
            
                    case 3: y1 = rabs(rmin(inp1,inp2));  
                                if (y1 > __zero) outp = fabs(inp1-inp2)/y1;
                                normfac=1.0;
                                break;
            
                    case 4: y1 = rabs(inp1) +rabs(inp2) + rabs(inp1-inp2);
                                if (y1 > __zero) outp = rabs(inp1-inp2)/y1;
                                normfac=1.0;
                                break;
            
                    case 5: if (rabs(inp2) > 0.0) y1 = rabs(inp1/inp2);
                                if (y1 > __zero) outp = log(y1);
                                normfac=1.0;
                                break;
            
                    case 6: if (rabs(inp1) > __zero && rabs(inp2) > __zero) outp=rmax(rabs(inp2/inp1),rabs(inp1/inp2))-1.0;
                                normfac=1.0;
                                break;
            
            
                    default: printf("COMPARE_RESULT: method=%d\n",method+1);
                                  std_error("COMPARE_RESULT: Undefined method");
                    }
                    }
                }

/*        Wert fuer die i-te Variable zur Zeit j */
	target_data[i][j] =  outp;
     }
  }

  fflush(stdout);

//   out_file=fopen(out_name,"wb");


/* Daten zu Distanzen (Kosten) zusammenfuegen, Anzahl bestimmen*/
     for (i=1;i<=oh.nvars;i++) 
     {
       dist[i]=0.0;
       timnum1=0;
        for (j=1;j<=timnum;j++)
                {
                 val = (float) target_data[i][j];
                 if (val !=-9999.0)
                 {
                      dist[i] += val;
                      timnum1++;
                 }
                }
        }

/* Einzelgewichte bestimmen*/
     weightmax=0.0;
     for (i=1;i<=oh.nvars;i++) 
     {
/* Gewichte bestimmen */
          if (method==1) 
          {
/*              Zeitmittelwert */
              if (timnum1 > 0) weight[i]=fabs(weight[i])/timnum1; else weight[i]=1.0;
              weightmax=rmax((real) weightmax,(real) weight[i]);
          }
          else
          {
              weight[i]=1.0;
              weightmax=1.0;
           }
       } /*Ende Variablenschleife*/




/* Gesamtdistanz (Kostenfunktion) vorbereiten und Distanz (Kosten) fuer die i-te Variable */
    finaldist=0.0;  
     for (i=1;i<=oh.nvars;i++) 
     {
/*          Gewicht nach Spitz et al. 1998 */
          if ( weight[i] > __zero &&  weightmax > __zero ) weight[i]=weightmax/weight[i]; else weight[i]=1.0;

           if (timnum1 > 0) dist[i]=normfac *  weight[i] * dist[i] / (1.0*timnum1);

/* Gesamtdistanz (Kostenfunktion) vorbereiten */
          if (timnum1 > 0) finaldist+= dist[i];

/* Einzelwerte ausgeben*/         
//           fprintf(out_file,"%s , %f\n",out_names[i-1],dist[i]);
/*           fprintf(out_file,"%d:%s , %f, %f\n",i,out_names[i-1],dist[i],dist); */
   

    } /*Ende Variablenschleife*/

 


if (nanflag==0)
{
/* Am Ende nochmal durch die Anzahl der beruecksichtigenten Variablen teilen */
  printf("%f\n", finaldist/(1.0*oh.nvars));
/* Gesamtdistanz (Kostenfunktion) */
//    fprintf(out_file,"Distance %d, %f\n", method, finaldist/(1.0*oh.nvars));
}
else
{
  printf("%f\n", -9999.0);
//   fprintf(out_file,"Distance %d, %f\n", method, -9999.0);
}

//    fclose(out_file);

/*     fflush(stdout); */

return(0); 
}






