# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Compiler Flags
#--------------------
proc compilerflags {} {

global general_flaglist gflagarr compile_flaglist  cflagarr
global lfont comp_settings DOS

if ![info exist comp_settings] {set comp_settings ""}

if [winfo exist .cf] {
  raise .cf
} else {

toplevel .cf
wm title .cf {Compiler Flags}
set pos  [split [wm geometry .] +x]
wm geometry .cf "+[expr [lindex $pos 2]+100]+[expr [lindex $pos 3]+10]"

frame .cf.buts
pack .cf.buts

#  combined options
frame .cf.buts.1
pack .cf.buts.1 -side left

radiobutton .cf.buts.1.default  -text -default -variable comp_settings -value default -command {make_default_list} -font $lfont -fg darkred -anchor w
pack .cf.buts.1.default  -fill x 

radiobutton .cf.buts.1.debug  -text -debug -variable comp_settings -value debug -command {make_debug_list} -font $lfont  -fg darkred -anchor w
pack .cf.buts.1.debug  -fill x 

radiobutton .cf.buts.1.paranoid  -text -paranoid -variable comp_settings -value paranoid -command {make_paranoid_list} -font $lfont  -fg darkred -anchor w
pack .cf.buts.1.paranoid  -fill x 

if {$DOS == 0} {
   radiobutton .cf.buts.1.gprof  -text -gprof -variable comp_settings -value gprof -command {make_gprof_list} -font $lfont  -fg darkred -anchor w
   pack .cf.buts.1.gprof  -fill x 
}
radiobutton .cf.buts.1.all  -text -all -variable comp_settings -value all -command {make_all_list} -font $lfont  -fg darkred -anchor w
pack .cf.buts.1.all  -fill x 

radiobutton .cf.buts.1.none  -text -none -variable comp_settings -value none -command {make_none_list} -font $lfont  -fg darkred -anchor w
pack .cf.buts.1.none  -fill x 

if {$comp_settings == ""} {.cf.buts.1.default invoke}
#  single options
frame .cf.buts.2
pack .cf.buts.2 -side left
set i 1
foreach item $compile_flaglist {
#$cfmenu add check -label -$item -variable cflagarr($item) 
checkbutton .cf.buts.2.$i  -text -$item -variable cflagarr($item)  -font $lfont -anchor w
pack .cf.buts.2.$i -fill x 
incr i
}

foreach item $general_flaglist {
#$cfmenu add check -label -$item -variable gflagarr($item) 
checkbutton .cf.buts.2.$i  -text -$item -variable gflagarr($item)  -font $lfont  -anchor w
pack .cf.buts.2.$i  -fill x 
incr i

}


frame .cf.but
pack .cf.but
button .cf.but.close -font $lfont -text {ok} -command {cf_OK}  -font $lfont 
pack .cf.but.close -side left
}
}

proc cf_OK {} {
destroy .cf
.topp.com.but config -state normal
}

proc make_gprof_list {}  {
 global general_flaglist gflagarr compile_flaglist  cflagarr
                       foreach item $compile_flaglist {set cflagarr($item) 0}
                        foreach item $general_flaglist {set gflagarr($item) 0}
                        set gflagarr(pg)  1
                        set gflagarr(static)  1
}

proc make_paranoid_list {}  {
 global general_flaglist gflagarr compile_flaglist  cflagarr DOS
                       foreach item $compile_flaglist {set cflagarr($item) 0}
                        foreach item $general_flaglist {set gflagarr($item) 0}
                        set gflagarr(pedantic)  1
                        set gflagarr(Wredundant-decls)  1
                        set gflagarr(Wextra) 1
                        set gflagarr(Wshadow) 1
                        set gflagarr(Wfloat-equal) 1
                        set gflagarr(Wunreachable-code) 1
                        set gflagarr(Wstrict-prototypes) 1
if {$DOS==0} {
                        set gflagarr(Wunused-result) 1
                        set gflagarr(Wno-unused-result) 0
                        set gflagarr(Wunused-but-set-variable) 1
                        set gflagarr(Wno-unused-but-set-variable) 0
}
                        set cflagarr(Wall)  1
}

proc make_debug_list {}  {
global general_flaglist gflagarr compile_flaglist  cflagarr DOS
                        foreach item $compile_flaglist {set cflagarr($item) 0}
                        foreach item $general_flaglist {set gflagarr($item) 0}
                        set gflagarr(g) 1
                        set gflagarr(pedantic)  1
                        set gflagarr(D__verbose__)  1
                        set gflagarr(Wredundant-decls)  1
if {$DOS==0} {
                        set gflagarr(Wunused-result) 1
                        set gflagarr(Wno-unused-result) 0
                        set gflagarr(Wunused-but-set-variable) 0
                        set gflagarr(Wno-unused-but-set-variable) 0
}
                        set cflagarr(Wall)  1
}

proc make_all_list  {} {
global general_flaglist gflagarr compile_flaglist  cflagarr
                        foreach item $compile_flaglist {set cflagarr($item) 1}
                        foreach item $general_flaglist {set gflagarr($item) 1}
}

proc make_none_list {}  {
 global general_flaglist gflagarr compile_flaglist  cflagarr
                       foreach item $compile_flaglist {set cflagarr($item) 0}
                        foreach item $general_flaglist {set gflagarr($item) 0}
}

proc make_default_list {}  {
global general_flaglist gflagarr compile_flaglist  cflagarr DOS
                        foreach item $compile_flaglist {set cflagarr($item) 0}
                        foreach item $general_flaglist {set gflagarr($item) 0}
                        set cflagarr(O2)  1
if {$DOS==0} {
                        set gflagarr(Wno-unused-result) 1
                        set gflagarr(Wunused-result) 0
                        set gflagarr(Wunused-but-set-variable) 0
                        set gflagarr(Wno-unused-but-set-variable) 1
}
                        set cflagarr(Wall)  1
}


