# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc execlog {} {
global command input log but par
global font sfont lfont
global tclstop stopbut startbuts DOS
global editor toolflag
global c2 pady
global allbuts logwindows alltext

set tclstop 0
set logwindows ""
set stopbut ""

switch $toolflag {
cemtk {
   set logheight 15
   set parheight 5
   
   if {[winfo screenheight .] <=1000} {set logheight 5;set parheight 3}
} 
mocos {
   set logheight 5
   if {[winfo screenheight .] <= 800} {set logheight 5}
   set parheight 5
}

cevos {
   set logheight 10
   if {[winfo screenheight .] <= 800} {set logheight 5}
   set parheight 5
}
}

# Create the command buttons.
if {$DOS==0 || $DOS==2} {
lappend stopbut [button .topp.lab.s -font $lfont -text "Stop Running Model" -command Stopmodel]
#grid  .topp.run -row 0 -column 1 -sticky nw

pack .topp.lab.s -side right -pady $pady
lappend allbuts .topp.lab.s
lappend alltext .topp.lab.s
deactivate $stopbut
}

# Create a labeled entry for the command
#label .topp.l -text Command: -padx 0
#label .topp.cmd -width 20 -relief sunken \
#	-textvariable command
#pack .topp.l -side left
#pack .topp.cmd -side left -fill x -expand true

# Set up keybinding equivalents to the buttons
#bind .topp.cmd <Return> Run
#bind .topp.cmd <Control-c> Stop
#focus .topp.cmd

global w
set w .topp.paned

frame $w
grid $w -row 1 -column 0 -sticky news
#grid columnconfigure $w 0 -weight 1
# Create the pane itself
panedwindow $w.pane -orient vertical
pack $w.pane -side top -expand yes -fill both -pady 2 -padx 2


# Create a text widget to log the output
labelframe $w.t  -text "Global Log"
set log [text $w.t.log -width 120 -height $logheight \
	-borderwidth 2 -relief raised -setgrid true -font $sfont \
	-yscrollcommand {.topp.paned.t.scroll set}]
scrollbar $w.t.scroll -command {.topp.paned.t.log yview}
pack $w.t.scroll -side right -fill y
pack $w.t.log -side left -fill both -expand true -padx 2 -pady 5
pack $w.t -side top -fill both -expand true

# Create a text widget to log the parameter changes
labelframe $w.p -text "Parameter Changes"
set par [text $w.p.par -width 120 -height $parheight \
	-borderwidth 2 -relief raised -setgrid true -font $sfont \
	-yscrollcommand {.topp.paned.p.scroll set}]
scrollbar $w.p.scroll -command {.topp.paned.p.par yview}
pack $w.p.scroll -side right -fill y
pack $w.p.par -side left -fill both -expand true  -padx 2 -pady 5
pack $w.p -side top -fill both -expand true

lappend logwindows $w.t.log $w.p.par
# Now add our contents to the paned window
$w.pane add $w.t $w.p

}

############# RUN ##################################
# Run the program and arrange to read its input
proc Run {{sw 1}} {
        global allbuts startbuts stopbut pwd toolflag
	global command input log but par DOS SHOW_PROLOG display_info

#        .topp.run configure -state normal

         if {$sw ==1} {
          if {$toolflag != "cevos"} {
			deactivate $allbuts
			deactivate $startbuts
		}
        set display_info $SHOW_PROLOG
	    if {$DOS==0 || $DOS==2} {activate $stopbut}
	    }

         $log delete 1.0 end
         $par delete 1.0 end
         #puts $command

	if [catch {open "|$command"} input] {
	   $log insert end $input\n
	} else {
	    fileevent $input readable Log
	    $log insert end $command\n
	}

#        .topp.run config  -command Stop
}

############# LOG ##################################

# Read and log output from the program
proc Log {} {
	global input log allbuts par DOS cevlog display_info

	if [eof $input] {
		Stop
#                activate $allbuts
#                activate_start
	} else {
               if {[gets $input line] >=1 || $DOS==0 || $DOS==2} {
                  if [string match Starting [lindex $line 0]] {set display_info 1}

	           if {$display_info ==1} {$log insert end $line\n}
		   $log see end
                   # Fuer CEvoS
                   if {$line!=""} {set cevlog $line}

                   if [string match Change* $line] {
		      $par insert end $line\n
		      $par see end
                   }
               } else {
#                activate $allbuts
#				 activate_start
               }

	}
}

############# STOP ##################################

# Stop the program and fix up the button
# proc Stop2 {} {
# 
#         global allbuts
# 	global input but
#         global tclstop processready
# 	catch {close $input}
#        .topp.run config -command Run
#        .topp.run configure -state disabled
#         activate $allbuts
# 	activate_start
#         set tclstop 1
# }


proc Stop {} {
    global allbuts stopbut DOS toolflag
	global tclstop input pwd

	catch {close $input}
	    if {$toolflag != "cevos"} {
			activate $allbuts
			activate_start
			if {$DOS==0 || $DOS==2} {deactivate $stopbut}
		}
        set tclstop 1
	update
}


proc Stopmodel {} {
	global pwd cevlog
        set cevlog "now exiting to the system"
        if [file exists $pwd/cemos.pid] {
		  set cemospid [exec cat $pwd/cemos.pid]
		  set command "exec kill -9 $cemospid"
		  catch $command
		  file delete -force $pwd/cemos.pid
        }
        Stop
}

#####################################################

proc OpenTerm {} {
	global pwd DOS
	if {$DOS==0} {
	eval exec "konsole --workdir $pwd" &
	}
	if {$DOS==2} {
        eval exec "open -a Terminal.app $pwd"
#	eval exec "konsole --workdir $pwd" &
	}
}

proc OpenEdit {} {
	global pwd editor DOS
       if {$DOS==0 || $DOS==2} {
             eval exec "$editor" &
       } else {
	eval exec "$editor $pwd/doc1.txt" &
       }
}











