# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc ReadPar {} {
global endtime mindelt maxdelt outdelt storetim 
global method accuracy relrate relchange multi
global pwd
global modelhome modelhomeabs resultdir simtype
global cemhome cemospar
global firstread allbuts


if ![info exist firstread] {set firstread 1}
if ![info exist mindelt(1)]   {set mindelt(1) 0.00001}
if ![info exist relrate(1)]   {set relrate(1) 1.0}
if ![info exist relchange(1)] {set relchange(1) 0.5}
if ![info exist accuracy(1)]  {set accuracy(1) 0.1}

  if [info exist cemospar] {
      activate_start
      if [info exists allbuts] {activate $allbuts}
                                
  } else {
    set cemospar $cemhome/defaults/empty.par
    if {$firstread==1} {
      set firstread 0
      textinfo "No local file cemos.par !!"
      textinfo " Create new model or call cem from a model directory !!"
    }
      if [info exists allbuts] {deactivate $allbuts
                                activate .mod.new
                               }
  }
  if ![file exist $cemospar] {set cemospar $cemhome/defaults/empty.par}

  set ipar [open $cemospar]
  set i 0

  set list "endtime outdelt storetim multi"
  while {[gets $ipar line]>=0} {

  if {[string match model_dir* $line]==1} {
     set modelhome [lindex $line end]
     set modelhomeabs $pwd/$modelhome
  }
  if {[string match resulttype* $line]==1} {
     set simtype [lindex $line end]
  }

  if {[string match result_dir* $line]==1} {
     set resultdir [lindex $line end]
     if {[string match "/*" $resultdir]!=1} {
     set resultdir $pwd/$resultdir
     }
  }

    foreach item $list {
      if {[string match $item* $line]==1} {
        # Kommentare abschneiden
        set line [lindex [split $line \;] 0]\;
        set g1 [expr 1+[string last = $line]]
        set g2 [expr [string length $line]-2]
        set a($item) [string range $line $g1 $g2]
      }
    }
  }
  close $ipar

  set endtime $a(endtime)
  set outdelt $a(outdelt)
  if [info exist a(storetim)] {set storetim $a(storetim)} else {set storetim 0}
  if [info exist a(multi)] {set multi $a(multi)} else {set multi 1}


  set flag 0
  set list "mindelt maxdelt accuracy relrate relchange method"

  for {set j 1} {$j <=$multi} {incr j} {
      set ipar [open $cemospar]
      while {[gets $ipar line]>=0} {

       if {[string match %integration_par$j $line]==1
           || [string match %integration_par $line]==1} {
               set flag 1
               continue
       } else {
           if {[string match %* $line]==1} {
               set flag 0
               continue
              }
       }


         if {$flag ==1} {
           foreach item $list {

             if {[string match $item* $line]==1} {
               set g1 [expr 1+[string last = $line]]
               set g2 [expr [string length $line]-2]

               set b($item) [string range $line $g1 $g2]
               break
             }
           }
         }
       }
       if [info exist b(mindelt)] {set mindelt($j) $b(mindelt)}
       if [info exist b(maxdelt)] {set maxdelt($j) $b(maxdelt)}
       if [info exist b(accuracy)] {set accuracy($j) $b(accuracy)}
       if [info exist b(relrate)] {set relrate($j) $b(relrate)}
       if [info exist b(relchange)] {set relchange($j) $b(relchange)}
       if [info exist b(method)] {set method($j) $b(method)}

       if [info exist b] {unset b}
       set flag 0
       close $ipar
       if ![info exist mindelt($j)] {set mindelt($j) $mindelt(1)}
       if ![info exist maxdelt($j)] {set maxdelt($j) $maxdelt(1)}
       if ![info exist accuracy($j)] {set accuracy($j) $accuracy(1)}
       if ![info exist relrate($j)] {set relrate($j) $relrate(1)}
       if ![info exist relchange($j)] {set relchange($j) $relchange(1)}
       if ![info exist method($j)] {set method($j) $method(1)}

  }
  if {$simtype=="outa" && [winfo exist .topp.misc.movtk]} {.topp.misc.movtk configure -state disabled}

}

