# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Rename Results
#--------------------
proc renameResult {} {
global lfont sourcename name pwd simtype resultdir browsedir
toplevel .lab

wm title .lab {Rename Result File}
set pos  [split [wm geometry .] +x]
wm geometry .lab "+[expr [lindex $pos 2]+200]+[expr [lindex $pos 3]+170]"
wm protocol .lab WM_DELETE_WINDOW {cancel}

.topp.ed.rename config -state disabled
frame .lab.up
pack .lab.up

if [info exist resultdir] {
   set browsedir $resultdir
   } else {
   set browsedir $pwd
}

set sourcename "$browsedir/result.$simtype"

entry .lab.up.text -width 50 -textvariable sourcename -font $lfont
pack .lab.up.text -side left

button .lab.up.choose -font $lfont -text {Browse}\
       -command {set sourcename [fileselect "File to change" $simtype $browsedir open];if [winfo exist .lab] { raise .lab}}
pack .lab.up.choose -side left

bind  .lab.up.text <Return> "focus .lab.down.text"

frame .lab.down
pack .lab.down

label .lab.down.label -font $lfont -text "Set new name" -anchor w -width 20
pack .lab.down.label -side left

entry .lab.down.text -width 50 -textvariable name -font $lfont
pack .lab.down.text -side left

bind  .lab.down.text <Return> ".lab.but.close invoke"

focus .lab.down.text

frame .lab.but
pack .lab.but

button .lab.but.cancel -font $lfont -text {cancel} -command {cancel}
pack .lab.but.cancel -side left

button .lab.but.close -font $lfont -text {ok} -command {renameOK}
pack .lab.but.close -side left
}

proc renameOK {} {
global name sourcename simtype lfont
global pwd browsedir

if {[file extension $name] == "$simtype"} { set name  [file rootname $name] }

set newdir [file dirname $name]

if {$newdir=="."} {
  # set name $browsedir/$name
  set newdir [file dirname $sourcename]

}

#set i_name $browsedir/$name.info
#set l_name $browsedir/$name.log
#set r_name $browsedir/$name.$simtype

set i_name $newdir/$name.info
set l_name $newdir/$name.log
set r_name $newdir/$name.$simtype

if {[file extension $sourcename] == "$simtype"} {set sourcename [file rootname $sourcename] }

set i_sourcename $sourcename.info
set l_sourcename $sourcename.log
set r_sourcename $sourcename.$simtype

if {$name       == {} } {textinfo "No target filename given!";return}
if {$sourcename == {} } {textinfo "No source filename given!";return}

if [file exists $r_name] {
   textinfo "$r_name already exists!"
} else {
   if [file exists $r_sourcename] {
        exec mv $r_sourcename $r_name
       textinfo "$r_sourcename renamed to $r_name"
   } else {
       textinfo "no file $sourcename"
   }
   if [file exists $i_sourcename] {
        exec mv $i_sourcename $i_name
       textinfo "$i_sourcename renamed to $i_name"
   } else {
       textinfo "no file $i_sourcename"
   }
   if [file exists $l_sourcename] {
        exec mv $l_sourcename $l_name
       textinfo "$l_sourcename renamed to $l_name"
   } else {
       textinfo "no file $l_sourcename"
   }
}
set name {}
destroy .lab
.topp.ed.rename configure -state normal
}

proc cancel {} {
set name {}
destroy .lab
.topp.ed.rename configure -state normal
}
