# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc shiftcut {inname} {
global lfont pwd simtype resultdir browsedir
global shiftdays cutdays scname newname remname

set shiftdays -1459
set cutdays 1
set scname $inname
set remname $inname
set newname "[file rootname $scname]\_shift\_cut.outc"

if [info exist resultdir] {set browsedir $resultdir} else {set browsedir $pwd}
textinfo ""
textinfo "default shift"
textinfo " shift=-1459 cut=1"
textinfo "extracting last year of 5 year run with a cycle of 365 starting at day 1"
textinfo "to a 1 year run with a cycle of 365 starting at day 1"

toplevel .shiftcut
wm title .shiftcut {Shift and Cut Result File}
wm protocol .shiftcut WM_DELETE_WINDOW {shiftcutcancel}
set pos  [split [wm geometry .] +x]
wm geometry .shiftcut "+[expr [lindex $pos 2]+200]+[expr [lindex $pos 3]+170]"
wm attributes .shiftcut -topmost yes
.topp.misc.sc configure -state disabled

frame .shiftcut.num
pack .shiftcut.num
label .shiftcut.num.shiftlabel -font $lfont -text "Shift days" -anchor w -width 20
pack .shiftcut.num.shiftlabel -side left
entry .shiftcut.num.shiftdays  -font $lfont -width 10 -textvariable shiftdays
pack .shiftcut.num.shiftdays -side left
label .shiftcut.num.cutlabel -font $lfont -text "Cut days" -anchor w -width 20
pack .shiftcut.num.cutlabel -side left
entry .shiftcut.num.cutdays  -font $lfont -width 10 -textvariable cutdays
pack .shiftcut.num.cutdays -side left

frame .shiftcut.up
pack .shiftcut.up
label .shiftcut.up.label -font $lfont -text "Result name" -anchor w -width 20
pack .shiftcut.up.label -side left
entry .shiftcut.up.text -width 50 -textvariable scname -font $lfont
pack .shiftcut.up.text -side left

button .shiftcut.up.choose -font $lfont -text {Browse}\
       -command {set scname [fileselect "File to change" $simtype $browsedir open]
                          set newname "[file rootname $scname]\_shift\_cut.outc"
                          if [winfo exist .shiftcut] { raise .shiftcut}

                          }
pack .shiftcut.up.choose -side left
bind  .shiftcut.up.text <Return> "focus .shiftcut.but.close"

frame .shiftcut.down
pack .shiftcut.down
label .shiftcut.down.label -font $lfont -text "New name" -anchor w -width 20
pack .shiftcut.down.label -side left
label .shiftcut.down.text -width 50 -text $newname -font $lfont -anchor w
pack .shiftcut.down.text -side left

frame .shiftcut.but
pack .shiftcut.but
button .shiftcut.but.cancel -font $lfont -text {cancel} -command {shiftcutcancel}
pack .shiftcut.but.cancel -side left
button .shiftcut.but.close -font $lfont -text {ok} -command {shiftcutOK}
pack .shiftcut.but.close -side left
.topp.misc.sc configure -state disabled 

}



proc shiftcutOK {} {
global scname simtype lfont
global shiftdays cutdays scname  lfont
global pwd browsedir

if {[file extension $scname] == ".outc" || [file extension $scname] == ""} {
          set scname [file rootname $scname] 
} else {
           textinfo "File must be outc file!";return
}

if ![file exists $scname\.outc]  {textinfo "File $scname not found!";return}
textinfo ""
textinfo "Shifting $scname by $shiftdays days"
exec shift_result $scname $shiftdays
textinfo "Cutting $scname by $cutdays days"
exec cut_result $scname\_shift $cutdays
file delete $scname\_shift.outc
textinfo "Output written to $scname\_shift\_cut.outc"
destroy .shiftcut
.topp.misc.sc configure -state normal
}




proc shiftcutcancel {} {
global newname remname 
set newname $remname 
destroy .shiftcut
.topp.misc.sc  configure -state normal
}
