# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#-------------------------------
# Writing integration parameters
#-------------------------------
proc WritePar {} {
global endtime mindelt maxdelt outdelt 
global storetim method accuracy relrate relchange multi
global parfilename outputtype
global pwd

if {$storetim > $endtime} {textinfo "Storetime > Endtime" 1;
                            textinfo "No results will be stored"
}

#puts "WritePar: outputtype=$outputtype"
set ipar [open $pwd/integrat.par w 0664]
puts $ipar "%simulation_par"
puts $ipar "endtime=$endtime;"
puts $ipar "outdelt=$outdelt;"
puts $ipar "storetim=$storetim;"
puts $ipar "multi=$multi;"
puts $ipar "resulttype $outputtype"

for {set i 1} {$i <=$multi} {incr i} {
if ![info exist mindelt($i)] {set mindelt($i) $mindelt(1)}
if ![info exist maxdelt($i)] {set maxdelt($i) $maxdelt(1)}
if ![info exist accuracy($i)] {set accuracy($i) $accuracy(1)}
if ![info exist relrate($i)] {set relrate($i) $relrate(1)}
if ![info exist relchange($i)] {set relchange($i) $relchange(1)}
if ![info exist method($i)] {set method($i) $method(1)}

puts $ipar "%integration_par$i"
puts $ipar "mindelt=$mindelt($i);"
puts $ipar "maxdelt=$maxdelt($i);"
puts $ipar "accuracy=$accuracy($i);"
puts $ipar "relrate=$relrate($i);"
puts $ipar "relchange=$relchange($i);"
puts $ipar "method=$method($i);"
}

close $ipar
set parfilename integrat.par
}

