/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"
#include "netcdf.h"

int main(int argc, char *argv[])
{
 char *resultname;
 name all;
 long int timnum=0;

  int i,ncid, varid,status;
  int ndims, numvars, ngatts, xdimid;
  long index[]={0};
  long end[]={80};

      unsigned int nvars;
      float startim;
      float endtim;
      float maxdelt;
      float outdelt;
      float year;
      float cycle;
      char sdir[80];


  resultname=argv[1];

  ncid=ncopen(resultname,NC_NOWRITE);

  varid = ncvarid(ncid,"varnumber");
  status= ncvarget1(ncid,varid,index,(void*) &nvars);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"starttime");
  status= ncvarget1(ncid,varid,index,(void*) &startim);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"endtime");
  status= ncvarget1(ncid,varid,index,(void*) &endtim);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"maxdelt");
  status= ncvarget1(ncid,varid,index,(void*) &maxdelt);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"outdelt");
  status= ncvarget1(ncid,varid,index,(void*) &outdelt);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"year");
  status= ncvarget1(ncid,varid,index,(void*) &year);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"cycle");
  status= ncvarget1(ncid,varid,index,(void*) &cycle);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("id=%d ",varid); */

  varid = ncvarid(ncid,"model_dir");
  status= ncvargets(ncid,varid,index,end,(long *)NULL,(void*) sdir);
  if (status != NC_NOERR) std_error("Error in readall_nc");
  sdir[80]=(char) 0;
/*   printf("id=%d\n",varid); */

  printf("%d ",nvars);
  printf("%f ",startim);
  printf("%f ",endtim);
  printf("%f ",maxdelt);
  printf("%f ",outdelt);
  printf("%f ",year);
  printf("%f ",cycle);
  printf("%s\n",sdir);

  status= nc_inq(ncid, &ndims, &numvars, &ngatts, &xdimid);
  if (status != NC_NOERR) std_error("Error in readall_nc");
/*   printf("ndims=%d,numvars=%d,ngatts=%d,xdimid=%d\n",ndims, numvars, ngatts, xdimid); */


   for (i=varid+2;i<=numvars-1;i++) {
      nc_inq_varname(ncid,i,all);
      printf("%s\n",all);
   }
 return(0);
}


