/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"
#include "netcdf.h"

int main(int argc, char *argv[])
{
 char *resultname;
 char *var;
 int casesen;

 float *dat;

  int i,ncid,varid,status;
  int ndims, numvars, ngatts, xdimid;
  long index[]={0};
  size_t start[]={0};
  size_t end[]={0};

  float startim;
  float endtim;
  float outdelt;
  float proceed;

  resultname=argv[1];
  var=argv[2];
  sscanf(argv[3],"%d",&casesen);

  ncid=ncopen(resultname,NC_NOWRITE);

  varid = ncvarid(ncid,"starttime");
  status= ncvarget1(ncid,varid,index,(void*) &startim);
  if (status != NC_NOERR) std_error("Error in readdata_nc");

  varid = ncvarid(ncid,"endtime");
  status= ncvarget1(ncid,varid,index,(void*) &endtim);
  if (status != NC_NOERR) std_error("Error in readdata_nc");

  varid = ncvarid(ncid,"outdelt");
  status= ncvarget1(ncid,varid,index,(void*) &outdelt);
  if (status != NC_NOERR) std_error("Error in readdata_nc");

  varid = ncvarid(ncid,"proceed");
  status= ncvarget1(ncid,varid,index,(void*) &proceed);
  if (status != NC_NOERR) std_error("Error in readdata_nc");

  end[0]=(int) proceed;
  dat=malloc(sizeof(float)*end[0]);

  status= nc_inq_varid(ncid, var, &varid);
  if (status != NC_NOERR) {
     printf("not_stored\n");
     return(0);
  }

  status= nc_get_vara_float(ncid,varid,start,end,dat);

  for (i=0;i<end[0];i++) printf("%.24g ",dat[i]);
  printf("\n");

 return(0);
}


