/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[]) 
{
  int mov_read_csv(char*,int,float*);
  real y1,y2,y3,y4;
  float tmp,*var1,*var2,*buf,*correl;
  int num1,num2,i,j,k,len;
  string file1,file2;
  float *dummy=NULL;

       if (argc<2) std_error("No arguments given for cross_correlation (cc0)");

        sscanf(argv[1],"%s",file1);
        sscanf(argv[2],"%s",file2);

/* Erstes File auslesen */

  /* Anzahl der Werte ermitteln    */
  num1=mov_read_csv(file1,0,dummy);
  num2=mov_read_csv(file2,0,dummy);

   len=IMAX(num1,num2);

/* Vektor zur Aufnahme der ersten Variable (es wird mit ZERO aufgefuellt) */
    var1=fvector(1,len);

/* Vektor zur Aufnahme der zweiten Variable (es wird mit ZERO aufgefuellt) */
    var2=fvector(1,len);

 /* Werte einlesen */
      if (mov_read_csv(file1,1,var1) !=num1) std_error("Error in datafile1");
      if (mov_read_csv(file2,1,var2) !=num2) std_error("Error in datafile2");

/* Ergebnisvektor anlegen */
        correl=fvector(1,len);

/* Kreuzkorrelation berechnen */

        for (j=0;j<len;j++)
        {
                correl[j+1]=0.0;
                
                for (k=0;k<len;k++)
                {
                        i=j+k;
                        while (i>len) i-=len;
                        correl[j+1]+=var1[i+1]*var2[k+1];
                } 
        }

/* Ausgabe     */
        for (j=1;j<=len;j++) printf("%f ",correl[j]);
        printf("\n");
return(0);
}
