/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include "stdinc.h"

void matr_matr_add(real **in_matrix_a,real **in_matrix_b,real **out_matrix,
			          int start_line_a,int end_line_a, int start_row_a,int end_row_a,
				  int start_line_b,int end_line_b, int start_row_b,int end_row_b)
{
/* Input :  real **in_matrix_a	Pointer to input matrix A dimension num_lines_a,num_rows_a
		real **in_matrix_b	Pointer to input matrix B dimension num_lines_b,num_rows_b
                int num_lines_a	number of columns of input matrix A
	        int num_rows_a	number of rows of input matrix A

   Output: real **out_matrix	Values are written to out_matrix dimension num_lines_a,num_rows_b

 */
int i,j,num_lines_a,num_lines_b,num_rows_a,num_rows_b;
real a,b;

num_lines_a = end_line_a - start_line_a;
num_lines_b = end_line_b - start_line_b;
num_rows_a = end_row_a - start_row_a;
num_rows_b = end_row_b - start_row_b;

if (num_lines_b != num_rows_a) std_error("Matrices A and B are not compatible");

for (j=start_row_a;j<=end_row_a;j++)
   {
   for (i=start_line_a; i<=end_line_a; i++) out_matrix[i][j] = in_matrix_a[i][j] + in_matrix_b[i][j];
    }
}


