/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[])
{
 void *readheader(FILE*,header*,int);
 void writeheader(FILE *, header*, long_name80*, int);


 char *resultname;
 char *HOME;
 string input_file,output_file;
 long int timnum;
 int i,j,k,l,n,m,namelength, namelength1;
 int num_of_years,start=1;
  long_name *all_var_names, one_name;
  string helpname;
  void *names;
  float *dat;
  real argu;
  real **all_data;

  FILE *in_file, *out_file, *transform;

  header oh1,oh2;

  namelength=sizeof(long_name80);
  oh2.sdir = malloc(sizeof(char)*namelength);

  HOME=getenv("HOME");
  resultname=argv[1];

  if (strpos(resultname,".outb") > 0) {
    namelength1 = sizeof(name12);
  } else {
    std_error("Error: Input file is not outb");
  }

  sprintf(input_file,"%s",resultname);

  /*    Ausgabenamen zusammenbauen und dabei die Extension ".outb" oder ".outc" abschneiden */
  i=strpos(resultname,".out");
  sprintf(output_file,"%s.outc",strmid(resultname,0,i));

  in_file=fopen(input_file,"rb");

  if (in_file == NULL)
  {
     std_error("Error when opening data file for reading");
  }
/* Header der Quelldatei einlesen */
  names = readheader(in_file,&oh1,namelength1);

  if (strpos(oh1.sdir,"fourier") >= 0)
  {
     start=0;
     printf("Transforming spectrum data file\n");
  }

 /*Variable-Liste fr die Ausgabedatei zusammenbauen*/
 all_var_names = (long_name*) malloc(sizeof(long_name)*oh1.nvars);
  for (i=0;i<oh1.nvars;i++)
  {
     sprintf(helpname,"%s",strmid(names,i*namelength1,namelength1));
/*      printf("%d:|%s|",i,helpname); */
     for (m=(int)strlen(helpname);m<namelength;m++) helpname[m]= (char) 32;
     sprintf(all_var_names[i],"%s",strmid(helpname,0,namelength));
/*      printf("|%s|\n",all_var_names[i]); */
  }

  timnum = (long int) (0.5+(oh1.endtim-oh1.startim)/oh1.outdelt) +1;
/*   timnum=32; */
  num_of_years = (int) (0.5+(oh1.endtim-oh1.startim)/oh1.cycle);

/* Speicherplatz fr gesamten bin�en Datenanteil reservieren ('mal sehen wie lange es geht...) */
  all_data = matrix(1,oh1.nvars,start,timnum);

/* Speicherplatz fr einen Satz */
  dat =malloc(oh1.nvars*sizeof(float));

/* Simulationsdaten einlesen */
  printf("Reading data..\n");
  fflush(stdout);
/* Hauptschleife ber alle Variablen */
   k=start;
/* Einen "Tag" einlesen */
   while(fread(dat,sizeof(float),oh1.nvars,in_file) == oh1.nvars)
   {
      for (i=1;i<=oh1.nvars;i++)
        {
        all_data[i][k] = (real) dat[i-1];
        }
   k++;
   }
   fclose(in_file);
   timnum=k-1;

  printf("Time information of input data:\n");
  printf("Starttime %f, Endtime: %f, Cycle: %f, Number of years %d, Number of time steps: %ld \n",
          oh1.startim,oh1.endtim, oh1.cycle,num_of_years,timnum);
  fflush(stdout);


/* Header fr die Ausgabedatei erzeugen */
  oh2.nvars    = oh1.nvars;
  oh2.startim  = oh1.startim;
  oh2.endtim   = oh1.endtim;
  oh2.maxdelt  = oh1.maxdelt;
  oh2.outdelt  = oh1.outdelt;
  oh2.year     = oh1.year;
  oh2.cycle    = oh1.cycle;
  strncpy(oh2.sdir,oh1.sdir,12);
  for (m=(int)strlen(oh2.sdir);m<namelength;m++) oh2.sdir[m]= (char) 32;
  oh2.sdir[namelength-1]= (char) 0;

  out_file=fopen(output_file,"wb");

 /* Header schreiben */
  writeheader(out_file,&oh2,all_var_names,namelength);

  for (j=start;j<=timnum;j++)
     {
     for (i=1;i<=oh2.nvars;i++) dat[i-1] = (float) all_data[i][j];
     fwrite(&dat[0],sizeof(float),oh2.nvars,out_file);
     }

  fclose(out_file);

  printf("Ready\n");

}
