/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

real stddev(real *in_vector,real mean,int start_ind, int end_ind)
{
/* Input :  real *in_vector		Pointer to input vector dimension vec_len

   Output: real std_dev
*/
int i;
int vec_len;
real std_dev,a;

vec_len      = end_ind - start_ind +1;
if (vec_len  < 2) std_error("STDDEV: Input vector has length below 2");

std_dev = (real) 0.0;

for (i=start_ind; i<=end_ind; i++)
    {
    a = in_vector[i];
    std_dev += ((a - mean) * (a- mean));
    }

std_dev  /= (real) (vec_len-1);

a = pow(std_dev,0.5);

return(a);
}

