/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"
int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
 void *readheader(FILE*,header*,int);
 header oh;
 char *resultname;
 char *var;
 long int timnum;
 int i,namelength;
 int pos=-1;
 int casesen;
 int first,last;
 float ymin=1.0e15;
 float ymax=-1.0e15;
 float yrange;
 float colmin,colmax,colrange;
 float factor,value;

  void *all;
  float *dat=NULL;
  FILE *unit;
  string help;

  resultname=argv[1];
  var=argv[2];
  sscanf(argv[3],"%d",&casesen);
  sscanf(argv[4],"%d",&first);
  sscanf(argv[5],"%d",&last);
  sscanf(argv[6],"%f",&ymin);
  sscanf(argv[7],"%f",&ymax);
  sscanf(argv[8],"%f",&colmin);
  sscanf(argv[9],"%f",&colmax);


  unit=fopen(resultname,"rb");
 if (unit != NULL)
 {
   if (strpos(resultname,".outb") > 0) {
      namelength = sizeof(name12);
   } else {
      namelength = sizeof(long_name80);
   }
   all = readheader(unit,&oh,namelength);

  timnum = (long int)(1.+(oh.endtim-oh.startim)/oh.outdelt);

  dat = malloc(sizeof(float)*oh.nvars);

  yrange = ymax - ymin;
  colrange = colmax -colmin;
  if (fabs(yrange) <= fabs(ymax*1e-10)) yrange = 1;
  factor=colrange/yrange;

  for (i=0;i<oh.nvars;i++)
  {
     strncpy(help,strmid(all,i*namelength,namelength),namelength);
     help[namelength]=(char) 0;

     if (casesen == 0) sprintf(help,"%s",strtolower(help));

     if (strpos(help,var) == 0)
     {
       pos=i;
       break;
     }
     else pos=-1;
  }


  if (pos>=0) {
     for (i=0;i<timnum;i++)
     {
       fread(dat,sizeof(float),oh.nvars,unit);
       if (i>=first && i<=last) {
         value=colmax - (dat[pos]-ymin)*factor;
         value=FMAX(colmin,FMIN(value,colmax));
         printf("%d ",(int) value);
       }
     }
     printf("\n");
  }
  else printf("not_stored\n");

  fclose(unit);
 }
else
  printf("Error in readfast \n");

 free(all);
 free(dat);
 return(0);
}


