/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[])
{
 void *readheader(FILE*,header*,int);
 header oh;
 char *resultname;
 char *var;
 long int i, timnum;
 unsigned int t;
 int pos,namelength;
 int casesen;
 int harm,numharm;
 int eval_harm;
 int first,last;
 float sum,t_synth,timewin;
 float ymin=1.0e15;
 float ymax=-1.0e15;

  void *all;
  float *dat, *coeff;
  FILE *unit;
  string help;

  resultname=argv[1];
  var=argv[2];
  sscanf(argv[3],"%d",&casesen);
  sscanf(argv[4],"%d",&harm);
  sscanf(argv[5],"%d",&first);
  sscanf(argv[6],"%d",&last);

  unit=fopen(resultname,"rb");
  if (unit != NULL)
  {
   if (strpos(resultname,".outb") > 0) {
      namelength = sizeof(name12);
   } else {
      namelength = sizeof(long_name80);
   }
  all = readheader(unit,&oh,namelength);
  numharm = oh.maxdelt;
  timewin = (oh.endtim - oh.startim)/oh.outdelt;
  timnum  = (long int) (0.5 + timewin);

/*   für Kompatibilität mit alten pk-Files */
  if (oh.year < 1.0) oh.year = 1.0;

  dat = malloc(sizeof(float)*oh.nvars);
  coeff = malloc(sizeof(float)*(numharm+1));

  for (i=0;i<oh.nvars;i++)
  {
     strncpy(help,strmid(all,i*namelength,namelength),namelength);
     help[namelength]=(char) 0;

     if (casesen == 0) sprintf(help,"%s",strtolower(help));

     if (strpos(help,var) == 0)
     {
       pos=i;
       break;
     }
     else pos=-1;
  }

  if (pos>=0) {
     for (i=0;i<=numharm;i++)
     {
       fread(dat,sizeof(float),oh.nvars,unit);
       coeff[i]=dat[pos];

     }
     eval_harm = numharm/2-1;
     if (harm!=0) eval_harm = IMIN(harm,eval_harm);

     for (t=0;t<=timnum;t++)
     {
       if (t>=first && t<=last)
       {
         sum=coeff[0];
         for (i=1;i<eval_harm;i++)
         {
            t_synth= 2.0*M_PI*((t*i))*oh.outdelt/(oh.year*oh.cycle);
            sum += coeff[2*i-1]*cos(t_synth)+coeff[2*i]*sin(t_synth);
         }
         ymin=FMIN(ymin,sum);
         ymax=FMAX(ymax,sum);

       }
     }
     printf("%.24g ",ymin);
     printf("%.24g\n",ymax);
  }
  else printf("not_stored\n");

  fclose(unit);
 }
else
  printf("Error in readminmax_pk \n");

 free(coeff);
 free(all);
 free(dat);
 return(0);
}


