# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Custom procedure called from mov
#########################################
proc customtool {} {
global preferences	
global moviehome pwd
global can
global filename
global toolflag data

global defaultresult2 defaultresult3
global defaultdata
global defaultdatadir
global defaultcas
global defaultboxfont
global defaultplotfont
global defaultxax
global defaultcan
global iconsize
global colorscheme plotcolorlist movplotcols

# Font Settings
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global boxFont textFont buttonFont
global filenum remembertool

if [winfo exist .custom] {destroy .custom}
toplevel .custom
wm title .custom {Tiger Graphics MoViE Options}
wm geometry .custom "+300+150"
wm attributes .custom -topmost yes

#wm protocol .custom WM_DELETE_WINDOW exit
#wm iconbitmap .custom @$moviehome/icons/tinylogo.pic
#wm sizefrom .custom user

#if [winfo exist .dummy ] {destroy .dummy}
#set canvas .dummy

set defaultresult2 ""
set defaultresult3 ""
set defaultdatadir ""
set defaultdata(1)   ""
set defaultdata(2)   ""
set defaultdata(3)   ""
set defaultdata(4)   ""
set defaultdata(5)   ""
set defaultcas 0
set remembertool 0
set defaultxax 0
set defaultcan $can
set iconsize ""

readdefaults

set pady 5
set width 50

set sfs [lindex [split $boxFont " "] 1]
set bfs [lindex [split $buttonFont " "] 1]
set tfs [lindex [split $textFont " "] 1]
set pnfs [lindex [split $plotFontN " "] 1]
set psfs [lindex [split $plotFontS " "] 1]
set ptfs [lindex [split $plotFontT " "] 1]

# Initializing of the buttons
##############################
frame .custom.button
pack .custom.button -side bottom

button  .custom.button.reset -text {Reset to Defaults} -command {
    if {$preferences=="global"} {
		file copy -force $moviehome/tkmovie5defaults $home/.config
	} else {
		file copy -force $moviehome/tkmovie5defaults $pwd/.tkmovie5defaults
	}
    readdefaults
    destroy .custom
	destroytool
	tools
	createcontrol
}
pack  .custom.button.reset -side left

button  .custom.button.cancel  -font $buttonFont -text {  Cancel } -command {readdefaults; destroy .custom}
pack  .custom.button.cancel -side left

button  .custom.button.exit  -font $buttonFont -text {Apply & Exit} -command {
#    if [info exists filename(2)] {unset filename(2)}
#    if [info exists filename(3)] {unset filename(3)}
#	set filenum -1
    writedefaults
    readdefaults
    destroy .custom
	destroytool
	tools
	createcontrol
}
pack  .custom.button.exit -side left

#~ frame .custom.c1
#~ pack .custom.c1 -pady 0

#~ label .custom.c1.result2text -text "Default Resultfile 2" -font $buttonFont
#~ pack .custom.c1.result2text -side left -pady $pady

#~ entry .custom.c1.result2 -width $width -bd 2 -textvariable defaultresult2 -font $buttonFont
#~ pack  .custom.c1.result2 -side left

#~ button  .custom.c1.sresult2 -text {  Search  } -font $buttonFont \
#~ -command { set defaultresult2 [fileselect  "Select result file" outb $pwd open] }
#~ pack  .custom.c1.sresult2 -side left

#~ button  .custom.c1.empty -text {  Empty  } -font $buttonFont -command { set defaultresult2 "";corr_defaultres}
#~ pack  .custom.c1.empty -side left

#############################
#~ frame .custom.c2
#~ pack .custom.c2  -pady {0 5}

#~ label .custom.c2.result3text  -font $buttonFont -text "Default Resultfile 3"
#~ pack .custom.c2.result3text -side left  -pady $pady

#~ set t [entry .custom.c2.result3 -width $width -textvariable defaultresult3 -font $buttonFont]
 #~ pack  .custom.c2.result3 -side left

 #~ button  .custom.c2.sresult3  -font $buttonFont -text {  Search  } \
#~ -command {set defaultresult3 [fileselect  "Select result file" outb $pwd open];corr_defaultres}
#~ pack  .custom.c2.sresult3 -side left

#~ button  .custom.c2.empty -text {  Empty  }  -font $buttonFont -command {set defaultresult3 ""}
#~ pack  .custom.c2.empty -side left


##############################
# frame .custom.c30
# pack .custom.c30 -pady {0 5}
# 
# label .custom.c30.l1  -font $buttonFont -text "Settings for Data"
# pack .custom.c30.l1 -side left -pady $pady

frame .custom.c31
pack .custom.c31 -pady {0 5}

label .custom.c31.dt  -font $buttonFont -text "Default Data Dir"
pack .custom.c31.dt -side left -pady $pady

set t [entry .custom.c31.datadir -width $width -textvariable defaultdatadir -font $buttonFont]
pack  .custom.c31.datadir -side left

button  .custom.c31.sdatadir  -font $buttonFont -text {  Search  } \
-command { set defaultdatadir [dirselect  "Select Data Dir"  ~] }
 pack  .custom.c31.sdatadir  -side left

button  .custom.c31.empty  -font $buttonFont -text {  Empty  } \
-command "set defaultdatadir \"\";corr_defaultdata"
pack  .custom.c31.empty  -side left
##############################


for {set i 1} {$i<=5} {incr i} {

frame .custom.c4$i
pack .custom.c4$i -pady {0 5}

label .custom.c4$i.datatext  -font $buttonFont -text "Default Datafile $i"
pack .custom.c4$i.datatext -side left -pady $pady

set t [entry .custom.c4$i.data -width $width -textvariable defaultdata($i) -font $buttonFont]
pack  .custom.c4$i.data -side left

button  .custom.c4$i.sdata  -font $buttonFont -text {  Search  } \
-command "set_defaultdata $i "
 pack  .custom.c4$i.sdata -side left

button  .custom.c4$i.empty  -font $buttonFont -text {  Empty  } \
-command "set defaultdata($i) \"\";corr_defaultdata"
pack  .custom.c4$i.empty  -side left

}

##############################

frame .custom.can
pack .custom.can -pady 20

label .custom.can.text  -font $buttonFont -text "Canvas Size"
pack .custom.can.text -side left -pady {0 5}
foreach item "400 600 800 1000 1200 1600" {
	radiobutton .custom.can.$item  -font $buttonFont -variable defaultcan -text "$item\x$item"  -value $item
	pack .custom.can.$item -side left -pady 2
}
##############################

frame .custom.remember
pack .custom.remember -padx {150 0} -fill x -pady 2 

label .custom.remember.text  -font $buttonFont -text "Remember Last Tool"
pack .custom.remember.text -side left -pady 2

radiobutton .custom.remember.yes  -font $buttonFont -variable remembertool \
              -text yes  -value 1

radiobutton .custom.remember.no  -font $buttonFont -variable remembertool \
              -text no  -value 0

pack .custom.remember.yes -side left -pady 2
pack .custom.remember.no -side left -pady 2


frame .custom.cas
pack .custom.cas -padx {150 0} -fill x -pady 2 

label .custom.cas.text  -font $buttonFont -text "Case Sensitive Results"
pack .custom.cas.text -side left -pady 2

radiobutton .custom.cas.yes  -font $buttonFont -variable defaultcas \
              -text yes  -value 1

radiobutton .custom.cas.no  -font $buttonFont -variable defaultcas \
              -text no  -value 0

pack .custom.cas.yes -side left -pady 2
pack .custom.cas.no -side left -pady 2
#.custom.cas.yes configure -state disabled
frame .custom.vis
pack .custom.vis -padx {150 0} -fill x -pady 2

label .custom.vis.text  -font $buttonFont -text "X-Axis Representation"
pack .custom.vis.text -side left -pady 2


radiobutton .custom.vis.day  -font $buttonFont -variable defaultxax \
              -text Days  -value 1

radiobutton .custom.vis.num  -font $buttonFont -variable defaultxax \
              -text Numbers  -value 0

pack .custom.vis.day -side left -pady 2
pack .custom.vis.num -side left -pady 2

##############################
# Main Window button size
#~ frame .custom.main
#~ pack .custom.main -padx {150 0} -fill x -pady 2

#~ label .custom.main.text  -font $buttonFont -text "Main Window Button Size (Restart MoViE)"
#~ pack .custom.main.text -side left -pady 2


#~ radiobutton .custom.main.normal  -font $buttonFont -variable defaulticonsize \
              #~ -text Normal  -value normal

#~ radiobutton .custom.main.big  -font $buttonFont -variable defaulticonsize \
              #~ -text Big  -value big

#~ pack .custom.main.normal -side left -pady 2
#~ pack .custom.main.big -side left -pady 2

##############################
# Color Scheme
frame .custom.color
pack .custom.color -padx {150 0} -fill x -pady 2

label .custom.color.text  -font $buttonFont -text "GUI Color Scheme"
pack .custom.color.text -side left -pady 2

set colors {classic blue grey steel}
foreach but $colors {
	radiobutton .custom.color.$but  -font $buttonFont -variable colorscheme \
              -text $but  -value $but
	pack .custom.color.$but -side left -pady 2
}

##############################
# Plot Colors
frame .custom.plotcolor
pack .custom.plotcolor -padx {150 0} -fill x -pady 2

label .custom.plotcolor.text  -font $buttonFont -text "Plot Color Scheme"
pack .custom.plotcolor.text -side left -pady 2

foreach but $movplotcols {
	radiobutton .custom.plotcolor.$but  -font $buttonFont -variable plotcolorlist \
              -text $but  -value $but
	pack .custom.plotcolor.$but -side left -pady 2
}


##############################
# Preference Policy
frame .custom.prefs
pack .custom.prefs -padx {150 0} -fill x -pady 2

label .custom.prefs.text  -font $buttonFont -text "Where to store preferences"
pack .custom.prefs.text -side left -pady 2

set preflist {global local}
foreach but $preflist {
	radiobutton .custom.prefs.$but  -font $buttonFont -variable preferences \
              -text $but  -value $but
	pack .custom.prefs.$but -side left -pady 2
}
##############################
frame .custom.fonts
pack .custom.fonts -pady {0 5}

#~ button .custom.fonts.fontsel0  -font $buttonFont -text { Select Button Font }  \
           #~ -command {set moviefont [Font_Select "Selector Buttons" $buttonFont]; if {$moviefont !=""} {set buttonFont $moviefont}}
#~ pack .custom.fonts.fontsel0 -side left


#~ button .custom.fonts.fontsel1  -font $buttonFont -text { Select Selector Button Font }  \
           #~ -command {set moviefont [Font_Select "Selector Buttons" $boxFont]; if {$moviefont !=""} {set boxFont $moviefont}}
#~ pack .custom.fonts.fontsel1 -side left

#~ button .custom.fonts.fontsel2  -font $buttonFont -text { Select Text Tool Font }  \
           #~ -command {set moviefont [Font_Select "Text Tool" $textFont]; if {$moviefont !=""} {set textFont $moviefont}}
#~ pack .custom.fonts.fontsel2 -side left

menubutton .custom.fonts.fontsel0  -relief raised -font $buttonFont -text "Button/Label Font Size: $bfs" -menu .custom.fonts.fontsel0.menu
set m [menu .custom.fonts.fontsel0.menu -tearoff 0]
foreach item "6 8 9 10 11 12 13 14 15 16 18" {
    $m add radio -label $item -font $buttonFont -variable bfs -command {set buttonFont "-size [list $bfs]"}
}    

menubutton .custom.fonts.fontsel1  -relief raised -font $buttonFont -text "Selector Button Font Size: $sfs" -menu .custom.fonts.fontsel1.menu
set m [menu .custom.fonts.fontsel1.menu -tearoff 0]
foreach item "6 8 9 10 11 12 13 14 15 16 18" {
    $m add radio -label $item -font $buttonFont -variable sfs -command {set boxFont "-size [list $sfs]"}
}    

menubutton .custom.fonts.fontsel2  -relief raised -font $buttonFont -text "Text Tool Font Size: $tfs" -menu .custom.fonts.fontsel2.menu
set m [menu .custom.fonts.fontsel2.menu -tearoff 0]
foreach item "6 8 9 10 11 12 13 14 15 16 18" {
    $m add radio -label $item -font $buttonFont -variable tfs -command {set textFont "-size [list $tfs]"}
}    
pack .custom.fonts.fontsel0 -side left -padx 1
pack .custom.fonts.fontsel1 -side left -padx 1
pack .custom.fonts.fontsel2 -side left -padx 1

##############################
frame .custom.plotfonts
pack .custom.plotfonts -pady {0 5}

#~ button .custom.plotfonts.fontsel1  -font $buttonFont -text { Select Plot Font (normal)}  \
           #~ -command {set moviefont [Font_Select "Plot Font (normal)" $plotFontN]; \
	                        #~ if {$moviefont !=""} {set plotFontN $moviefont; regsub -- "-weight normal" $plotFontN "-weight bold" boldFontN}}
#~ pack .custom.plotfonts.fontsel1 -side left

#~ button .custom.plotfonts.fontsel2  -font $buttonFont -text { Select Plot Font (small)}  \
           #~ -command {set moviefont [Font_Select "Plot Font (small)" $plotFontS]; \
	   			#~ if {$moviefont !=""} {set plotFontS $moviefont; regsub -- "-weight normal" $plotFontS "-weight bold" boldFontS}}
#~ pack .custom.plotfonts.fontsel2 -side left

#~ button .custom.plotfonts.fontsel3  -font $buttonFont -text { Select Plot Font (tiny)}  \
           #~ -command {set moviefont [Font_Select "Plot Font (tiny)" $plotFontT]; \
	   			#~ if {$moviefont !=""} {set plotFontT $moviefont; regsub -- "-weight normal" $plotFontT "-weight bold" boldFontT}}
#~ pack .custom.plotfonts.fontsel3 -side left
menubutton .custom.plotfonts.fontsel1  -relief raised -font $buttonFont -text "Plot Font Size (normal): $pnfs" -menu .custom.plotfonts.fontsel1.menu
set m [menu .custom.plotfonts.fontsel1.menu -tearoff 0]
foreach item "8 9 10 11 12 13 14 15 16 18" {
    $m add radio -label $item -font $buttonFont -variable pnfs -command {set plotFontN "-size [list $pnfs] -weight normal"
																		 set boldFontN "-size [list $pnfs] -weight bold"}
}    

menubutton .custom.plotfonts.fontsel2  -relief raised -font $buttonFont -text "Plot Font Size (small): $psfs" -menu .custom.plotfonts.fontsel2.menu
set m [menu .custom.plotfonts.fontsel2.menu -tearoff 0]
foreach item "6 8 9 10 11 12 13 14" {
    $m add radio -label $item -font $buttonFont -variable psfs -command {set plotFontS "-size [list $psfs] -weight normal"
																		 set boldFontS "-size [list $psfs] -weight bold"}
}    

menubutton .custom.plotfonts.fontsel3  -relief raised -font $buttonFont -text "Plot Font Size (tiny): $ptfs" -menu .custom.plotfonts.fontsel3.menu
set m [menu .custom.plotfonts.fontsel3.menu -tearoff 0]
foreach item "4 5 6 8 9 10" {
    $m add radio -label $item -font $buttonFont -variable ptfs -command {set plotFontT "-size [list $ptfs] -weight normal"
																		 set boldFontT "-size [list $ptfs] -weight bold"}
}    

pack .custom.plotfonts.fontsel1 -side left -padx 1
pack .custom.plotfonts.fontsel2 -side left -padx 1
pack .custom.plotfonts.fontsel3 -side left -padx 1

##############################

update idletasks
}

proc set_defaultdata {i} {
global defaultdata defaultdatadir

 set defaultdata($i) [fileselect  "Select Data file" symb $defaultdatadir open ]
 corr_defaultdata
}

proc corr_defaultdata {} {
global defaultdata defaultdatadir
for {set i 1} {$i<=4} {incr i} {
 for {set j 1} {$j<=5} {incr j} {
  if {$defaultdata($j) == "" } {
     if [info exist defaultdata([expr $j+1])] {
        set defaultdata($j) $defaultdata([expr $j+1])
        set defaultdata([expr $j+1]) ""
     }
  }
 }
}
}

proc corr_defaultres {} {
global defaultresult2 defaultresult3

  if {$defaultresult2 == "" } {

     if [info exist defaultresult3] {
        set defaultresult2 $defaultresult3
        set defaultresult3 ""
     }
  }
}




