# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc animate {} {

global can ovc mf
global starttime endtime outdelt year cycle timewin
global actstart actend
global pxmin pxmax pymin pymax pxdelt pydelt
global taglist
global filmvar filmdata filmdir
global map actbox animcolor
global filmcolor colmax colmin filmmin filmmax
global plotFont boldFont
global animlen animtime
global krem
global tracer
global borders numbers markzeros
global mapname 

global fmin fmax colmin colmax

#$ovc.right.misc.start config -state normal
set c $mf.left.plot 

if [info exist krem] {unset krem}
set colrange [expr $colmax-$colmin]

if {$filmmin != ""} {set fmin $filmmin}
if {$filmmax != ""} {set fmax $filmmax}


set animlen [llength $filmdata(1)]

  for {set i 1} {$i <= $actbox} {incr i} {
  set animcolor($i) {}
  foreach item $filmdata($i) {

   if {[expr abs($item)] < 0.00000001 && $markzeros==1} {
       lappend animcolor($i) grey
   } else {
       lappend animcolor($i) $filmcolor($item)
   }
   
  }

}
set fac 1

scan [expr ($actstart(1)-$starttime(1))/$outdelt(1)] %d first
scan [expr $first +$timewin/$outdelt(1)] %d last


if {$tracer==1} {maketracer $fmin $fmax $fac $first $last}


# erasing oldtags
#-----------------
set taglist {head time bar}
erase $c $taglist

# Settings of plot

# set pxmin 80
# set pxmax [expr $can - 30]
# set pymin [expr $can - 30]
# set pymax 50

# Calculating of normalizing factor for the plot
#--------------------------

#set pxdelt [expr $pxmax -$pxmin]
#set pydelt [expr $pymax -$pymin]


# Writing header
#--------------------------
scan $actstart(1) %d animtime


   set item [$c create text 50 30 -text [makeheader $filmvar] \
                   -anchor w -font $boldFont]
   $c addtag head withtag $item


   set item [$c create text 300 30 -text "Time = $animtime" \
                   -anchor w -font $boldFont]
   $c addtag time withtag $item
   
   set item [$c create rect 300 50 400 70]
   $c addtag timebar withtag $item

   $c bind head <3> "$c delete head"
   $c bind time <3> "$c delete time"
   $c bind timebar <3> "$c delete timebar"

if {$mapname != "mapripplexxxx"} {

   # Setting up of the colorbar
   #--------------------------
   set pxl [expr $can/2]
   set pyu [expr $pymin]
   set pyo [expr $pymin-30]
   set remx $pxl

   set offset [expr $can*0.4/$colrange]

   for {set i $colmax} {$i >= $colmin} {set i [expr $i-1]} {
       set pxr [expr $pxl+$offset]
       set item [eval $c create rect $pxl $pyu $pxr $pyo \
                    {-fill $filmcolor($i) -outline $filmcolor($i)}]
       $c addtag bar withtag $item
       set pxl $pxr
   }

   set item [$c create text $remx [expr $pyu+10] -text [format %6.2f $fmin] \
                   -anchor n -font $boldFont]
   $c addtag bar withtag $item
   set item [$c create text $pxl [expr $pyu+10] -text [format %6.2f $fmax] \
                   -anchor n -font $boldFont]
   $c addtag bar withtag $item

   $c bind bar <3> "$c delete bar"

}

# Setting of first day
#--------------------------
erase $c allnum
anim1day 0
if {$borders==1} {drawoutline}
if {$numbers==1} {drawnum}

}


# Animation
#--------------------------


# animation over 1 day
######################
proc anim1day {j} {
global animlen animcolor actbox outdelt animtime actstart
global tracer borders numbers mf

if {[expr int($outdelt(1))] == $outdelt(1)} {
   scan [expr $actstart(1) + $j*$outdelt(1)] %d animtime
} else {
   set animtime [expr $actstart(1) + $j*$outdelt(1)]
}

$mf.left.plot  delete timebox
$mf.left.plot  itemconfig time -text "Time = [format %6.2f $animtime]"

set item [$mf.left.plot  create rect 300 50 [expr int(100.0/($animlen-1)*$j+301.0)] 70 -fill blue]
$mf.left.plot  addtag timebar withtag $item
$mf.left.plot  addtag timebox withtag $item

#$mf.left.plot  delete timebar

for {set i 1} {$i <= $actbox} {incr i} {
     set cc [lindex $animcolor($i) $j]
     $mf.left.plot  itemconfig drawbox($i) -fill $cc -outline $cc
}

if {$tracer==1} {animtracer $j}

if {$borders==1} {drawoutline}

# wichtig fuer den Stop-Button
update
update idletasks
}


# Full animation over animlen
##############################
proc anim {} {
global animlen filmspeed stopflag  krem
global anim_restart
global psprint gameover mapname
global moviehome iconpath
global numbers borders mf filmdir pwd

if ![info exist anim_restart] {set anim_restart 1}

#erase $mf.left.plot  allnum
if {$psprint==1} {printout film -1}
wm attributes . -topmost yes
  for {set j [expr $anim_restart-1]} {$j < $animlen} {incr j} {
    anim1day $j

    if {$mapname=="mapripple" && [file exist $moviehome/film/rippleadvect.tcl]} {advect$j}
    #drawoutline
    if {$psprint==1} {printout film $j}

    if {$filmspeed != 10} {
       after [expr int(100/$filmspeed)]
       }
    if {$stopflag ==1} {
       set krem [expr $j+1]
       set anim_restart [expr $j+1]
       set j $animlen
       set stopflag  0
    }
  }
wm attributes . -topmost no

if {$psprint==1} {
	set path $pwd/films/$filmdir
	textinfo "Computing film to $path/$filmdir.mp4"
	set command "/usr/bin/mencoder \"mf:\/\/$path\/*.png\" -mf fps=10 -o $path\/$filmdir.mp4 -ovc x264 -quiet > /dev/null 2>&1"
	catch [eval exec $command] result
    textinfo "Ready"
}  
if {$borders==1} {drawoutline}
if {$numbers==1} {drawnum}

# set krem $j
# set anim_restart $j

if {$gameover==1} {
global moviehome can
image create photo gameover -gamma 2.0 -file $iconpath/gameover.gif
set item [$mf.left.plot  create image [expr $can/2] [expr $can/2] -image gameover -anchor c]
$mf.left.plot  addtag gameover withtag $item
update
exec sleep 2
$mf.left.plot  delete gameover
}

}


# animation stepper
###################
proc animstep {m} {
global krem anim_restart animlen

if ![info exist krem] {set krem 1}

set krem [max 1 [min $animlen [expr $krem + $m]]]

set anim_restart $krem

anim1day [expr $krem - 1]
}


