# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc analysis {} {
global command
global toolflag
global plusflag minusflag timesflag timesfactor timesvarflag divflag meanflag divvarflag
global faclabel
global distance
global run runmean step sum_step stepmean stepsum calc_l2dist
global logflag sumflag autocorr
global buttonFont 
global ovc

set factor 1.00
set run 30.0
set step 1.0
set sum_step 1.0
set distance 0.0


if [winfo exist .ana] {
  raise .ana
} else {

toplevel .ana

wm title .ana {Analysis}
wm geometry .ana "+850+500"
wm group .ana $ovc
wm transient .ana $ovc

frame .ana.calc
pack .ana.calc

button .ana.calc.plus  -font $buttonFont -text {+}\
       -command {set plusflag 1}
pack .ana.calc.plus -side left

button .ana.calc.minus  -font $buttonFont -text {-}\
       -command {set minusflag 1}
pack .ana.calc.minus -side left

button .ana.calc.timesvar  -font $buttonFont -text {*}\
       -command {set timesvarflag 1}
pack .ana.calc.timesvar -side left

button .ana.calc.divvar  -font $buttonFont -text {/}\
       -command {set divvarflag 1}
pack .ana.calc.divvar -side left


frame .ana.times
pack .ana.times

set faclabel [entry .ana.times.fac  -font $buttonFont -width 10 -textvariable factor]
pack .ana.times.fac -side left

facLoad $faclabel $factor

#bind .ana.times.fac <Return> "facLoad $faclabel \$factor"
focus .ana.times.fac

button .ana.times.but  -font $buttonFont -text {*}\
       -command {set timesflag 1;facLoad $faclabel $factor}
pack .ana.times.but -side left

button .ana.times.div  -font $buttonFont -text {/}\
       -command {set divflag 1;facLoad $faclabel $factor}
pack .ana.times.div -side left

if {$toolflag == "overview" || $toolflag == "compare" || $toolflag == "phase" || $toolflag == "profile"|| $toolflag == "profcom"} {

  frame .ana.log
  pack .ana.log -fill x
  checkbutton .ana.log.but  -font $buttonFont -text {log10 y-axis}\
       -variable logflag -command {set stepmean 0;set runmean 0;set meanflag 0;set sumflag 0;interpret}
  pack .ana.log.but -side left -pady {0 5}


if {$toolflag == "overview" || $toolflag == "compare"} {
  frame .ana.mean
  pack .ana.mean -fill x
  checkbutton .ana.mean.but  -font $buttonFont -text {mean over time window}\
       -variable meanflag -command {set autocorr 0;set sumflag 0;set logflag 0;set stepmean 0;set runmean 0;interpret}
  pack .ana.mean.but -side left -pady {0 5}
}
if {$toolflag == "overview" || $toolflag == "compare"} {  
  frame .ana.runmean
  pack .ana.runmean -fill x

  checkbutton .ana.runmean.but  -font $buttonFont -text {running mean}\
       -variable runmean -command {set autocorr 0;set logflag 0;set stepmean 0;set stepsum 0;set sumflag 0;set meanflag 0;interpret}
  pack .ana.runmean.but -side left -pady {0 5}


  set runlabel [entry .ana.runmean.run -width 8  -font $buttonFont -textvariable run]
  pack .ana.runmean.run -side left
  bind .ana.runmean.run <Return> "interpret"
}


  frame .ana.stepmean
  pack .ana.stepmean -fill x

  checkbutton .ana.stepmean.but  -font $buttonFont -text {mean over}\
       -variable stepmean -command {set autocorr 0;set logflag 0;set runmean 0;set meanflag 0;set sumflag 0;set stepsum 0;interpret}
  pack .ana.stepmean.but -side left -pady {0 5}


  set steplabel [entry .ana.stepmean.step  -font $buttonFont -width 8 -textvariable step]
  pack .ana.stepmean.step -side left -fill x
  bind .ana.stepmean.step <Return> "interpret"

if {$toolflag == "overview" } {  
  frame .ana.sum
  pack .ana.sum -fill x

  checkbutton .ana.sum.but  -font $buttonFont -text {sum over time window}\
       -variable sumflag -command {set autocorr 0;set logflag 0;set runmean 0;set meanflag 0;set stepsum 0;set stepmean 0;interpret}
  pack .ana.sum.but -side left -pady {0 5}
}

  frame .ana.stepsum
  pack .ana.stepsum -fill x

  checkbutton .ana.stepsum.but  -font $buttonFont -text {sum over}\
       -variable stepsum -command {set logflag 0;set runmean 0;set meanflag 0;set sumflag 0;set stepmean 0;interpret}
  pack .ana.stepsum.but -side left -pady {0 5}


  set steplabel [entry .ana.stepsum.step -width 8  -font $buttonFont -textvariable sum_step]
  pack .ana.stepsum.step -side left -fill x
  bind .ana.stepsum.step <Return> "interpret"

}
if {$toolflag == "overview" || $toolflag == "compare"} {  
  frame .ana.autocorr
  pack .ana.autocorr -fill x

  checkbutton .ana.autocorr.but  -font $buttonFont -text {auto correlation}\
       -variable autocorr -command {set runmean 0;set logflag 0;set stepmean 0;set stepsum 0;set sumflag 0;set meanflag 0;interpret}
  pack .ana.autocorr.but -side left -pady {0 5}
}

if {$toolflag == "text"} {


  frame .ana.mean
  pack .ana.mean -fill x
  checkbutton .ana.mean.but  -font $buttonFont -text {Statistic}\
       -variable meanflag -command {set logflag 0;set stepmean 0;set runmean 0;interpret}
  pack .ana.mean.but -pady {0 5}

  frame .ana.runmean
  pack .ana.runmean -fill x
}



if {$toolflag == "compare"} {
frame .ana.l2
pack .ana.l2 -fill x
checkbutton .ana.l2.but  -font $buttonFont -text {L2 distances} -variable calc_l2dist -command {dist_control; makecommand -1 -1}
pack .ana.l2.but -side left -pady {0 5}
}


button .ana.close  -font $buttonFont -text {close}\
       -command {set meanflag 0
                 set runmean 0
		 set stepmean 0
		 set stepsum 0
		 set logflag 0
		 set autocorr 0
		 set calc_l2dist 0
                 interpret
                 destroy .ana
		 destroy .dist
		 destroy .dv
		 destroy $ovc.right.windos.ana
                 $ovc.right.misc.ana configure -state normal
                } 
pack .ana.close
}





}

proc facLoad {w ff} {
global timesfactor

$w delete 0 end
$w insert 0 $ff
set timesfactor $ff
}


