# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc itemMark {c x y} {
    global areaX1 areaY1
    set areaX1 [$c canvasx $x]
    set areaY1 [$c canvasy $y]
    #$c delete area
}

proc itemStroke {c x y} {
    global areaX1 areaY1 areaX2 areaY2
    set x [$c canvasx $x]
    set y [$c canvasy $y]
    if {($areaX1 != $x) && ($areaY1 != $y)} {
	$c delete area
	$c addtag area withtag [$c create rect $areaX1 $areaY1 $x $y \
		-outline green]
	set areaX2 $x
	set areaY2 $y
    }
}
proc itemLine {c x y} {
    global areaX1 areaY1 areaX2 areaY2
    set x [$c canvasx $x]
    set y [$c canvasy $y]
    if {($areaX1 != $x) && ($areaY1 != $y)} {
	$c delete area
	$c addtag area withtag [$c create line $areaX1 $areaY1 $x $y \
		-fill black -width 1 -arrow last]
	set areaX2 $x
	set areaY2 $y
    }
}


#######################################################
proc handleConfigEvent {w x y} {

global wx wy

set top [winfo toplevel $w]
if {$w ne $top} return

set geo [split [wm geometry .] +]
set nx [lindex $geo 1]
set ny [lindex $geo 2]

set dx [expr $nx-$wx]
set dy [expr $ny-$wy]

set wx $nx
set wy $ny

foreach item [toplist] {
   if {$item ne $top && $item ne "."} {
      set geo [split [wm geometry $item] +]
      set nx [expr [lindex $geo 1]+$dx]
      set ny [expr [lindex $geo 2]+$dy]
   
      wm geometry $item [lindex $geo 0]+$nx+$ny
   }
}

}

#######################################################

proc toplist {{W .}} {

   set list {}

   if { [string equal [winfo toplevel $W] $W] } {
     lappend list $W
   }

   foreach w [winfo children $W] {
     if {[winfo class $w] ne "Menu"} {
     set list [concat $list [toplist $w]]
     }
   }

   return $list

 }

#######################################################
#######################################################




