# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc erase {w tag} {
foreach thing $tag {
  $w delete $thing
  $w dtag $thing
}
}

proc legendDown {w x y g} {
    global leg
   
    $w dtag selected
    $w addtag selected withtag $g
    $w raise current
    set leg(lastX) $x
    set leg(lastY) $y
}

proc legendMove {w x y} {
    global leg

    $w move selected [expr $x-$leg(lastX)] [expr $y-$leg(lastY)]
    set leg(lastX) $x
    set leg(lastY) $y

}

proc xlineDown {w x y} {
global pxmin pxmax lastX lastY xmin ymin 
global toolflag sc gc
global blue_ymin blue_ymax

   set item [$w create line $pxmin $y $pxmax $y -fill blue]
   $w addtag xline withtag $item

   if {$toolflag=="overview" || $toolflag=="compare" || ($toolflag=="phase" && $sc($gc)<2)} {
     set item [$w create rect [expr $pxmin-10]  [expr $y-10] [expr $pxmin-50] [expr $y+10] -fill white -outline white]
     $w addtag xline withtag $item
     if {$toolflag=="phase"} {
         set item [$w create text [expr $pxmin-10]  $y  -fill blue -text [format "%10.3g" [invnny $y $blue_ymin]] -anchor e]
     } else {
         set item [$w create text [expr $pxmin-10]  $y  -fill blue -text [format "%10.3g" [invnnyj $y 0]] -anchor e]
     }
     $w addtag xline withtag $item
     $w addtag xlinetext withtag $item
   }
    set lastX [$w canvasx $x]
    set lastY [$w canvasy $y]
}

proc xlineMotion {w x y} {
global lastX lastY xmin ymin
global toolflag sc gc
global blue_ymin blue_ymax

    set x [$w canvasx $x]
    set y [$w canvasy $y]
#    $w move xline [expr $x-$lastX] [expr $y-$lastY]
    $w move xline 0 [expr $y-$lastY]
   if {$toolflag=="overview" || $toolflag=="compare" || ($toolflag=="phase" && $sc($gc)<2)} {
     if {$toolflag=="phase"} {
         $w itemconfig xlinetext -text [format "%10.3g" [invnny $y $blue_ymin]] -anchor e
     } else {
         $w itemconfig xlinetext -text [format "%10.3g" [invnnyj $y 0]] -anchor e
   }
   }
    set lastX $x
    set lastY $y
}

proc xlineRelease {w} {
  $w delete xline
  $w dtag xline
}


proc ylineDown {w x y} {
global pymin pymax lastX lastY
global toolflag sc gc

   set item [$w create line $x $pymin $x $pymax -fill blue]
   $w addtag yline withtag $item

   if {$toolflag=="overview" || $toolflag=="compare" || ($toolflag=="phase" && $sc($gc)<2)} {
   set item [$w create rect [expr $x-25]  [expr $pymin+20] [expr $x+25] [expr $pymin+5] -fill white -outline white]
   $w addtag yline withtag $item
   set item [$w create text $x [expr $pymin+10]  -fill blue -text [format "%6.2f" [invnnx $x]] -anchor n]
   $w addtag yline withtag $item
   $w addtag ylinetext withtag $item
   }
    set lastX [$w canvasx $x]
    set lastY [$w canvasy $y]
}

proc ylineMotion {w x y} {
    global lastX lastY
    global toolflag sc gc
    set x [$w canvasx $x]
    set y [$w canvasy $y]
#    $w move xline [expr $x-$lastX] [expr $y-$lastY]
    $w move yline [expr $x-$lastX] 0

     if {$toolflag=="overview" || $toolflag=="compare" || ($toolflag=="phase" && $sc($gc)<2)} {
         $w itemconfig ylinetext -text [format "%6.2f" [invnnx $x]] -anchor n
     }   
    set lastX $x
    set lastY $y
}

proc ylineRelease {w} {
  $w delete yline
  $w dtag yline
}


proc ylineDown_spec {w x y} {
global pymin pymax lastX lastY
   set item [$w create line $x $pymin $x $pymax -fill blue]
   $w addtag yline withtag $item

   set item [$w create rect [expr $x-25]  [expr $pymin+20] [expr $x+25] [expr $pymin+5] -fill white -outline white]
   $w addtag yline withtag $item
   set item [$w create text $x [expr $pymin+10]  -fill blue -text [formatspec [invnnx $x]] -anchor n]
   $w addtag yline withtag $item
   $w addtag ylinetext withtag $item

    set lastX [$w canvasx $x]
    set lastY [$w canvasy $y]
}

proc ylineMotion_spec {w x y} {
    global lastX lastY
    set x [$w canvasx $x]
    set y [$w canvasy $y]
#    $w move xline [expr $x-$lastX] [expr $y-$lastY]
    $w move yline [expr $x-$lastX] 0
    $w itemconfig ylinetext -text [formatspec [invnnx $x]] -anchor n
    set lastX $x
    set lastY $y
}

proc entercanvas {x y}  {
 textinfo "[invnnx $x] [invnnyx $y]"
}

