# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc command {} {
global command comlab comname moviehome comanz
global modeflag
global maxgraph
global buttonFont
global ovc

set comanz [expr $maxgraph+1]

if [winfo exist .com] {
  raise .com
} else {

toplevel .com

wm title .com {Command Control}
wm geometry .com "+850+650"
wm group .com $ovc
wm transient .com $ovc

set modeflag 0

frame .com.file
pack .com.file  -anchor w

button .com.file.load  -font $buttonFont -text {Load}\
       -command {LoadCom}
pack .com.file.load -side left

button .com.file.save  -font $buttonFont -text {Save}\
       -command {SaveLastCom;SaveCom}
pack .com.file.save -side left

button .com.file.close  -font $buttonFont -text {Close}\
       -command {SaveLastCom;destroy .com; $ovc.right.misc.com configure -state normal}
pack .com.file.close -side left

frame .com.mode
pack .com.mode -anchor w

label .com.mode.label  -font $buttonFont -text {Selected Mode}
pack .com.mode.label -side left


radiobutton .com.mode.rec  -font $buttonFont -text {Recall}\
       -variable modeflag -value 0
pack .com.mode.rec -side left

radiobutton .com.mode.save  -font $buttonFont -text {Store}\
       -variable modeflag -value 1
pack .com.mode.save -side left

button .com.mode.all  -font $buttonFont -text {All}\
       -command {ReSetAll} 
pack .com.mode.all -side left



for {set i 1} {$i<=$comanz} {incr i} {
  frame .com.e$i
  pack .com.e$i

  button .com.e$i.b$i  -font $buttonFont -text $i\
       -command "ReSetCommand $i" 
  pack .com.e$i.b$i -side left
  
  
  bind .com.e$i.b$i <2> {tkButton3Down %W}
  bind .com.e$i.b$i <ButtonRelease-2> \
              "set newset 1;ReSetCommand $i;tkButton3Up %W"


  bind .com.e$i.b$i <3> {tkButton3Down %W}
  bind .com.e$i.b$i <ButtonRelease-3> \
              "set newgraph 1;ReSetCommand $i;tkButton3Up %W"


  entry .com.e$i.e$i -width 40  -font $buttonFont  -relief sunken \
        -textvariable comlab($i)
  pack .com.e$i.e$i -side left

}

if ![info exists comname] {
#   set comname $moviehome/defaults/empty.mcf
   LoadLastCom
}
ReadCom $comname
}
}

proc ReadCom {name} {
global comlab


set ff [open $name]
set i 1
while {[gets $ff line] >=0} {
  set comlab($i) $line
  incr i
}
close $ff
}


proc LoadCom {} {
global pwd moviehome comname

set comname [fileselect "Select MoViE command file" mcf $pwd open]

if { ![file exists $comname]  || $comname =={}} {
   set comname $moviehome/defaults/empty.mcf
}
ReadCom $comname
}

proc LoadLastCom {} {
global pwd moviehome comname

set file ""
if [file exists ~/.tkmoviemcf] {set comname ~/.tkmoviemcf}
if [file exists $pwd/.tkmoviemcf] {set comname $pwd/.tkmoviemcf}
if ![info exist comname] {set comname ""}

if { ![file exists $comname]  || $comname ==""} {
   set comname $moviehome/defaults/empty.mcf
}

ReadCom $comname
}

proc SaveCom {} {
global pwd moviehome
global comlab comanz

set name [fileselect "Select MoViE command file" mcf $pwd save]

if {[file extension $name] != ".mcf"} {set name $name.mcf}

set ff [open $name w 0755]

for {set i 1} {$i <= $comanz} {incr i} {
   puts $ff $comlab($i)
}
close $ff
}

proc SaveLastCom {} {
global pwd moviehome
global comlab comanz

if [info exists comlab] {
  set name $pwd/.tkmoviemcf

  set ff [open $name w 0755]

  for {set i 1} {$i <= $comanz} {incr i} {
     puts $ff $comlab($i)
  }
  close $ff
}
}


proc ReSetCommand j {
global command comlab gc sc comanz ovc
global newgraph maxgraph maxset newset
global modeflag
global cvarrem cboxrem

set cpl $ovc.left
set cpr $ovc.right

if {$modeflag == 0} {

   set help $comlab($j)

   if {[string first empty $help] == -1 && [string length $help] !=0} {
      if {$newgraph == 1} {set gc [expr $gc+1];set newgraph 0}
      
      if {$newset==1} {
        set newset 0
	    lappend command($gc) $help

      } else {
        set command($gc) $help
      }
      

      set sc($gc) [expr [llength $command($gc)] -1]
      if {$gc >0} {
         $cpl.graph.erasegraph configure -state normal
         $cpl.graph.eraseallgraphs configure -state normal
      }
      if {$gc >= $maxgraph} {$cpl.graph.newgraph configure -state disabled}
      if {$sc($gc) > 0} {
         if [winfo exists $cpl.set.eraseset] {
            $cpl.set.eraseset configure -state normal}
         if [winfo exists $cpl.set.eraseallsets] {
            $cpl.set.eraseallsets configure -state normal}
      }
      if {$sc($gc) >= $maxset} {if [winfo exists $cpl.set.newset] {
                                 $cpl.set.newset configure -state disabled}}

      set last [lindex $command($gc) end]
      regsub -all {[(][0-9]+[)]} $last "" cvarrem
      regsub -all {[A-Za-z0-9_]+[(]} $last "" abox
      regsub -all {[)]} $abox "" cboxrem
      
      interpret
   } 
} else {
   set comlab($j) $command($gc)
   set modeflag 0
}
}

proc ReSetAll {} {
global modeflag gc newgraph command comlab comanz
if {$modeflag == 0} {
   set gc -1
   for {set i 1} {$i<=$comanz} {incr i} {set newgraph 1; ReSetCommand $i}
   set newgraph 0
} else {
   for {set i 0} {$i<=$gc} {incr i} {
      set comlab([expr $i+1]) $command($i)
   }
   for {set i [expr $gc+2]} {$i<=$comanz} {incr i} {
      set comlab($i) empty
   }
   set modeflag 0
} 
}


