# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc nx {x mi ma} {
global pxmin pxdelt

return [expr {$pxmin+($x-$mi)*$pxdelt/($ma-$mi)}]
}

proc ny {y mi ma} {
global pymin pydelt

return [expr {$pymin+($y-$mi)*$pydelt/($ma-$mi)}]
}


proc nnx {x} {
global xmin xdelt pxmin pxdelt
if {$x!=""} {
return [expr {$pxmin+($x-$xmin)*1.0*$pxdelt/(1.0*$xdelt)}]
} else {
   textinfo "Formatting error"
   return 999
}
}

proc nnxj {x j} {
global xmin xdelt pxmin pxdelt
return [expr {$pxmin+($x-$xmin($j))*$pxdelt/$xdelt}]
}

proc nnyj {y j} {
global ymin ydelt pymin pydelt

if {$y!=""} {
 return [expr {$pymin+($y-$ymin($j))*$pydelt/$ydelt}]
} else { 
   textinfo "Formatting error"
   return 999
}

}

proc nny {y} {
global ymin ydelt pymin pydelt
return [expr {$pymin+($y-$ymin)*$pydelt/$ydelt}]
}

proc nnyx {y} {
global ymin ymax ydelt pymin pydelt xdelt pxdelt
#return [nny [expr $ymax-$y*$ydelt/$xdelt]]
return [nny [expr $ymin+$y*1.0*$ydelt/(1.0*$xdelt)]]
}

proc nnx0 {x} {
global xdelt pxdelt
return [expr $x*$pxdelt/$xdelt]
}
proc nny0 {y} {
global ydelt pydelt
return [expr $y*$pydelt/$ydelt]
}

proc invnnx {x} {
global xmin xdelt pxmin pxdelt
return [expr {($x-$pxmin)*$xdelt/$pxdelt+$xmin}]
}

proc invnny {y ymin} {
global ydelt pymin pydelt
return [expr {($y-$pymin)*$ydelt/$pydelt+$ymin}]
}

proc invnnyx {y} {
global ymin xdelt ydelt pymin pydelt
return [expr {($y-$pymin)*$xdelt/$pydelt}]
}


proc invnnyj {y j} {
global ymin ydelt pymin pydelt
return [expr {($y-$pymin)*$ydelt/$pydelt+$ymin($j)}]
}


proc formatspec {a} {
global outdelt startharm

scan [expr $a/$outdelt(1)] %d i

if {$i==0} {return ""}

if {$startharm>0} {set i [expr $i - 1]}
if {[expr $i/2.0]== [expr int($i/2)]} {
   return "b[expr $i/2]"
} else { 
   return "a[expr int($i/2)+1]"
}

}



proc scalepolygon {polygon} {

set switch 0

   foreach item $polygon {
     if {$switch==0} {
        set switch 1
        append newpolygon  " [nnx $item] "
     } else {
        set switch 0
        append newpolygon " [nnyx $item] "
     }
   }
return $newpolygon
}



proc scalepolygon_2 {polygon} {

global xdelt ydelt ymax
   set switch 0

   foreach item $polygon {
     if {$switch==0} {
        set switch 1
        append newpolygon  " [nnx $item] "
     } else {
        set switch 0
        append newpolygon " [nny [expr $ymax-$item*$ydelt/$xdelt]] "
     }
   }
return $newpolygon
}



proc split_xylist {polygon a} {
   
   if {$a=="x"} {set switch 0} else {set switch 1}

   foreach item $polygon {
     if {$switch==0} {
        set switch 1
        append newpolygon  " $item "
     } else {
        set switch 0
     }
   }
return $newpolygon

}


