# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc interpret {{extract "YES"}} {
global command line
global meanflag sumflag
global gc gl can sc
global scalefacX scalefacY scaleX scaleY vertoff
global sameaxis
global filename
global toolflag
global valu dataname valushow
global singleresult result
global maxfiles datalist multiset
global runmean
global calc_l2dist 
global pwd
global ovc mf DOS

global setapply apply

if {$apply==0} {return}
if {$setapply==0} {set apply 0}

# Settings for multiple graphs
#----------------------------
graphsettings
switch $toolflag {

overview {
          erase $mf.left.plot  $gl

          extract_result 1
          for {set i 0} {$i<= $gc} {incr i} {
             eval_slid $i 1
             calc_ext $i
          }


          if {$sameaxis == 1} {calc_glob_ext}



	  for {set i 0} {$i<= $gc} {incr i} {
             if {$meanflag == 0 && $sumflag==0}  "plot $i"
             if {$meanflag == 1}  "meanplot $mf.left.plot  $i Mean"
             if {$sumflag==1}  "meanplot $mf.left.plot  $i Sum"


             if {$gc > 0} {
                set sX [lindex $scaleX $i]
                set sY [lindex $scaleY $i]
                $mf.left.plot  scale [lindex $gl $i] 0 20 $scalefacX $scalefacY
                $mf.left.plot  move [lindex $gl $i] $sX $sY
             }
          }
         }
phase    {

          erase  $mf.left.plot  all
          extract_result 1

          for {set i 0} {$i<= $gc} {incr i} {
             set len [llength $command($i)]
             if {$len==3 && $DOS==2} {
				 textinfo "3D-Plot with GnuPlot is not available on MacOS"
				 set eraseset 1
				 set len 2
		     } 
             eval_slid $i 1
         
         switch $len {
         1 {
                 calc_ext $i
	             plot $i
               }
	     2
	       {
                 phaseplot $i 
               }
	     3
	       {
                 if ![file exists $pwd/plots] {exec \mkdir $pwd/plots}
                 set id [open $pwd/plots/gnutemp_phase.dat w]
                 for {set k 0} { $k < [llength $singleresult([lindex $command($i) 0])]} {incr k} {
                     puts $id "[lindex $singleresult([lindex $command($i) 0]) $k] \
		               [lindex $singleresult([lindex $command($i) 1]) $k] \
			       [lindex $singleresult([lindex $command($i) 2]) $k]"
		}

		close $id
		angleslider $i
	       }
        }

             if {$gc > 0} {
                set sX [lindex $scaleX $i]
                set sY [lindex $scaleY $i]
                $mf.left.plot  scale [lindex $gl $i] 0 20 $scalefacX $scalefacY
                $mf.left.plot  move [lindex $gl $i] $sX $sY
             }
          }
         }
compare {
          if {$calc_l2dist == 1} {pk_distances}
          if {$valu==1} {
	     foreach a $datalist {
	       if {$valushow($a)==1} {
                  for {set i 0} {$i<= $gc} {incr i} {
                    set item [string tolower [lindex $command($i) 0]]
                    readvalu $a $i $item
                  }
               }
	     }
          }
          erase  $mf.left.plot  $gl


          for {set i 0} {$i<= $gc} {incr i} {
	      if {$multiset==0} { set command($i) [lindex $command($i) 0];set sc($i) 0}
              prep_com $i
          }
          
	  if {$sameaxis == 1} {calc_glob_ext}

          for {set i 0} {$i<= $gc} {incr i} {
             if {$meanflag == 0}  "compplot $i"
             if {$meanflag == 1}  "compmean $i"

             if {$gc > 0} {
                set sX [lindex $scaleX $i]
                set sY [lindex $scaleY $i]
                $mf.left.plot  scale [lindex $gl $i] 0 20 $scalefacX $scalefacY
                $mf.left.plot  move [lindex $gl $i] $sX $sY
             }
          }
         }
text {
          for {set i 0} {$i<= $gc} {incr i} {
	   set command($i) [lindex $command($i) 0]
	   set sc($i) 0
	   prep_text $i
          }

          for {set i 0} {$i<= $gc} {incr i} {
              if {$runmean==1} {running_mean $i 1}
              if {$meanflag == 0}  "textplot $i"
              if {$meanflag == 1}  "textmean $i"
          }
          if [info exist line] {unset line}
    }

film {
          if [extract_filmdata] {
          animate
          }
     }

profile {
          erase $mf.left.plot  $gl

          if {$extract == "YES"} {
              extract_profdata 1
          }
          for {set i 0} {$i<= $gc} {incr i} {
              eval_prof_slid $i
              calc_prof_ext $i
          }

          if {$sameaxis == 1} {calc_glob_prof_ext}
          #corrlayer

          for {set i 0} {$i<= $gc} {incr i} {
             if {$meanflag == 0}  "prof_plot $i"
             #if {$meanflag == 1}  "mean_prof_plot $mf.left.plot  $i"

             if {$gc > 0} {
                set sX [lindex $scaleX $i]
                set sY [lindex $scaleY $i]
                $mf.left.plot  scale [lindex $gl $i] 0 20 $scalefacX $scalefacY
                $mf.left.plot  move [lindex $gl $i] $sX $sY
             }
          }


        }

profcom {
	  erase $mf.left.plot  $gl

         for {set i 0} {$i<= $gc} {incr i} {
	     set command($i) [lindex $command($i) 0]
	     set sc($i) 0
             prep_profcom $i $extract
          }

          if {$valu==1 && $extract=="YES"} {
	     foreach a $datalist {
                for {set i 0} {$i<= $gc} {incr i} {
		   prep_profvalu $a $i
                   calc_valu_ext $a $i
                }
	     }
          }

          if {$valu==1 && $extract!="YES"} {
	     foreach a $datalist {
              for {set i 0} {$i<= $gc} {incr i} {
                   calc_valu_ext $a $i
                }

	     }
          }

	  if {$sameaxis == 1} {calc_glob_prof_ext}
          #corrlayer

          for {set i 0} {$i<= $gc} {incr i} {
             if {$meanflag == 0}  "profcom_plot $i"
            # if {$meanflag == 1}  "mean_profcom_plot $mf.left.plot  $i"

             if {$gc > 0} {
                set sX [lindex $scaleX $i]
                set sY [lindex $scaleY $i]
                $mf.left.plot  scale [lindex $gl $i] 0 20 $scalefacX $scalefacY
                $mf.left.plot  move [lindex $gl $i] $sX $sY
             }
          }


        }


contour {
          erase $mf.left.plot  $gl
          if {$extract == "YES"} {
              extract_profdata 1
          }
          for {set i 0} {$i<= $gc} {incr i} {
              eval_cont_slid $i
              #calc_prof_ext $i
          }

          #corrlayer

          for {set i 0} {$i<= $gc} {incr i} {
             if {$meanflag == 0}  {cont_plot}
             #if {$meanflag == 1}  "mean_prof_plot $mf.left.plot  $i"

             if {$gc > 0} {
                set sX [lindex $scaleX $i]
                set sY [lindex $scaleY $i]
                $mf.left.plot  scale [lindex $gl $i] 0 20 $scalefacX $scalefacY
                $mf.left.plot  move [lindex $gl $i] $sX $sY
             }
          }


        }
boxview {
             extract_result 1
             eval_slid 0 1
             calc_ext 0

             plot 0 .bv.top.plot
        }
}

}



