# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makecommand {var box {which -1} {actgc -1} } {

global varrem boxrem
global data command
global newset eraseset sc
global actstart actend timewin
global starttime endtime outdelt
global selectvarrem
global plusflag minusflag timesflag timesfactor timesvarflag divflag divvarflag
global newgraph erasegraph gc
global eraseallgraphs eraseallsets
global maxset maxgraph filmmin filmmax
global fixvar fixbox aoag
global toolflag valu multiset
global ovc

set cpl $ovc.left
set cpr $ovc.right

if {$actgc == -1} {set actgc $gc}

if {$eraseallgraphs ==1} {
   set help  [lindex $command($gc) end]
   set gc 0
   for {set i 0} {$i <=$maxgraph} {incr i} {set command($i) X; set sc($i) 0}
   set command(0) $help
   if [winfo exists $cpl.graph.erasegraph] {
           $cpl.graph.erasegraph configure -state disabled}
   if [winfo exists $cpl.graph.eraseallgraphs] {
           $cpl.graph.eraseallgraphs configure -state disabled}
   if [winfo exists $cpl.graph.newgraph] {
            $cpl.graph.newgraph configure -state normal}
   set eraseallgraphs 0
   interpret
   return
}

if {$erasegraph ==1} {
   set command($gc) X
   set sc($gc) 0
   set gc [expr $gc -1]
   if {$gc ==0} {
	   if [winfo exists $cpl.graph.erasegraph] {
                      $cpl.graph.erasegraph configure -state disabled}
	   if [winfo exists $cpl.graph.eraseallgraphs] {
                      $cpl.graph.eraseallgraphs configure -state disabled}
   }
   if [winfo exists $cpl.graph.newgraph] {
            $cpl.graph.newgraph configure -state normal}
   set erasegraph 0
   interpret
   return
}

if {$eraseallsets == 1} {
    set sc($gc) 0
    set command($gc) [lindex $command($gc) end]
   if [winfo exists $cpl.set.eraseset] {
            $cpl.set.eraseset configure -state disabled}
   if [winfo exists $cpl.set.eraseallsets] {
            $cpl.set.eraseallsets configure -state disabled}
   if [winfo exists $cpl.set.newset] {
	       $cpl.set.newset configure -state normal}
	       
   if [winfo exists .as] {destroy .as}

   if {$toolflag=="compare" && [winfo exists $cpl.set.newset]} {
      if {$valu==1 || $multiset==0} {$cpl.set.newset configure -state disabled}
   }
   set eraseallsets 0
   interpret
   return
}

if {$eraseset == 1} {
 if [winfo exists .as] {destroy .as}
 if {[llength $command($actgc)] > 1} {
   if { $which != -1 } {
      set command($actgc) [lreplace $command($actgc) $which $which]
   } else {
      set help [expr [llength $command($gc)]-2]
      set command($gc) [lrange $command($gc) 0 $help]
   }
   set last [lindex $command($actgc) end]

   set plusind [string last + $last]
   #if {$plusind != -1} { set last [string range $last [expr $plusind +1] end]}

   set minusind [string last - $last]
   
   set ind [max $plusind $minusind]

   if {$ind != -1} { set last [string range $last [expr $ind +1] end]}

   if {$last != ""} {
      regsub {[(][0-9]+[)]} $last "" varrem
      regsub {[A-Za-z0-9]+[(]} $last "" abox
      regsub {[)]} $abox "" boxrem
   }
   interpret
   if {[llength $command($gc)] == 1} {
         if [winfo exists $cpl.set.eraseset] {
                  $cpl.set.eraseset configure -state disabled}
         if [winfo exists $cpl.set.eraseallsets] {
                  $cpl.set.eraseallsets configure -state disabled}
   }
 }
   if [winfo exists $cpl.set.newset] {$cpl.set.newset configure -state normal}
   set sc($gc) [expr $sc($gc) -1]
   set eraseset 0
   return
}


# making command($gc) list
#--------------------

#set last [lindex $command($gc) end]
##   set plusind [string last + $last]
##  if {$plusind != -1} { set last [string range $last [expr $plusind +1] end]}

#   if {$last != ""} {

#      regsub -all {[(][0-9]+[)]} $last "" varrem
#      regsub -all {[A-Za-z0-9]+[(]} $last "" abox
#textinfo "abox $abox varrem $varrem"
#
#      regsub -all {[)]} $abox "" boxrem
#textinfo "boxrem $boxrem varrem $varrem"

#}
##regsub X $boxrem 1 boxrem

if {$var == -1} {set var $varrem} else {set varrem $var}
if {$box == -1} {set box $boxrem} else {set boxrem $box}

set selectvar $var
append selectvar "("
append selectvar $box
append selectvar ")"


if {$timesflag == 1} {
   append selectvar * $timesfactor
   set timesflag 0
}

if {$divflag == 1} {
   append selectvar / $timesfactor
   set divflag 0
}

if {$plusflag == 1} {
   set help $selectvarrem
   append help + $selectvar
   set selectvar $help
   set plusflag 0
}

if {$minusflag == 1} {
   set help $selectvarrem
   append help - $selectvar
   set selectvar $help
   set minusflag 0
}


if {$divvarflag == 1} {
   set help $selectvarrem
   append help / $selectvar
   set selectvar $help
   set divvarflag 0
}

if {$timesvarflag == 1} {
   set help $selectvarrem
   append help * $selectvar
   set selectvar $help
   set timesvarflag 0
}


if {$fixvar == 1} {
    if {$newgraph ==1} {
        set targ [expr $gc+1]
        set sc($targ) $sc($gc)
    } else {set targ $gc}
    regsub -all {[(][0-9]+[)]} $command($gc) "($box)" command($targ)

    if {$newset==1} {
       set selectvar [lindex $command($gc) $sc($gc)]
       regsub -all {[(][0-9]+[)]} $selectvar "($box)" selectvar
    }

    if {$aoag == 1} {
        for {set i 0} {$i<= $gc} {incr i} {
            regsub -all {[(][0-9]+[)]} $command($i) "($box)" command($i)
        }
    }
}


if {$fixbox == 1} {
set hvar [append var (]

    if {$newgraph ==1} {
        set targ [expr $gc+1]
        set sc($targ) $sc($gc)
    } else {set targ $gc}
    regsub -all {[A-Za-z0-9_]+[(]} $command($gc) $hvar command($targ)

    if {$newset==1} {
       set selectvar [lindex $command($gc) $sc($gc)]
       regsub -all {[A-Za-z0-9_]+[(]} $selectvar $hvar selectvar
    }

    if {$aoag == 1} {
    for {set i 0} {$i<= $gc} {incr i} {
        regsub -all {[A-Za-z0-9_]+[(]} $command($i) $hvar command($i)
        }
    }
}
if {$newgraph ==1} {
  if {$gc == $maxgraph} {set newgraph 0; return}
   set gc [incr gc]
   if [winfo exists $cpl.graph.erasegraph] {$cpl.graph.erasegraph configure -state normal}
   if [winfo exists $cpl.graph.eraseallgraphs] {$cpl.graph.eraseallgraphs configure -state normal}

   set newgraph 0
}

if {$newset == 0} {
   if {$fixbox!=1 && $fixvar!=1} {set command($gc) [lreplace $command($gc) $sc($gc) $sc($gc) $selectvar]}

#  if [winfo exists $cpl.set.newset] {$cpl.set.newset configure -state normal}
# if [winfo exists .ana] {.ana.calc.plus configure -state normal}
#  if [winfo exists .ana] {.ana.calc.timesvar configure -state normal}
#  if [winfo exists .ana] {.ana.calc.divvar configure -state normal}
#  if [winfo exists $cpl.set.eraseset] {
#           $cpl.set.eraseset configure -state disabled}
} else {
  if {$sc($gc) == $maxset} {set newset 0;return}
  lappend command($gc) $selectvar
  set sc($gc) [incr sc($gc)]
  if {$sc($gc) >= $maxset} {if [winfo exists $cpl.set.newset] {$cpl.set.newset configure -state disabled}}
  if [winfo exists $cpl.set.eraseset] {$cpl.set.eraseset configure -state normal}
  if [winfo exists $cpl.set.eraseallsets] {$cpl.set.eraseallsets configure -state normal}
  set newset 0
}

if {$fixbox!=1 && $fixvar!=1} {set selectvarrem $selectvar}
if {$toolflag != "film"} {
   interpret
}

#if [winfo exists $ovc.right.misc.apply] \
#               {$ovc.right.misc.apply config -state normal}
#if [winfo exists $ovc.right.misc.start] {$ovc.right.misc.start config -state disabled}
   if {$toolflag=="compare" && [winfo exists $cpl.set.newset]} {
      if {$valu==1 || $multiset==0} {$cpl.set.newset configure -state disabled}
   }
if {$toolflag=="film" || $toolflag=="contour"} {
	set filmmin ""
	set filmmax ""  
}

}



