# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc nicevarselector {} {
global can pwd toolflag casesensitive
global comvarlist nicevarlist
global varwin
global boxFont nicebuttoncolor
global nicevarbut varbut
global nicevarfile
global onewindow vs nvs

set name $nicevarfile
# Auslesen der Namen
set nicevarlist ""
set col 5

  set ff [open $name]

  gets $ff line
  set col $line
  set num 0
  set butwid 0

  while {[gets $ff line] >=0} {
    if {[lindex $line 0]!="#"} {
      if {$line == "="} {
        lappend nicevarlist  =
      } else {

        set help [split $line :]
        if {$casesensitive==1} {
            set actvar [lindex $help 0]
        } else {
             set actvar [string tolower [lindex $help 0]]
         }
        set nicevar($actvar) [lindex $help 1]
        set nicebuttoncolor($actvar) [string trim [lindex $help 2]]
        set index [lsearch $comvarlist $actvar]
        if {$index>=0} {
           lappend nicevarlist $actvar
           set butwid [max $butwid [string length $nicevar($actvar)]]
        }
        incr num
      }
    }
  }
  close $ff

set nicevarbut ""
set setsep 0
set maxwidth 0

# Initialisierung Nice Variable Selector
#---------------------------
if [winfo exist $vs] {
	set kids [winfo children $vs]
    foreach kid $kids { destroy $kid }
}
if [winfo exist .vs] {destroy .vs}
if [winfo exist .nvs] {destroy .nvs}

if {$onewindow==0} {
set vs .vs
toplevel $vs
wm title $vs {Nice Variable Selector}
wm geometry $vs "+[expr $can+450]+350"
wm group $vs .
wm transient $vs .
wm protocol $vs WM_DELETE_WINDOW exit
} 
set nvs $vs

set count 0
set framecount 0
set sepcount 0
frame $nvs.$framecount
grid  $nvs.$framecount -row 0 -column 0 
# Schleife ueber alle nice Variablen
# ----------------------------------
#puts "Nicevarlist: $nicevarlist"
#puts "Comvarlist: $comvarlist"

foreach nice $nicevarlist {
   if {$nice=="="} {
     set setsep 1
	 set count 0
    } else {
     set index [lsearch $comvarlist $nice]
     if {$index>=0} {
        set var [lindex $comvarlist $index]
        set butid [string tolower $var]
        if ![winfo exists $nvs.$framecount.$butid] {
             set offset [expr int(fmod($count,$col)) ]
             incr count
             if {$setsep==1} {
                incr sepcount
                frame $nvs.sep$sepcount
                grid $nvs.sep$sepcount -row $framecount -column $offset -sticky w
                set offset 0 
                set setsep 0
             }
        if {$offset ==0} {
           incr framecount
           frame $nvs.$framecount
           grid  $nvs.$framecount -row $framecount -column $offset -sticky w
        }
	# puts "nicevar: nice=$nice framecount= $framecount, count= $count, offset=$offset, sepcount=$sepcount"
      set textcol black
      if  {[info exist nicebuttoncolor($var)]} {
         if  {$nicebuttoncolor($var) !=""} { set textcol $nicebuttoncolor($var) }
       }
       button $nvs.$framecount.$butid -text $nicevar($var) -padx 0 -width $butwid \
            -font $boxFont -fg $textcol \
            -command "makecommand $var -1;disablestart"

       pack $nvs.$framecount.$butid -side left -fill x
       lappend nicevarbut $nvs.$framecount.$butid
       
       if {$toolflag == "overview" || $toolflag == "phase" || $toolflag == "profile"} {
         bind $nvs.$framecount.$butid <2> {tkButton2Down %W}
         bind $nvs.$framecount.$butid <ButtonRelease-2> \
              "set newset 1;makecommand $var -1;tkButton2Up %W"
# For systems without 2nd mouse button
         bind $nvs.$framecount.$butid <Shift-1> "set newset 1;makecommand $var -1"
       }

       if {$toolflag != "film" && $toolflag != "contour" && $toolflag != "phase"} {
         bind $nvs.$framecount.$butid <3> {tkButton3Down %W}
         bind $nvs.$framecount.$butid <ButtonRelease-3> \
              "set newgraph 1;makecommand $var -1;tkButton3Up %W"
# For systems without 3rd mouse button
         bind $nvs.$framecount.$butid <Control-1> "set newgraph 1;makecommand $var -1"

       }
    } ;# end if winfo exists $nvs.$framecount.$butid]
  } ;# end if index >= 0
} 
} ;# end foreach nice
set varbut $nicevarbut
set varwin $varbut
}


