# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc ReadFile {name a} {
global moviehome toolflag
global starttime endtime maxdelt outdelt year cycle what numharm
global actstart timewin
global filenamerem
global outd
global filelist
global maxfiles
global timewinrem
global data
global casesensitive netcdf
global filename filenum
global tempdir

if [info exist data] {unset data}

set filenamerem $name

if {[file extension $name]==".nc"} {
    set all [exec $moviehome/../cprog/readall_nc $name]
    set netcdf 1
    set casesensitive 1
} else {
    if {[file extension $name]==".csv"} {
        set newname "[file rootname $name]"
        exec $moviehome/../cprog/csv2result $name $newname
        set name $newname\_csv.outc
        set filename($filenum) $name
    } 
    if {[file extension $name]==".outa"} {
        set newname "$tempdir/[file rootname [file tail $name]]"
        exec $moviehome/../cprog/outa2result $name $newname
        set name $newname.outc
        set filename($filenum) $name
    } 
#    puts $casesensitive
    set all [exec $moviehome/../cprog/readall $name]
    set netcdf 0
}

set nvars($a) [lindex $all 0]
set starttime($a) [lindex $all 1]
set endtime($a) [lindex $all 2]
set maxdelt($a) [lindex $all 3]
set outdelt($a) [lindex $all 4]
set year($a) [lindex $all 5]
set cycle($a) [lindex $all 6]
if {$netcdf==0} {
   set what($a) [lindex $all 7]
} else {
   set what($a) "netcdf"
}

textinfo "**********************************************"
textinfo "Resultfile: $name"
textinfo "**********************************************"
textinfo "Start: $starttime($a)"
textinfo "End: $endtime($a)"
textinfo "Outdelt: $outdelt($a)"
textinfo "Cycle: $cycle($a)"
textinfo "Year: $year($a)"

textinfo ""
ChangeInfo $name

if {$what($a)=="fourier"} {
   set numharm($a) [expr $maxdelt($a)/2]
} else {
  if [info exist numharm($a)] {unset numharm($a)}
}
# alte Version
#if {$what($a)=="fourier"} {
#   set numharm($a) $maxdelt($a)
#   set starttime($a) $maxdelt($a)
#   set endtime($a) [expr $starttime($a)+ $year($a)]
#}

set filelist 1
set outd $outdelt(1)
set actstart(1) [expr $starttime(1)]; # expr for slider representation (cutting zeros)
#set timewin [expr $endtime(1)-$starttime(1)]
set timetime [expr $endtime(1)-$starttime(1)]
set timewin $timetime 
set timewinrem $timetime
if {$toolflag=="compare" || $toolflag=="text" || $toolflag=="profcom"} {
   set odflag 0
   set odtextflag 0
   set startflag 0

for {set k 2} {$k<=$maxfiles} {incr k} {
   if [info exists filename($k)] {

     lappend filelist $k

     set actstart($k) $starttime($k)
     set timewin [min $timewin [expr $endtime($k)-$starttime($k)]]


     if {$actstart(1) != $actstart($k) } {set startflag 1}

     if {$outdelt(1) >=1 && $outdelt($k) >=1} {
        set outd [kgv $outd $outdelt($k)]
        if {$outdelt(1) != $outdelt($k)} {set odtextflag 1}
     } else {
        set outd [max $outd $outdelt($k)]
        if {$outdelt(1) != $outdelt($k)} {set odflag 1}
     }
  }
}

if {($toolflag=="profcom" || $toolflag=="text") && $startflag==1} {
   textinfo "Starttimes differ\nResults only valid for same starttimes" 1
}

if {$odflag==1 || ($odtextflag==1 && $toolflag=="text")} {
   textinfo "Outdelts differ\nResults only valid for identical outdelts" 1
}
}
set timewinrem $timewin
set all [lrange $all 8 end]

set allvars [lrange $all 0 [expr $nvars($a) -1]]

MakeVarBox $allvars $a
}



