# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc gnu_openf {} {
global pwd gc 
global gnu_out
global data title gc_rem gnu_legend

set o_data data
set o_title title
set gc_rem 1
set gnu_legend ""

# Preparation of the  header structure 
puts $gnu_out "# Automatically generated Gnu Batch file by MoViE"
puts $gnu_out "# (c) Cora Kohlmeier* & Frank Hamberg"
puts $gnu_out "#    *ICBM University of Oldenburg, Germany"
puts $gnu_out "#    phone +49-441-7983067 "
puts $gnu_out "#    email kohlmeier@icbm.de"
puts $gnu_out "set border 4095"
puts $gnu_out "set grid"

if {$gc>0} {
set subplot_num_graphs [expr $gc + 1]

switch $subplot_num_graphs {
1 {
    set subplot_num_rows 1
    set subplot_num_columns 1
}
2 {
    set subplot_num_rows 2
    set subplot_num_columns 1
}
3 {
    set subplot_num_rows 3
    set subplot_num_columns 1
}
4 {
    set subplot_num_rows 2
    set subplot_num_columns 2
}
5 {
    set subplot_num_rows 2
    set subplot_num_columns 3
}
6 {
    set subplot_num_rows 2
    set subplot_num_columns 3
}
7 {
    set subplot_num_rows 3
    set subplot_num_columns 3
}
8 {
    set subplot_num_rows 3
    set subplot_num_columns 3
}
9 {
    set subplot_num_rows 3
    set subplot_num_columns 3
}
}

puts $gnu_out "set multiplot layout $subplot_num_rows, $subplot_num_columns"

}
}
###############################################


proc gnu_open_graph { graph starttime endtime wymin wymax ytitle type {flip 0}} {
global g_c gc gnu_out
global toolflag meanflag
global worldxmin worldxmax worlymin worldymax
global subplot_num_rows subplot_num_columns g_c
global gnu_header
global gnudata

set g_c [expr $graph + 1]

set worldxmin $starttime
set worldxmax $endtime

set worldymin $wymin
set worldymax $wymax

puts $gnu_out "set title \"$ytitle\" "

puts $gnu_out "set xlabel \"time\" "
puts $gnu_out "set xrange \[$starttime\:$endtime\]"
puts $gnu_out "set yrange \[$wymin\:$wymax\]"

set gnudata plot
}

###############################################

proc gnu_set_num {graph set data set_title outdelt {timedata xxx}} {
global gmfile
global worldxmin
global gnudata

#Daten eines sets in ein File schreiben
set gnuid [open $gmfile\_$graph\_$set.dat w]  
set gnuname [file tail $gmfile]

set t 0
foreach item $data {
if {$timedata == "xxx"} {
  set time [expr $t*$outdelt+$worldxmin]
} else {
   #timedata !=xxx in phase tool for 2D plot
   #Daten eines sets in ein File schreiben
   # in diesem Fall reduziert sich die Zahl der sets
  set time [lindex $timedata $t]
}

  puts $gnuid "$time $item"
  incr t
}
close $gnuid

#Fuer den Eintrag in die Batch Datei
append gnudata " \"$gnuname\_$graph\_$set.dat\"   title \"$set_title\"   with lines,"

}

###############################################

proc gnu_add_bar {bar value title} {
global gnu_bar_names gnu_bar_values
global gmfile
#Daten eines sets in ein File schreiben

if {$bar==0} {
      set gnu_bar_values $value
      set gnu_bar_names $title
} else {
      lappend gnu_bar_values $value
      lappend gnu_bar_names $title
}
}

###############################################

proc gnu_plot_bars {graph title} {
global gmfile gnu_out 
global gnu_bar_names gnu_bar_values gnu_header

set gnuid [open $gmfile\_$graph.dat w]  
set gnuname [file tail $gmfile]

set k 0
foreach item $gnu_bar_values {
    puts $gnuid "[lindex $gnu_bar_names $k] [lindex $gnu_bar_values $k]"
    incr k
}

close $gnuid

#Eintrag in die Batch Datei
puts $gnu_out "set auto x"
puts $gnu_out "set title   \"$title\""
puts $gnu_out "set style  data histogram"
puts $gnu_out "set style  histogram"
puts $gnu_out "set xtics left"
puts $gnu_out "set style fill solid border -1"
puts $gnu_out "plot for \[col=2:2\] \"$gnuname\_$graph.dat\" using col:xtic(1) ti \"\""
}

###############################################

proc gnu_set_valu { graph set set_title  time val_dat {ytop 0} {ybot 0}} {
global gnu_out gnu_header

global gmfile
global worldxmin
global gnudata

#Daten eines sets in ein File schreiben
set gnuid [open $gmfile\_$graph\_$set.dat w]  
set gnuname [file tail $gmfile]

set t 0
if {$ytop!=0} {
foreach item $val_dat {
  puts $gnuid "[lindex $time $t]  $item [lindex $ybot $t]  [lindex $ytop $t]"
  incr t
}
close $gnuid

#Fuer den Eintrag in die Batch Datei
append gnudata " \"$gnuname\_$graph\_$set.dat\"   title \"$set_title\"   with errorbars,"

} else {

foreach item $val_dat {
  puts $gnuid "[lindex $time $t]  $item "
  incr t
}
close $gnuid

#Fuer den Eintrag in die Batch Datei
append gnudata " \"$gnuname\_$graph\_$set.dat\"   title \"$set_title\"   with points,"

}


}

###############################################

proc gnu_close_graph {} {
global gnu_out gnudata

puts $gnu_out [string trimright $gnudata ,]

}

###############################################
proc gnu_closef {file} {
global gnu_flag gc
if {$gc>0} {
puts $file "unset multiplot"
}
close $file
set gnu_flag 0
}

