# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg


proc xv_openf {} {
global pwd gc movieversion
global xvgr_out
global xvgr_color data title
global index_x index_y posxmin posxmax posymin posymax
global cs1 cs2 cs05


set xvgr_color "1 2 15 4 11 8 10 12 7 5 6 5 9 13 3"

set index_x "0 0 1 1 2 2 2 2 2"
set posxmin(0) ".1 .1 0 0 0 0 0 0 0"
set posxmin(1) ".1 .54 .1 .54 0 0 0 0 0"
set posxmin(2) ".1 .38 .69 .1 .38 .69 .1 .38 .69"

set posxmax(0) ".9 .9 0 0 0 0 0 0 0"
set posxmax(1) ".45 .9 .45 .9 0 0 0 0 0"
set posxmax(2) ".3 .6 .9 .3 .6 .9 .3 .6 .9"

set index_y "0 1 2 2 3 3 4 4 4"
set posymin(0) ".1 0 0 0 0 0 0 0 0"
set posymin(1) ".54 .1 0 0 0 0 0 0 0"
set posymin(2) ".54 .54 .1 .1 0 0 0 0 0"
set posymin(3) ".54 .54 .54 .1 .1 .1 0 0 0"
set posymin(4) ".67 .67 .67 .38 .38 .38 .1 .1 .1"

set posymax(0) ".9 0 0 0 0 0 0 0 0"
set posymax(1) ".9 .45 0 0 0 0 0 0 0"
set posymax(2) ".9 .9 .45 .45 0 0 0 0 0"
set posymax(3) ".9 .9 .9 .45 .45 .45 0 0 0"
set posymax(4) ".9 .9 .9 .614 .614 .614 .33 .33 .33"

set o_data data
set o_title title

# Preparation of the xvgr/xmgr header structure 

puts $xvgr_out "# ACE/gr data file "
puts $xvgr_out "# written by MoViE TK $movieversion"
puts $xvgr_out "#         (c) Cora Kohlmeier & Frank Hamberg"
puts $xvgr_out "#             ICBM University of Oldenburg, Germany"
puts $xvgr_out "#             phone 049-441-7983067 "
puts $xvgr_out "#             email kohlmeier@icbm.de"
puts $xvgr_out "#"
puts $xvgr_out "@version 50108"
puts $xvgr_out "@ description \"File produced by MoViE TK $movieversion \
                 (c) Cora Kohlmeier & Frank Hamberg \""
puts $xvgr_out "@page 5"
puts $xvgr_out "@page inout 5"
puts $xvgr_out "@link page off"
puts $xvgr_out "@default font 4"

#puts $xvgr_out "@with string"
#puts $xvgr_out "@    string on"
#puts $xvgr_out "@    string loctype view"
#puts $xvgr_out "@    string 0.986215538847, 0.0177705977383"
#puts $xvgr_out "@    string linewidth 1"
#puts $xvgr_out "@    string color 1"
#puts $xvgr_out "@    string rot 0"
#puts $xvgr_out "@    string font 4"
#puts $xvgr_out "@    string just 1"
#puts $xvgr_out "@    string char size 0.280000"
#puts $xvgr_out "@string def \"MoViE Graphic\""

puts $xvgr_out "@map font 0 to \"Helvetica\", \"Helvetica\""
puts $xvgr_out "@map font 1 to \"Helvetica\", \"Helvetica\""
puts $xvgr_out "@map font 2 to \"Helvetica\", \"Helvetica\""
puts $xvgr_out "@map font 3 to \"Helvetica\", \"Helvetica\""
puts $xvgr_out "@map font 4 to \"Helvetica\", \"Helvetica\""
puts $xvgr_out "@map font 5 to \"Helvetica-Oblique\", \"Helvetica-Oblique\""
puts $xvgr_out "@map font 6 to \"Helvetica-Bold\", \"Helvetica-Bold\""
puts $xvgr_out "@map font 7 to \"Helvetica-BoldOblique\", \"Helvetica-BoldOblique\""
puts $xvgr_out "@map font 8 to \"Courier\", \"Courier\""
puts $xvgr_out "@map font 9 to \"Courier-Oblique\", \"Courier-Oblique\""
puts $xvgr_out "@map font 10 to \"Courier-Bold\", \"Courier-Bold\""
puts $xvgr_out "@map font 11 to \"Courier-BoldOblique\", \"Courier-BoldOblique\""
puts $xvgr_out "@map font 12 to \"Symbol\", \"Symbol\""
puts $xvgr_out "@map font 13 to \"ZapfDingbats\", \"ZapfDingbats\""

set cs_fac [expr 0.75*(1.0-0.1*[lindex $index_y $gc])]
scan [expr 2*$cs_fac] %s cs2
scan [expr $cs_fac] %s cs1
scan [expr $cs_fac/1.5] %s cs05

}


proc xv_open_graph { graph starttime endtime wymin wymax ytitle type {flip 0}} {
global g_c gc xvgr_out
global index_x index_y posxmin posxmax posymin posymax
global worldxmin worldxmax worlymin worldymax
global cs1 cs2 cs05
global toolflag

set g_c $graph

set tickdeltx [expr ($endtime-$starttime)/10.0]
set tickdelty [expr ($wymax-$wymin)/10.0]

set y_title $ytitle
set g_typ $type

set worldxmin $starttime
set worldxmax $endtime

set worldymin $wymin
set worldymax $wymax

puts $xvgr_out "@with g$g_c"
puts $xvgr_out "@g$g_c on"
puts $xvgr_out "@  default font 4"
puts $xvgr_out "@  string char size $cs1"
puts $xvgr_out "@  xaxis ticklabel char size $cs1"
puts $xvgr_out "@  yaxis ticklabel char size $cs1"
puts $xvgr_out "@  xaxis tick size $cs2"
puts $xvgr_out "@  yaxis tick size $cs2"
puts $xvgr_out "@  xaxis tick minor size $cs1"
puts $xvgr_out "@  yaxis tick minor size $cs1"
puts $xvgr_out "@  xaxis label char size $cs05"
puts $xvgr_out "@  yaxis label char size $cs1"
if {$flip==1} {puts $xvgr_out "@    yaxes invert on"}

puts $xvgr_out "@  legend font 4"
puts $xvgr_out "@  legend char size $cs05"

if {$g_typ != "bar"} {
   puts $xvgr_out "@  legend length 8"
} else {
   puts $xvgr_out "@  legend length 0"
}
puts $xvgr_out "@  legend box color 0"

puts $xvgr_out "@ world xmin $worldxmin"
puts $xvgr_out "@ world xmax $worldxmax"
puts $xvgr_out "@ world ymin $worldymin"
puts $xvgr_out "@ world ymax $worldymax"

set v_xmin [lindex $posxmin([lindex $index_x $gc]) $g_c]
set v_xmax [lindex $posxmax([lindex $index_x $gc]) $g_c]

set v_ymin [lindex $posymin([lindex $index_y $gc]) $g_c]
set v_ymax [lindex $posymax([lindex $index_y $gc]) $g_c]

puts $xvgr_out "@ view xmin $v_xmin"
puts $xvgr_out "@ view xmax $v_xmax"
puts $xvgr_out "@ view ymin $v_ymin"
puts $xvgr_out "@ view ymax $v_ymax"

puts $xvgr_out "@ legend on"


puts $xvgr_out "@ legend x1 [expr $v_xmin+.1*($v_xmax-$v_xmin)]"
puts $xvgr_out "@ legend y1 [expr $v_ymin+.8*($v_ymax-$v_ymin)]"

puts $xvgr_out "@ xaxis ticklabel type auto"

#if {$toolflag == "profile"} {
#   puts $xvgr_out "@ xaxis ticklabel prec 2"
#} else {
   puts $xvgr_out "@ xaxis ticklabel prec 1"
#}

puts $xvgr_out "@ xaxis ticklabel format decimal"
puts $xvgr_out "@ xaxis tick op bottom"
puts $xvgr_out "@ xaxis tick on"
puts $xvgr_out "@ xaxis ticklabel font 4"


if {$g_typ != "bar"} {
  puts $xvgr_out "@ xaxis tick major [expr 2*$tickdeltx]"
  puts $xvgr_out "@ xaxis tick minor $tickdeltx"
  puts $xvgr_out "@ yaxis  label \"\""
} else {
  puts $xvgr_out "@ g$g_c type chart"
  puts $xvgr_out "@ g$g_c stacked false"
  puts $xvgr_out "@ xaxis tick major 1"
  puts $xvgr_out "@ xaxis tick minor 0"
  puts $xvgr_out "@ xaxis ticklabel on"
  puts $xvgr_out "@ xaxis ticklabel type spec"
  puts $xvgr_out "@ xaxis tick type spec"
  puts $xvgr_out "@ xaxis tick spec [expr $worldxmax]"
  puts $xvgr_out "@ xaxis ticklabel char size $cs1"
  puts $xvgr_out "@ yaxis  label \"\""
}

puts $xvgr_out "@    yaxis  label layout para"
puts $xvgr_out "@    yaxis  label place auto"
puts $xvgr_out "@    yaxis  label char size 0.680000"
puts $xvgr_out "@    yaxis  label font 4"
puts $xvgr_out "@    yaxis  label color 1"
puts $xvgr_out "@    yaxis  label place normal"


puts $xvgr_out "@ yaxis ticklabel type auto"
puts $xvgr_out "@ yaxis ticklabel prec 2"
puts $xvgr_out "@ yaxis tick major [expr 2*$tickdelty]"
puts $xvgr_out "@ yaxis tick minor $tickdelty"

puts $xvgr_out "@ yaxis ticklabel format decimal"
puts $xvgr_out "@ yaxis ticklabel font 4"
puts $xvgr_out "@ yaxis tick op left"
puts $xvgr_out "@ yaxis tick on"

#puts $xvgr_out "@WITH G$g_c"
#puts $xvgr_out "@G$g_c on"

#puts $xvgr_out "@ yaxis  label \"\""
puts $xvgr_out "@ title font 4"
puts $xvgr_out "@ subtitle font 4"
puts $xvgr_out "@ subtitle \"$y_title\""
puts $xvgr_out "@ subtitle size $cs1"

}

proc xv_set_num {graph setnum data set_title outdelt {timedata xxx}} {
global xvgr_out xvgr_color
global worldxmin worldxmax worldymin worldymax

set g_c $graph
set s_c $setnum
set o_data $data
set o_title $set_title
set o_delt $outdelt
set col [lindex $xvgr_color $s_c]

if {$o_title != {}} {
   puts $xvgr_out "@   legend font 4"
#   puts $xvgr_out "@   legend string $s_c \"$o_title\""
   puts $xvgr_out "@ s$s_c legend \"$o_title\""
}

 puts $xvgr_out "@ s$s_c color $col"
# alt: unterschiedliche linestyle für jeden Set
# puts $xvgr_out "@ s$s_c linestyle [expr $s_c+1]"
 puts $xvgr_out "@ s$s_c linestyle 1"
 puts $xvgr_out "@ s$s_c symbol     0"
 puts $xvgr_out "@target G$g_c.S$s_c"
 puts $xvgr_out "@type xy"

set t 0
foreach item $o_data {
if {$timedata == "xxx"} {
  set time [expr $t*$o_delt+$worldxmin]
} else {
  set time [lindex $timedata $t]
}
  set outs "$time , $item"
  puts $xvgr_out $outs
  incr t
}
puts $xvgr_out &

}

proc xv_set_bar {one_bar ytop set_title {fixcol -1} {setnum 1} {sets 1}} {
global xvgr_color xvgr_out multiset

set set_id [expr $one_bar+1]
set width [expr 1.0/$sets]
set offset [expr (1.0*$setnum)/(1.0*$sets)]

if {$fixcol >= 0} {
   set xvcol [lindex $xvgr_color $fixcol]
} else {
   set xvcol [lindex $xvgr_color $one_bar]
}
set label $set_title

#puts $xvgr_out "@ xaxis tick $one_bar , $set_id"
#puts $xvgr_out "@ xaxis ticklabel $one_bar , \"$label\""
puts $xvgr_out "@ s$one_bar legend \"$label\""
puts $xvgr_out "@ s$one_bar color $xvcol"
puts $xvgr_out "@ s$one_bar line color $xvcol"
puts $xvgr_out "@ s$one_bar symbol color $xvcol"
puts $xvgr_out "@ s$one_bar fill 1"
puts $xvgr_out "@ s$one_bar fill with color"
puts $xvgr_out "@ s$one_bar fill color $xvcol"
puts $xvgr_out "@ s$one_bar symbol fill color $xvcol"
puts $xvgr_out "@ s$one_bar symbol fill pattern 1"
puts $xvgr_out "@type bar"

puts $xvgr_out "$setnum $ytop"

puts $xvgr_out &
}

proc xv_open_multibar_header {graph setnum set_title} {
global xvgr_out

puts $xvgr_out "@s$setnum legend \"$set_title\""
puts $xvgr_out "@s$setnum line pattern 0"
puts $xvgr_out "@s$setnum symbol fill pattern 4"
puts $xvgr_out "@target G$graph.S$setnum"
puts $xvgr_out "@type bar"

}

proc xv_close_multibar_header {} {
global xvgr_out

puts $xvgr_out "&"
}

proc xv_set_tickmark {setnum ticktext} {
global xvgr_out

puts $xvgr_out "@ xaxis tick major $setnum,$setnum"
puts $xvgr_out "@ xaxis ticklabel $setnum ,\"$ticktext\""
}

proc xv_set_multibar {index value} {
global xvgr_out

puts $xvgr_out "$index $value"
}


proc xv_init_valu { graph setnum set_title color time val_dat {ytop 0} {ybot 0}} {
global xvgr_out xvgr_color
global cs1 cs2 cs05

set g_c $graph
set s_c $setnum
set sets s$setnum
set val_title $set_title
set val_col [expr $color-1]
set col [lindex $xvgr_color $val_col]
set ls [expr $val_col-2]
set sym $val_col

puts $xvgr_out "@ $sets symbol 9"
puts $xvgr_out "@ $sets symbol size $cs1"
puts $xvgr_out "@ $sets symbol fill 0"
puts $xvgr_out "@ $sets symbol center false"
puts $xvgr_out "@ $sets symbol char 0"
puts $xvgr_out "@ $sets skip 0"
puts $xvgr_out "@ $sets linestyle 0"
puts $xvgr_out "@ $sets linewidth 1"
puts $xvgr_out "@ $sets color $col"
puts $xvgr_out "@ $sets fill 0"
puts $xvgr_out "@ $sets fill with color"
puts $xvgr_out "@ $sets fill color 0"
puts $xvgr_out "@ $sets fill pattern 0"
puts $xvgr_out "@ $sets errorbar type BOTH"
puts $xvgr_out "@ $sets errorbar length $cs1"
puts $xvgr_out "@ $sets errorbar linewidth 1"
puts $xvgr_out "@ $sets errorbar linestyle 1"
puts $xvgr_out "@ $sets errorbar riser on"
puts $xvgr_out "@ $sets errorbar riser linewidth 1"
puts $xvgr_out "@ $sets errorbar riser linestyle 1"
puts $xvgr_out "@ legend string $setnum \"$val_title\""
puts $xvgr_out "@target G$g_c.S$s_c"
puts $xvgr_out "@type xydydy"

set k 0
foreach item $val_dat {
  set tim [lindex $time $k]

  if {$ytop!=0 && $ybot!=0 && $ytop!="" && $ybot!=""} {
    set top [expr [lindex $ytop $k] -$item]
    set bot [expr $item -[lindex $ybot $k]]
  } else {
    set top 0
    set bot 0
  }
   puts $xvgr_out "$tim $item $top $bot"
   incr k
}
puts $xvgr_out &
}


proc xv_close_valu {} {
global xvgr_out
global data title

 puts $xvgr_out &
}

proc xv_closef {} {
global xvgr_out xvgr_flag

   close $xvgr_out
   set xvgr_flag 0
}


