# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc sequence_buttons {} {
global seq ovc
global buttonFont

set seq 0

labelframe $ovc.left.seq -text "Sequence Control"
pack $ovc.left.seq -pady {0 5} -anchor w

button $ovc.left.seq.sel_sequence  -font $buttonFont -text {Sequence} \
       -command {select_sequence}

pack $ovc.left.seq.sel_sequence -side left 

button $ovc.left.seq.start_sequence  -font $buttonFont -text {Start Sequence} \
       -command {set seq 1;start_sequence;set seq 0} -state disabled

pack $ovc.left.seq.start_sequence -side left


}

proc select_sequence {} {
global pwd
global seq_len playlist

  set seqname [fileselect "Select Playlist" lst $pwd open]
  if {$seqname!="" && [file exist $seqname]} {
	  set seqid [open $seqname r]
	  set seq_len 0
	
	  while {[gets $seqid line]>=0} {
	     incr seq_len
	     set playlist($seq_len) $line.outc
	  }
	
	  if {$seq_len > 0} {
	     $ovc.left.seq.start_sequence config -state normal
	     # init_sequence
	  }
	}
}	
proc init_sequence {} {

global seq_len playlist command maxnumber minnumber
global seq_min seq_max
global singleresult
global filename

set len [llength $command(0)]

for {set l 0} {$l < $len} {incr l} {
    set selectvar [lindex $command(0) $l]
    set seq_min($selectvar) $maxnumber
    set seq_max($selectvar) $minnumber
}

for {set k 1} {$k <= $seq_len} {incr k} {
    set filename(1) $playlist($k)
    extract_result 1
    eval_slid 0 1

    for {set l 0} {$l < $len} {incr l} {
       set selectvar [lindex $command(0) $l]
       set seq_min($selectvar) [min $seq_min($selectvar) [lmin $singleresult($selectvar)] ]
       set seq_max($selectvar) [max $seq_max($selectvar) [lmax $singleresult($selectvar)] ]
    }
}
#puts $command(0)
#for {set l 0} {$l < $len} {incr l} {
#puts "$seq_min($l) $seq_max($l)"
#}

}


proc start_sequence {} {
global seq_len playlist
global filename
init_sequence

for {set i 1} {$i <= $seq_len} {incr i} {
  set filename(1) $playlist($i)
#  puts $seq_len
  interpret
  update
}

}
