# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc get_symb_data {} {

global pwd prep_command log moviehome datadir
global symb_cycle symb_outdelt symb_epsi symb_harm

set symb_cycle 360.0
set symb_outdelt 1.0
set symb_epsi -1.0
set symb_harm -1

set filename [fileselect  "Select data file" symb $datadir open]

toplevel .symb

wm title .symb {symb_pk Parameters}
wm geometry .symb "+350+500"


frame .symb.main
pack .symb.main

label .symb.main.cycle -text "Cycle" -width 20
pack .symb.main.cycle -side left -pady {0 5} -padx 10
entry .symb.main.symb_cycle -width 12 -textvariable symb_cycle
pack .symb.main.symb_cycle -side left -pady {0 5} -padx 10


frame .symb.but
pack .symb.but

button .symb.but.cancel -text {Cancel}\
       -command { destroy .symb
                }
pack .symb.but.cancel -side left -pady {0 5}

button .symb.but.ok -text {OK}\
       -command { $log delete 1.0 end
                  $log insert end "Converting $filename "

                  set ext [file extension $filename]
                  #regsub $ext $filename "" file
                  set file [file rootname $filename]

                  $log insert end "to $file\_dpk \n"

                  set prep_command "$moviehome/../cprog/transform_symb $file $symb_cycle $symb_outdelt $symb_epsi $symb_harm"
                  Run

		  destroy .symb
                }
pack .symb.but.ok -side left -pady {0 5}

}
