# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc result2fourier {} {
global pwd prep_command log moviehome home
global four_cycle four_outdelt four_file

$log delete 1.0 end

$log insert end "ATTENTION\n\n"
$log insert end "To avoid errors in the transformation the resultfile must hold samples for one complete period
This means f.e.
                  cycle=365.0
                  outdelt = 0.1
                  starttime = 0.0
                  endtime = 364.9 
                  storestart = 1 must be set to avoid the resultfile start with zero values\n\n"

#$log -state disabled
wm attributes .prepare -topmost no
set four_file [fileselect  "Select result file" outb $pwd open]
if {$four_file==""} {
wm attributes .prepare -topmost yes
return
}
set four_cycle -1.0
set four_outdelt -1.0

toplevel .four

wm title .four {res_pk Parameters}
wm geometry .four "+350+500"


frame .four.main
pack .four.main

frame .four.main.1
pack .four.main.1
label .four.main.1.cycle -text "Cycle" -width 20
pack .four.main.1.cycle -side left -pady {0 5} -padx 10
entry .four.main.1.four_cycle -width 12 -textvariable four_cycle
pack .four.main.1.four_cycle -side left -pady {0 5} -padx 10
.four.main.1.four_cycle icursor end
bind .four.main.1.four_cycle <Return> "focus .four.main.2.four_outdelt"
focus .four.main.1.four_cycle

frame .four.main.2
pack .four.main.2
label .four.main.2.outdelt -text "Outdelt" -width 20
pack .four.main.2.outdelt -side left -pady {0 5} -padx 10
entry .four.main.2.four_outdelt -width 12 -textvariable four_outdelt
pack .four.main.2.four_outdelt -side left -pady {0 5} -padx 10
.four.main.2.four_outdelt icursor end
bind .four.main.2.four_outdelt <Return> "focus .four.but.ok"

frame .four.but
pack .four.but

button .four.but.cancel -text {Cancel}\
       -command { destroy .four
				  wm attributes .prepare -topmost yes
                }
pack .four.but.cancel -side left -pady {0 5}

button .four.but.ok -text {OK}\
       -command { 
			wm attributes .prepare -topmost yes
			$log insert end "Converting $four_file"
			set ext [file extension $four_file]
			set file [file rootname $four_file]
			$log insert end " to $file\_pk.outc \n\n"
			set matrixdir $home/.MOVIE-matrices
			if ![file exists $matrixdir] {file mkdir $matrixdir}
			set prep_command "$moviehome/../cprog/transform_result $four_file $four_cycle $four_outdelt"
			Run
			destroy .four	   
       }
pack .four.but.ok -side left -pady {0 5}

}

