# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc symb2fourier {} {

global pwd prep_command log moviehome datadir
global symb_cycle symb_outdelt symb_epsi symb_harm
global symb_file

set symb_cycle 360.0
set symb_outdelt 0.1
set symb_epsi -1.0
set symb_harm -1

wm attributes .prepare -topmost no
set symb_file [fileselect  "Select data file" symb $datadir open]
if {$symb_file==""} {
	wm attributes .prepare -topmost yes
	return
}
toplevel .symb

wm title .symb {symb_pk Parameters}
wm geometry .symb "+350+500"
wm attributes .symb -topmost yes

frame .symb.main
pack .symb.main

frame .symb.main.1
pack .symb.main.1
label .symb.main.1.cycle -text "Cycle" -width 20
pack .symb.main.1.cycle -side left -pady {0 5} -padx 10
entry .symb.main.1.symb_cycle -width 12 -textvariable symb_cycle
pack .symb.main.1.symb_cycle -side left -pady {0 5} -padx 10
.symb.main.1.symb_cycle icursor end
bind .symb.main.1.symb_cycle <Return> "focus .symb.main.2.symb_outdelt"
focus .symb.main.1.symb_cycle

frame .symb.main.2
pack .symb.main.2
label .symb.main.2.outdelt -text "Outdelt" -width 20
pack .symb.main.2.outdelt -side left -pady {0 5} -padx 10
entry .symb.main.2.symb_outdelt -width 12 -textvariable symb_outdelt
pack .symb.main.2.symb_outdelt -side left -pady {0 5} -padx 10
.symb.main.2.symb_outdelt icursor end
bind .symb.main.2.symb_outdelt <Return> "focus .symb.main.3.symb_epsi"

frame .symb.main.3
pack .symb.main.3
label .symb.main.3.epsi -text "Epsilon" -width 20
pack .symb.main.3.epsi -side left -pady {0 5} -padx 10
entry .symb.main.3.symb_epsi -width 12 -textvariable symb_epsi
pack .symb.main.3.symb_epsi -side left -pady {0 5} -padx 10
.symb.main.3.symb_epsi icursor end
bind .symb.main.3.symb_epsi <Return> "focus .symb.main.4.symb_harm"

frame .symb.main.4
pack .symb.main.4
label .symb.main.4.harm -text "Number of harmonics" -width 20
pack .symb.main.4.harm -side left -pady {0 5} -padx 10
entry .symb.main.4.symb_harm -width 12 -textvariable symb_harm
.symb.main.4.symb_harm icursor end
pack .symb.main.4.symb_harm -side left -pady {0 5} -padx 10
bind .symb.main.4.symb_harm <Return> "focus .symb.but.ok"

#bind .symb.runmean.run <Return> "interpret"


frame .symb.but
pack .symb.but

button .symb.but.cancel -text {Cancel}\
       -command { destroy .symb
				  wm attributes .prepare -topmost yes
                }
pack .symb.but.cancel -side left -pady {0 5}

button .symb.but.ok -text {OK}\
       -command { wm attributes .prepare -topmost yes
				  $log delete 1.0 end
                  $log insert end "Converting $symb_file "
                  set file [file rootname  $symb_file]
                  $log insert end "to $file\_dpk \n"
                  set prep_command "$moviehome/../cprog/transform_symb $file $symb_cycle $symb_outdelt $symb_epsi $symb_harm"
				  Run
				  destroy .symb
        }
pack .symb.but.ok -side left -pady {0 5}

}
