# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc mean_profcom_plot {c j} {

global can
global startbox boxwindow time timemax timemaxflag
global pxmin pxmax pymin pymax pxdelt pydelt
global xmin xmax ymin ymax xdelt ydelt
global colorlist colorindex
global plotFont boldFont
global singleresult command
global graph gl
global xvgr_flag

set graph [lindex $gl $j]
set lbar [llength $command($j)]

set init 1

set xmin($j) [min $xmin($j) 0]
set xmax($j) [max $xmax($j) 0]

if {$xmin($j) == $xmax($j)} { set xmax($j) [expr $xmin($j)+1.0]}

if {$timemaxflag==1} {set xmax($j) $timemax($j)}

foreach selectvar $command($j) {

if { $init == 1} {

   set init 0
   set colorindex 0
   set barnum 0

   # Setting of x-axis
   set ymin $startbox
   set ymax [expr $startbox + $boxwindow]
   set ydelt [expr {$ymax - $ymin}]
   set xdelt [expr $xmax($j) - $xmin($j)]


   # Plotting of x-axis and y axis
   #--------------------------
   set item [$c create line $pxmin $pymin $pxmin $pymax -width 1.5]
   $c addtag axis withtag $item
   $c addtag $graph withtag $item

   set item [$c create line $pxmin $pymin $pxmax $pymin -width 1.5]
   $c addtag axis withtag $item
   $c addtag $graph withtag $item


  # Calculating of normalizing factor for the plot
  #--------------------------
  set pyoff [expr $pydelt/$lbar]
  set pylabel [expr $pymin + $pyoff/2]

  set py1 [expr $pymin-5]
  set py2 [expr $pymin + $pyoff]

  # Plotting of header
  #--------------------------

   scan $ymin %u ytext1
   scan $ymax %u ytext2
   set graphtitle "Box: $ytext1 - $ytext2   Time: $time"

  set item [$c create text $pxmin 10 -text $graphtitle \
             -font $plotFont -anchor w]
  $c addtag axis withtag $item
  $c addtag $graph withtag $item

  # Plotting of x-axis labels
  #--------------------------


  for {set i 0} {$i <= 6} {incr i} {
    set xlabel [expr $xmin($j) + ($i*$xdelt/6)]
    set xtext [format "%10.3g" $xlabel]
    set xoff [nnxj $xlabel $j]

    set item [$c create line $xoff [expr $pymin-5] $xoff  [expr $pymin+5] -width 2]
    $c addtag axis withtag $item
    $c addtag $graph withtag $item

    set item [$c create text $xoff [expr $pymin+15]  -text $xtext \
                   -anchor e -font $plotFont]
    $c addtag axis withtag $item
   $c addtag $graph withtag $item
  }

   if {$xvgr_flag == 1} { xv_open_graph $j 0 [expr $lbar+1] \
                                      $ymin $ymax $graphtitle bar
                        }


} else {set colorindex [expr $colorindex+1]}

# Plotting of singleresult
#--------------------------
set color [lindex $colorlist $colorindex]

regsub -all {[(][0-9]+[)]} $selectvar "" text
set item [$c create text [expr $pxmin-25] $pylabel -text $text \
                       -anchor n -font $plotFont -fill $color]

$c addtag $color$graph withtag $item
$c addtag $graph withtag $item

set pylabel [expr $pylabel + $pyoff]

# Preparing data for plot
#------------------------
set pmean [nnxj $singleresult($selectvar) $j]

# Plotting one bar
#------------------------

set item [eval {$c create rect} $pxmin $py1 $pmean $py2  {-width 1 -fill $color}]

$c addtag $color$graph withtag $item
$c addtag $graph withtag $item
$c bind $color$graph <3> "set eraseset 1;makecommand -1 -1 $colorindex $j"

set py1 $py2
set py2 [expr $py2 + $pyoff]

    if {$xvgr_flag ==1 } {
       xv_set_bar $barnum $mean($selectvar) $selctvar
      incr barnum
    }
}
}



