# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc flippaxes {j {c none}} {

global can mf
global outdelt timewin cycle
global actstart
global pxmin pxmax pymin pymax pxdelt pydelt
global xmin xmax ymin ymax xdelt ydelt
global colorlist colorindex
global plotFont boldFont
global command
global graph gl singleresult
global vertoff
global xvgr_flag
global smooth
global fixxmax fixxmin
global xax
global startbox boxwindow
global layer layersum barchart
global tiefe layervalue

   if {$c=="none"} {set c $mf.left.plot} 

   # Plotting of x-axis
   #--------------------------

   set item [$c create line $pxmin $pymin $pxmax $pymin -width 1.5]
   $c addtag axis withtag $item
   $c addtag $graph withtag $item


   # Plotting of y-axis
   #--------------------------


   set item [$c create line $pxmin $pymin $pxmin $pymax -width 1.5]
   $c addtag axis withtag $item
   $c addtag $graph withtag $item


  # Plotting of x-axis labels
  #--------------------------

  for {set i 0} {$i <= 10} {incr i} {
    set xlabel [expr $ymin($j) + ($i*$ydelt/10) ]
    set xtext [string trim [format "%10.3g" $xlabel]]

    set xoff [nx $xlabel $ymin($j) $ymax($j)]

     set item [$c create line $xoff $pymin $xoff [expr $pymin+5] -width 2]
     $c addtag axis withtag $item
     $c addtag $graph withtag $item
     set item [$c create text $xoff [expr $pymin+10] -text $xtext \
                   -justify center -anchor n -font   $plotFont]
     $c addtag axis withtag $item
     $c addtag $graph withtag $item

  }

  # Plotting of y-axis labels
  #--------------------------

  set lastbox [expr $startbox + $boxwindow]
  set pos $xmax

  if {$barchart==1} {
      set labelpos [expr $pos-0.5]
    } else {
      set labelpos $pos
    }

  for {set i $startbox} {$i <= $lastbox} {incr i} {

   if {$layervalue==1} {
       set ytext  [string trim [format "%10.3g" $tiefe($i)]]
    } else {
       set ytext $i
    }


    set ypos [ny $pos $xmin $xmax]
    set ylabelpos [ny $labelpos $xmin $xmax]


    set item [$c create line [expr $pxmin-5] $ypos $pxmin $ypos -width 2]
    $c addtag axis withtag $item
    $c addtag $graph withtag $item

    set item [$c create text [expr $pxmin-10] $ylabelpos -text $ytext \
                   -anchor e -font     $plotFont]
    $c addtag axis withtag $item
    $c addtag $graph withtag $item

    if {$barchart==1} {
      set pos [expr $pos-1]
      set labelpos [expr $pos-0.5]
    } else {
      set pos [expr $pos-$layer($i)]
      set labelpos $pos
    }
  }


}



