# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# PROFILE PS animation
###################

proc profRecord {} {
global starttime endtime outd mf
global pwd time onefile rstart rend toolflag

set systemTime [clock seconds]
set filmdir [clock format $systemTime -format %Y-%m-%d]_[clock format $systemTime -format %H_%M]
if ![file exists $pwd/films] {exec \mkdir $pwd/films}
if ![file exists $pwd/films/$filmdir] {exec \mkdir $pwd/films/$filmdir}

set j 0
set lstart [expr int($rstart/$outd)]
set lend [expr int($rend/$outd)]

wm attributes . -topmost yes

textinfo "Frames are output to $pwd/films/$filmdir"

for {set k $lstart} {$k<=$lend} { incr k} {
   set filecounter [format "%8.8d" $j]
   set outfile $pwd/films/$filmdir/$toolflag\_$filecounter.png
   set time [expr $k*$outd]
   interpret
   update
   update idletasks
   image create photo img -format window -data $mf.left.plot
   img write $outfile -format png
   incr j
}
wm attributes . -topmost no

set path $pwd/films/$filmdir
textinfo "Computing film to $path/$toolflag\_$filmdir.mp4"
set command "/usr/bin/mencoder \"mf:\/\/$path\/*.png\" -mf fps=10 -o $path\/$toolflag\_$filmdir.mp4 -ovc x264 -quiet > /dev/null 2>&1"
catch [eval exec $command] result
textinfo "Ready"

}

