# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc textmean {j} {

global can
global starttime endtime outdelt year cycle timewin
global actstart
global pxmin pxmax pymin pyglobal
global singleresult command
global filename filelist
global gc
global ttt
global outwin outd
global line
global eformat digits

$ttt delete 1.0 end
set selectvar [lindex $command($j) 0]
set form 10
set sep 10

set signs [string length $selectvar]

switch $eformat {
 s  { set actformat "  %${signs}s"}
 g  { set actformat "  %${signs}.$digits$eformat"}
 f  { set actformat "  %${signs}.$digits$eformat"}
 e  { set actformat "  %${signs}.$digits$eformat"}
}


if {$j ==0} {
  append line(0)  "Time: $actstart(1) - [expr $actstart(1)+$timewin]"
  append line(1)  " "
  append line(2)  "File:        "
  append line(3)  " "
  append line(4)  "Statistics   "
  append line(5)  " "
  append line(6)  "Mean         "
  append line(7)  "Median       "
  append line(8)  "Min          "
  append line(9)  "Max          "
  append line(10) "Std.Dev.     "
  append line(11) "Delta        "
#  append line(12) "Delta% (mean)"
  append line(12) "Sum          "
  append line(13) "First-Last   "
}

# FILES
########
for {set a 1} {$a<=[lindex $filelist end]} {incr a} {
  if [info exists filename($a)] {

     set mini [lmin $singleresult($a,$selectvar)]
     set maxi [lmax $singleresult($a,$selectvar)]
     set mean [lmean $singleresult($a,$selectvar)]
     set medi [lmed $singleresult($a,$selectvar)]
     set stdv [lstd $singleresult($a,$selectvar)]
     set sum [lsum $singleresult($a,$selectvar)]
     set anfend [expr [lindex $singleresult($a,$selectvar) 0] - [lindex $singleresult($a,$selectvar) end]]
     set delta [expr abs($maxi-$mini)]
     if {$mean !=0.0} {
        set deltaproz [expr 1.0*$delta/$mean*100.0]
     } else {
        set deltaproz 0.0
     }

     set short [file rootname [file tail $filename($a)]]
     set sign [expr $sep+[max $signs [string length $short]]]
  
     append line(2)  [format "%${sign}s" $short]
     append line(4)  [format "%${sign}s" $selectvar]
     append line(6)  [format $actformat $mean]
     append line(7)  [format $actformat $medi]
     append line(8)  [format $actformat $mini]
     append line(9)  [format $actformat $maxi]
     append line(10) [format $actformat $stdv]
     append line(11) [format $actformat $delta]
#     append line(12) [format $actformat $deltaproz]
     append line(12) [format $actformat $sum]
     append line(13) [format $actformat $anfend]
   }
}

$ttt insert end $line(0)\n

   for {set i 1} {$i < 14} {incr i} {
        $ttt insert end $line($i)\n
   }

}




