# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc textplot {j} {

global can
global outdelt timewin
global actstart
global singleresult command
global filename filelist
global gc
global ttt
global outwin outd
global line
global eformat digits
global not_stored

set selectvar [lindex $command($j) 0]

if {$not_stored($selectvar)==1} {return}

$ttt delete 1.0 end
set form 10
set sep 3

set signs [expr $sep+[max [string length $selectvar] $form]]

switch $eformat {
 s  { set actformat "  %${signs}s"}
 g  { set actformat "  %${signs}.$digits$eformat"}
 f  { set actformat "  %${signs}.$digits$eformat"}
 e  { set actformat "  %${signs}.$digits$eformat"}
}

# HEAD
########

if {$j ==0} {
  append line(0) [format "%${form}s" "File"]
  append line(1) [format "%${form}s" "Time"]
}

set short [file rootname [file tail $filename(1)]]
set sign1 [expr $sep+[max $signs [string length $short]]]

append line(0) [format "%${sign1}s" $short]
append line(1) [format "%${sign1}s" $selectvar]

set datalen [expr [llength $singleresult(1,$selectvar)]]
set linenum 1


# FILE 1
########

#set increment [expr int($outd/$outdelt(1))]
set increment 1

for  {set i 0} {$i < $datalen} {set i [expr $i + $increment]} {
       incr linenum
       if {$j ==0} {
          set time [format $actformat [expr $actstart(1)+($i*$outd)]]
          append line($linenum) $time
       }

       set out  [format $actformat [lindex $singleresult(1,$selectvar) $i]]

       append line($linenum) $out
}

# FURTHER FILES
###############

for {set a 2} {$a<=[lindex $filelist end]} {incr a} {
  if [info exists filename($a)] {
     set short [file rootname [file tail $filename($a)]]
     set sign2 [expr $sep+[max $signs [string length $short]]]

     append line(0) [format "%*s" $sign2 $short]
     append line(1) [format "%*s" $sign2 $selectvar]

     set linenum [expr [llength $singleresult($a,$selectvar)] +1]

     for  {set i 2} {$i <=$linenum} {incr i} {
       scan [expr ($i-2)*$outd/$outdelt($a)] %d ind
       set out [format "%*s" $sign2 [format $actformat [lindex $singleresult($a,$selectvar) $ind]]]
       append line($i) $out
     }
   }
}


$ttt insert end $line(0)\n
$ttt insert end $line(1)\n

set linenum [expr int(0.5+$timewin/$outd)+2]

for {set i 2} {$i <= $linenum} {incr i} {
  # die letzte Zeile existiert nicht immer Rundungsfehler ?
  if [info exist line($i)] {
    $ttt insert end $line($i)\n
  }
#scan [expr $i + $outwin/$outd] %d off
}
}




